#*************************************************************************
#*
#*    $Workfile:$
#*
#*    Creation date     KR 28.06.99
#*    last change       $Author: armin $ $Date: 2001/03/05 16:56:57 $
#*
#*    $Revision: 1.2 $
#*
#*    $Logfile:$
#*
#*    Copyright 2000 Sun Microsystems, Inc. All Rights Reserved.
#*
#*************************************************************************

PRJ		= ..$/..$/..$/..
PRJNAME = xmlsearch
PACKAGE = com$/sun$/xmlsearch
TARGET  = com_sun_xmlsearch

# --- Settings -----------------------------------------------------

.INCLUDE : settings.mk

JARFILES 		=  jaxp.jar parser.jar xt.jar
EXTRAJARFILES 		=  jaxp.jar parser.jar xt.jar  

CLASSGENDIR		= $(OUT)$/classgen
RDB		 		= $(SOLARBINDIR)$/applicat.rdb
JAVAFILES		= $(subst,$(CLASSDIR)$/$(PACKAGE)$/, $(subst,.class,.java $(JAVACLASSFILES))) 

%.java:
	javamaker -BUCR -O$(OUT)$/misc$/java $(subst,$/,. $(subst,$(OUT)$/misc$/java$/,-T  $*)) $(RDB)

# --- Files --------------------------------------------------------

JAVACLASSFILES = \
	$(CLASSDIR)$/$(PACKAGE)$/db/Block.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/BlockFactory.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/BlockManager.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/BlockManagerParameters.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/BlockProcessor.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/BlockStack.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/BtreeDict.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/BtreeDictParameters.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/CompactEdgeFormat.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/DBPartParameters.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/EdgePrinter.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/EntryProcessor.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/FullBtreeDict.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/FullVectorBtree.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/Schema.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/VectorBtree.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/VectorBtreeIterator.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/VectorBtreeParameters.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/VectorFormat.class   \
	$(CLASSDIR)$/$(PACKAGE)$/db/VectorProcessor.class \
	$(CLASSDIR)$/$(PACKAGE)$/util/ExtensibleURLStreamHandlerFactory.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/BitBuffer.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/ByteArrayDecompressor.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/Compressor.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/CompressorIterator.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/ConceptList.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/ConceptLocation.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/Configuration.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/Decompressor.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/DocumentCompressor.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/Extent.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/Index.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/IndexAccessor.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/IndexInverter.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/IntegerArray.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/LineInput.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/Location.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/NonnegativeIntegerGenerator.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/PrefixTranslator.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/SimpleTokenizer.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/StreamDecompressor.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/Token.class     \
	$(CLASSDIR)$/$(PACKAGE)$/util/Tokenizer.class \
	$(CLASSDIR)$/$(PACKAGE)$/tree/Names.class     \
	$(CLASSDIR)$/$(PACKAGE)$/tree/Node2.class     \
	$(CLASSDIR)$/$(PACKAGE)$/tree/NodeFactory.class     \
	$(CLASSDIR)$/$(PACKAGE)$/tree/ResultAdapter.class     \
	$(CLASSDIR)$/$(PACKAGE)$/tree/TreeBuilder.class     \
	$(CLASSDIR)$/$(PACKAGE)$/tree/XmlTreeNode.class     \
	$(CLASSDIR)$/$(PACKAGE)$/tree/XmlTreeNodeImpl.class  \
	$(CLASSDIR)$/$(PACKAGE)$/qe/ConceptData.class     \
	$(CLASSDIR)$/$(PACKAGE)$/qe/ConceptGroupGenerator.class     \
	$(CLASSDIR)$/$(PACKAGE)$/qe/GeneratorHeap.class     \
	$(CLASSDIR)$/$(PACKAGE)$/qe/HitStore.class     \
	$(CLASSDIR)$/$(PACKAGE)$/qe/LiteMorph.class     \
	$(CLASSDIR)$/$(PACKAGE)$/qe/LiteMorph_en.class     \
	$(CLASSDIR)$/$(PACKAGE)$/qe/NextDocGenerator.class     \
	$(CLASSDIR)$/$(PACKAGE)$/qe/NextDocGeneratorHeap.class     \
	$(CLASSDIR)$/$(PACKAGE)$/qe/Query.class     \
	$(CLASSDIR)$/$(PACKAGE)$/qe/QueryHit.class     \
	$(CLASSDIR)$/$(PACKAGE)$/qe/RoleFiller.class     \
	$(CLASSDIR)$/$(PACKAGE)$/qe/Rule.class     \
	$(CLASSDIR)$/$(PACKAGE)$/qe/SearchEnvironment.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/ContextTables.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/XmlIndex.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/indexer/ElementIndexer.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/indexer/XmlIndexBuilder.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/indexer/XmlIndexer.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/indexer/XmlIndexingException.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/ConceptData.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/ConceptData1.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/ConceptData2.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/ConceptData3.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/ConceptData4.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/ConceptData5.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/ConceptData7.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/ConceptDataStart.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/ConceptDataStop.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/ConceptGroupGenerator.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/GeneratorHeap.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/HitStore.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/MultiTokenLocator.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/NextDocGenerator.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/NextDocGeneratorHeap.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/Query.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/QueryFactoryImpl.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/QueryHit.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/QueryHitData.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/QueryHitIterator.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/QueryProcessor.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/QueryProcessorImpl.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/QueryResults.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/QueryStatement.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/RoleFiller.class     \
	$(CLASSDIR)$/$(PACKAGE)$/xml/qe/Search.class

JARCLASSDIRS	= com
JARTARGET		= $(PRJNAME).jar
JARCOMPRESS 	= TRUE
CUSTOMMANIFESTFILE =


# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk




