/*************************************************************************
 *
 *  $RCSfile: PrefixTranslator.java,v $
 *
 *  $Revision: 1.1 $
 *
 *  last change: $Author: abi $ $Date: 2000/11/30 18:03:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

package com.sun.xmlsearch.util;

import java.util.Hashtable;
import java.util.Enumeration;

public final class PrefixTranslator {
    private Hashtable _transTable = new Hashtable();
    private String[] _prefixArray = null;
  
    public static PrefixTranslator makePrefixTranslator(String[] table) {
	PrefixTranslator result = null;
	if (table != null && table.length > 0) {
	    result = new PrefixTranslator();
	    for (int i = 0; i < table.length; )
		result.addPrefixTranslation(table[i++], table[i++]);
	}
	return result;
    }

    public void addPrefixTranslation(String prefix, String replacement) {
	if (_transTable.get(prefix) != null)
	    System.err.println("prefix already known: " + prefix);
	_transTable.put(prefix, replacement);
	sortPrefixes();
    }

    public String translatePrefix(String input) {
	for (int i = 0; i < _prefixArray.length; i++)
	    if (input.startsWith(_prefixArray[i]))
		return (String)_transTable.get(_prefixArray[i]) +
		    input.substring(_prefixArray[i].length());
	return input;
    }

    private void sortPrefixes() {
	if (_transTable.size() > 0)
	    _prefixArray = new String[_transTable.size()];
	int k = 0;
	for (Enumeration keys = _transTable.keys(); keys.hasMoreElements(); )
	    _prefixArray[k++] = (String)keys.nextElement();
	for (int i = 0; i < k - 1; i++)
	    for (int j = i + 1; j < k; j++)
		if (_prefixArray[j].length() > _prefixArray[i].length()) {
		    String temp = _prefixArray[j];
		    _prefixArray[j] = _prefixArray[i];
		    _prefixArray[i] = temp;
		}
    }
}
