/*************************************************************************
 *
 *  $RCSfile: ConceptData2.java,v $
 *
 *  $Revision: 1.1 $
 *
 *  last change: $Author: abi $ $Date: 2000/11/30 18:03:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

package com.sun.xmlsearch.xml.qe;

import com.sun.xmlsearch.xml.ContextTables;

/** ConceptData2 is ConceptData that implements field searching
  with constrained parent type
 */
final class ConceptData2 extends ConceptData {
    private final int _fieldCode;
    private final int _parentCode;
  
    public ConceptData2(int id, int role, double score, int queryNo,
			int nColumns, ContextTables ctxInfo,
			int code, int parentCode) {
	super(id, role, score, queryNo, nColumns, ctxInfo);
	_fieldCode = code;
	_parentCode = parentCode;
    }
  
    public void generateFillers(RoleFiller[] array, final int pos) {
	if (array[_queryNo] != RoleFiller.STOP) {// not 'prohibited'
	    int ancestor = _ctx.firstParentWithCode2(pos,
						     _fieldCode,
						     _parentCode);
	    if (ancestor != -1)
		(new RoleFiller(_nColumns,
				this,
				_role,
				pos,
				ancestor,
				pos + _proximity)).use(array, _queryNo);
	}
	if (_next != null)
	    _next.generateFillers(array, pos);
    }
}
