/*************************************************************************
 *
 *  $RCSfile: treeiterators.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: jb $ $Date: 2001/06/20 20:35:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <stdio.h>
#ifndef CONFIGMGR_TREEITERATORS_HXX_
#include "treeiterators.hxx"
#endif
#ifndef CONFIGMGR_CONFIGNAME_HXX_
#include "configpath.hxx"
#endif
#include "valueref.hxx"

// .......................................................................
namespace configmgr
{
// .......................................................................

	// ===================================================================
	// = CollectNodeNames
	// ===================================================================
	// -------------------------------------------------------------------
	CollectNodeNames::Result CollectNodeNames::handle(configuration::Tree const& aTree, configuration::NodeRef const& aNode)
	{
		m_aList.push_back(aTree.getName(aNode).toString());
		return CONTINUE;
	}

	// -------------------------------------------------------------------
	CollectNodeNames::Result CollectNodeNames::handle(configuration::Tree const& aTree, configuration::ValueRef const& aNode)
	{
		m_aList.push_back(aTree.getName(aNode).toString());
		return CONTINUE;
	}

// .......................................................................
}	// namespace configmgr
// .......................................................................

/*************************************************************************
 * history:
 *	$Log: treeiterators.cxx,v $
 *	Revision 1.3  2001/06/20 20:35:06  jb
 *	#88036# Adjusted to NodeVisitor change
 *	
 *	Revision 1.2  2000/11/23 13:46:01  dg
 *	#79258# missing include
 *	
 *	Revision 1.1  2000/11/21 19:22:41  fs
 *	initial checkin - commonly used tree iterators
 *	
 *
 *	Revision 1.0 21.11.00 17:21:27  fs
 ************************************************************************/

