/*************************************************************************
 *
 *  $RCSfile: localsession.cxx,v $
 *
 *  $Revision: 1.65 $
 *
 *  last change: $Author: lla $ $Date: 2001/08/01 12:16:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdio.h>

#include "localsession.hxx"

#ifndef _CONFIGMGR_OSLSTREAM_HXX_
#include "oslstream.hxx"
#endif
#ifndef INCLUDED_CONFIGMGR_MERGECHANGE_HXX
#include "mergechange.hxx"
#endif
#ifndef _CONFIGMGR_XMLTREEBUILDER_HXX
#include "xmltreebuilder.hxx"
#endif
#ifndef _CONFIGMGR_SAXTOOLS_HXX_
#include "saxtools.hxx"
#endif
#ifndef _CONFIGMGR_XML_TREEUPDATE_HXX_
#include "treeupdate.hxx"
#endif
#ifndef _CONFIGMGR_FILEHELPER_HXX_
#include "filehelper.hxx"
#endif
#ifndef CONFIGMGR_MISC_OPTIONS_HXX_
#include "options.hxx"
#endif
#ifndef _CONFIGMGR_XML_UPDATETREE_HXX_
#include "updatetree.hxx"
#endif
#ifndef _CONFIGMGR_TREEACTIONS_HXX_
#include "treeactions.hxx"
#endif
#ifndef CONFIGMGR_XMLFORMATER_HXX
#include "xmlformater.hxx"
#endif
#ifndef CONFIGMGR_NAMEHELPER_HXX
#include "namehelper.hxx"
#endif
#ifndef CONFIGMGR_ATTRIBUTEPARSER_HXX
#include "attributeparser.hxx"
#endif
#ifndef CONFIGMGR_BINARYHANDLER_HXX
#include "writesubtreeasbinaryhandler.hxx"
#endif
#ifndef CONFIGMGR_BINARYWRITEHANDLER_HXX_
#include "binarywritehandler.hxx"
#endif
#ifndef CONFIGMGR_BINARYREADER_HXX
#include "binaryreader.hxx"
#endif
#ifndef CONFIGMGR_BINARYDECIDE_HXX_
#include "binarydecide.hxx"
#endif
#ifndef CONFIGMGR_PARSERCONTEXT_HXX
#include "parsercontext.hxx"
#endif
#ifndef CONFIGMGR_GENERATECACHE_HXX
#include "generatecache.hxx"
#endif

#ifndef _CONFIGMGR_TRACER_HXX_
#include "tracer.hxx"
#endif

#ifndef _COM_SUN_STAR_XML_SAX_XDOCUMENTHANDLER_HPP_
#include <com/sun/star/xml/sax/XDocumentHandler.hpp>
#endif
#ifndef _COM_SUN_STAR_XML_SAX_INPUTSOURCE_HPP_
#include <com/sun/star/xml/sax/InputSource.hpp>
#endif
#ifndef _COM_SUN_STAR_XML_SAX_SAXPARSEEXCEPTION_HPP_
#include<com/sun/star/xml/sax/SAXParseException.hpp>
#endif

#ifndef _RTL_LOGFILE_HXX_
#include <rtl/logfile.hxx>
#endif

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::xml;
using namespace ::com::sun::star::xml::sax;
using namespace ::com::sun::star::io;
using namespace ::vos;
using namespace ::std;
using namespace ::osl;
using namespace ::rtl;

#define ASCII(x) rtl::OUString::createFromAscii(x)

/*
#define ENTER()	\
	::osl::MutexGuard aGuard(m_aMutex);	\
	m_eError = E_None;

#define ENTER_FULL_CHECK(methodname, handler)	\
	::osl::MutexGuard aGuard(m_aMutex);	\
	m_eError = E_None;	
*/

#define RTL_LOGFILE_OU2A(rtlOUString)	(::rtl::OString((rtlOUString).getStr(), (rtlOUString).getLength(), RTL_TEXTENCODING_ASCII_US).getStr())

namespace configmgr 
{
    using namespace configuration;

	static const OUString sInstanceDirectoryName = ASCII("instance");
	static const OUString sTemplateDirectoryName = ASCII("template");

// -----------------------------------------------------------------------------

	namespace 
	{
		struct DocumentBuilder
		{
			typedef Reference< sax::XParser > ParserRef;
			typedef Reference< sax::XDocumentHandler > HandlerRef;

			ParserRef xParser;
	
			DocumentBuilder(ParserRef const& xParser_, HandlerRef const& xHandler_)
			: xParser(xParser_)
			{
				xParser->setDocumentHandler(xHandler_);
			}
			~DocumentBuilder()
			{
				xParser->setDocumentHandler(NULL);
			}

			void parseStream( sax::InputSource const& aInputSource )
				throw (sax::SAXException, RuntimeException)
			{
				xParser->parseStream(aInputSource);
			}
		};
	}
// -----------------------------------------------------------------------------
	
	LocalSession::LocalSession(const Reference< XMultiServiceFactory >& _rxServiceProvider)
			: m_eError(E_None), m_xServiceProvider(_rxServiceProvider),m_bIsSetup(false),
			  m_bWriteToShare(true),
			  m_bRecreateBinary(false)
	{
		// create the writer and the parser we want to use

		// create empty Objects
		m_xParser = Reference< sax::XParser >(_rxServiceProvider->createInstance(
			::rtl::OUString::createFromAscii("com.sun.star.xml.sax.Parser")),
											  UNO_QUERY);

		if (!m_xParser.is())
		{
			OSL_ENSURE(sal_False, "LocalSession::LocalSession : no or invalid SAX XML Parser !");
			m_eError = E_Invalid;
			return;
		}
	}

	// -----------------------------------------------------------------------------

	void LocalSession::setFilter(rtl::OUString const& _aModuleName)
	{
		// PRE: a ModuleName something like org.openoffice.X.Y

		m_aFilterVector.clear();
//		if (m_aSharePath.isNewFileStructure())
//			m_aFilterVector.push_back(NameHelper::getModuleNameWithoutPackageName(_aModuleName));
//		else
			m_aFilterVector.push_back(_aModuleName);
	}
	
	// -----------------------------------------------------------------------------
	void LocalSession::prepareFilter(const AbsolutePath &_rPath)
	{
		// cut down name in Modulename and an vector of Path Names

        // org.openoffice.XXX
		OUString aModuleName = _rPath.getModuleName().toString();
		setFilter(aModuleName);

 		AbsolutePath::Iterator it = _rPath.begin();
 		if (it != _rPath.end())
 		{
 			for( ++it; it != _rPath.end() ; ++it)
 			{
 				m_aFilterVector.push_back(it->getName().toString());
 			}
 		}
	}
	
// -----------------------------------------------------------------------------
	static inline OUString makeString(sal_Unicode const ch)
	{
		return OUString(&ch, 1);
	}
// -----------------------------------------------------------------------------
	void LocalSession::setSetupMode(bool _bRecreateBinary)
	{
		m_bIsSetup = true;
		m_bRecreateBinary = _bRecreateBinary;
	}

	sal_Bool LocalSession::open(const ::rtl::OUString& _rShareURLPath, const ::rtl::OUString& _rUserURLPath)
	{
		// try to open the directory instance
		// if this failed, we MUST use the old filestructure


		// rtl::OUString sShareURLPath = FileHelper::convertFilenameToFileURL(_rShareURLPath);
		m_aSharePath.setPath(_rShareURLPath);
		m_aSharePath.setInstance(sInstanceDirectoryName);
		// m_aSharePath.setNewFilestructure(true);


		if (_rUserURLPath.getLength() > 0)			 // SetupSession
		{
			// rtl::OUString sUserURLPath = FileHelper::convertFilenameToFileURL(_rUserURLPath);
			m_aUserPath.setPath(_rUserURLPath);
			m_aUserPath.setNewFileStructure(m_aSharePath.isNewFileStructure());
			m_aUserPath.setInstance(sInstanceDirectoryName);
		}
		
		return true;
	}
	
	void LocalSession::close()
	{
		if (m_bRecreateBinary)
		{
			m_bRecreateBinary = false;
			OGenerateCache aGenerate(m_aSharePath.createDirectory(), m_aSharePath.createBinaryDirectory(), this);
		}
	}
	
	sal_Bool LocalSession::isOpen()
	{
		bool nRet = false;
		if (m_aSharePath.createFileURL().getLength() > 0 && m_aUserPath.createFileURL().getLength() > 0)
			nRet = true;
		return nRet;
	}

// ----------------------------- ISynchronizedData -----------------------------
	//--------------------------------------------------------------------------
	ITreeProvider* LocalSession::asITreeProvider() {return this;}
	ITreeProvider const* LocalSession::asITreeProvider() const {return this;}
	ITemplateProvider* LocalSession::asITemplateProvider() {return this;}

	// -----------------------------------------------------------------------------

	std::auto_ptr<INode> LocalSession::requestTemplateInstance(
        Name const& aName, Name const& _rModule, 
        const vos::ORef < OOptions >& _xOptions) throw (uno::Exception)
	{
		::osl::MutexGuard aGuard(m_aMutex);		 // #87880# wait if other thread works

		m_aSharePath.setInstance(sTemplateDirectoryName); // Templates only in share

        AbsolutePath aModulePath = AbsolutePath::makeModulePath(_rModule, AbsolutePath::NoValidate());
		if (!m_aSharePath.isNewFileStructure())
		{
            configuration::Path::Component aModuleComp = aModulePath.getLocalName();

            static const OUString sTemplateBase = ASCII("org.openoffice.Templates");
            aModulePath = AbsolutePath::makeModulePath(sTemplateBase,Name::NoValidate()).compose(aModuleComp);
		}

		std::auto_ptr<ISubtree> pIRootSubtree = requestSubtreeOrTemplate(aModulePath, _xOptions, ALL_LEVELS, ShouldWriteBinary::NO);
		std::auto_ptr<INode> pResult;
		if (pIRootSubtree.get())
		{
			if (aName.isEmpty())
			{
				pResult.reset( pIRootSubtree.release() );
			}
			else
			{
				pResult = pIRootSubtree->removeChild( aName.toString() );
			}
		}
		return pResult;
	}

// -----------------------------------------------------------------------------

	std::auto_ptr<ISubtree> LocalSession::loadSubtree( AbsolutePath const& _aSubtreePath, const vos::ORef<OOptions>& _rOptions, sal_Int16 _nMinLevels)
		throw (uno::Exception)
	{
		::osl::MutexGuard aGuard(m_aMutex);		 // #87880# wait if other thread works

		RTL_LOGFILE_CONTEXT_AUTHOR(aLog, "configmgr::LocalSession", "ll93751", "loadSubtree()");
		RTL_LOGFILE_CONTEXT_TRACE1(aLog, "%s", RTL_LOGFILE_OU2A(_aSubtreePath.getModuleName().toString()) );

		m_aUserPath.setInstance(sInstanceDirectoryName);
		m_aSharePath.setInstance(sInstanceDirectoryName);

		OUString sModuleName = _aSubtreePath.getModuleName().toString();

		m_aSharePath.setModule(sModuleName);
		m_aUserPath.setModule(sModuleName);

		CFG_TRACE_INFO("local session::requestSubtree() start %s", OUSTRING2ASCII(_aSubtreePath.toString()));
		::std::auto_ptr<ISubtree> pSubtree = requestSubtreeOrTemplate(_aSubtreePath, _rOptions, _nMinLevels, ShouldWriteBinary::YES);
		CFG_TRACE_INFO_NI("local session::requestSubtree() stop");
		
		return pSubtree;
	}
	
// -----------------------------------------------------------------------------
	void apply(TreeChangeList & _aTreeChangeList, ISubtree& _aSubtree)
	{
		// coarse: _aSubtree = _aSubtree + _aSubtreeChange;

		TreeUpdate aTreeUpdate(&_aSubtree);
		// ISubtree *pAll = 
		
		// pSubtree = pSubtree + aChangeList
		TreeChangeList aMergeChangeList(_aTreeChangeList, SubtreeChange::NoChildCopy());
		
		OMergeTreeAction aChangeHandler(aMergeChangeList.root, &_aSubtree);
		_aTreeChangeList.root.forEachChange(aChangeHandler);
		
		// now check the real modifications
		OChangeActionCounter aChangeCounter;
		aChangeCounter.handle(aMergeChangeList.root);
		CFG_TRACE_INFO_NI("cache manager: counted changes from notification : additions: %i , removes: %i, value changes: %i", aChangeCounter.nAdds, aChangeCounter.nRemoves, aChangeCounter.nValues);
		if (aChangeCounter.hasChanges())
		{
			// aTree.updateTree(aMergeChangeList);
			aMergeChangeList.root.forEachChange(aTreeUpdate);
		}
	}
	
// -----------------------------------------------------------------------------
// 0 : load if possible bin otherwise xml
// 1 : load xml, create bin
// 2 : load xml only

#ifndef LOAD_XML_ONLY
#define LOAD_XML_ONLY 0
#endif

	std::auto_ptr<ISubtree> LocalSession::LoadShareAsSubtree(AbsolutePath const& _aSubtreePath, const vos::ORef<OOptions>& _rOptions, ShouldWriteBinary::Enum _eMode) throw (uno::Exception)
	{
		bool bLoadBinary = false;

		OUString sModuleName = _aSubtreePath.getModuleName().toString();
		CFG_TRACE_INFO("LoadShareAsSubtree %s", OUSTRING2ASCII(sModuleName));

		OUString aFileURL;
		if (!m_bRecreateBinary)
		{
			OFileTimeStampDecision aDecide(m_aSharePath);
			aFileURL = aDecide.getFileURL();
			if (aDecide.getFileType() == ODecideContext::BINARY_FILE)
			{	
#if LOAD_XML_ONLY
				bLoadBinary = false;
#else
				bLoadBinary = true; // this will prevent to load binaries
#endif
			}
		}

		// some binary files can't load today, it should be a bug
		if (bLoadBinary )
		{
			// load stuff in binary form
			CFG_TRACE_INFO_NI("load file from binary source %s", OUSTRING2ASCII(sModuleName));
			std::auto_ptr<ISubtree> pNew;
			try
			{
				pNew = read(_aSubtreePath, aFileURL, m_xServiceProvider, _rOptions->getLocale());
			}
			catch (io::IOException &e)
			{
				CFG_TRACE_ERROR_NI("LoadShareAsSubtree: problem with binary file read(): %s", OUSTRING2ASCII(e.Message));
				OSL_ENSURE(false, "LoadShareAsSubtree: problem with binary file read(), try fallback, read XML");
				pNew = LoadShareAsXMLAsSubtree(_aSubtreePath, _rOptions, _eMode);
			}
			return pNew;
		}
		else
		{
			// load stuff in xml form
			CFG_TRACE_INFO("load file from xml source %s", OUSTRING2ASCII(sModuleName));
#if LOAD_XML_ONLY > 1
			std::auto_ptr<ISubtree> pSubtree = LoadShareAsXMLAsSubtree(_aSubtreePath, _rOptions, ShouldWriteBinary::NO);
#else
			std::auto_ptr<ISubtree> pSubtree = LoadShareAsXMLAsSubtree(_aSubtreePath, _rOptions, _eMode);
#endif
			return pSubtree;
		}
	}
	
// -----------------------------------------------------------------------------
	
	std::auto_ptr<ISubtree> LocalSession::LoadShareAsXMLAsSubtree(AbsolutePath const& _aSubtreePath, const vos::ORef<OOptions>& _rOptions, ShouldWriteBinary::Enum _eMode) throw (uno::Exception)
	{
		
		OUString sModuleName = _aSubtreePath.getModuleName().toString();
		CFG_TRACE_INFO("LoadShareAsXMLAsSubtree %s", OUSTRING2ASCII(sModuleName));

		XMLTreeBuilder *pBuilder = new XMLTreeBuilder(sModuleName, _rOptions);

		OUString aShareURL = m_aSharePath.createFileURL();
		Reference< sax::XDocumentHandler > xWriter = pBuilder;
		
		LoadFromFile(aShareURL, xWriter, pBuilder->getParserContext(), m_aFilterVector, m_aSharePath.createBinaryFileURL(), _eMode);

		return pBuilder->getResultTree();
	}
	
	// -----------------------------------------------------------------------------
	void LocalSession::LoadFromFile(
		rtl::OUString const& _aShareURL, uno::Reference< sax::XDocumentHandler > const& _xWriter,
		ParserContext & _aParserContext, std::vector<rtl::OUString> const& _aFilterVector,
		rtl::OUString const& _sBinaryFileURL,
		ShouldWriteBinary::Enum _eMode) throw(uno::Exception)
	{
		CFG_TRACE_INFO_NI("local session: try to open the share file (%s) and create a Tree", OUSTRING2ASCII(_aShareURL));
		// ------------- open file -------------

		rtl::OUString sError;

		File aFile(_aShareURL);
		FileBase::RC eError = aFile.open(OpenFlag_Read);
		if (eError != osl_File_E_None)
		{
			CFG_TRACE_WARNING_NI("local session: could not open file: (%s)", OUSTRING2ASCII(_aShareURL));
			::rtl::OUString aStr(ASCII("Local Loader: Can't open URL: "));
			aStr += _aShareURL;
			sError = aStr;
			return;
		}

		try
		{
			// ------------- sax read --------------
			
			// connect stream to input stream to the parser
			InputSource aInputSource;		
			aInputSource.aInputStream =  new configmgr::OSLInputStreamWrapper(aFile);
			
			// create the writer and the parser we want to use		
			Reference<XDocumentHandler> xFilter(new OSelectHandler(_xWriter, _aFilterVector, _aParserContext.aAttributeParser ));
			
			if ((_eMode == ShouldWriteBinary::YES) && !m_bRecreateBinary)
			{
				// create the binary writer
				// if write to share is wished (default: true)
				// create a binaryWriteHandler, if it fails, newer create a binary handler again.
				if (m_bWriteToShare)
				try
				{
					// check directory structure
					m_aSharePath.checkDirectory(PathHelper::convertFilenameToDirectory(_sBinaryFileURL));
					// create binary file
					Reference<XDocumentHandler> xBinaryWriter(
						new OWriteSubtreeAsBinaryHandler(xFilter, _sBinaryFileURL,
														 m_xServiceProvider, _aParserContext));
					
					xFilter = xBinaryWriter;
				}
				catch (io::IOException & e)
				{
                    CFG_TRACE_WARNING("Cannot write binary files at share directory: %s", OUSTRING2ASCII(e.Message));
					m_bWriteToShare = false;
				}
			}
			// connect parser and filter
			DocumentBuilder aSaxBuilder( m_xParser, xFilter );
			
			aSaxBuilder.parseStream( aInputSource );
		}
		catch( SAXParseException &e )
		{
			OUString sLine = OUString::valueOf(e.LineNumber);
			OUString aStr = ASCII("SAXParseException occured in ");
			sError = aStr + ASCII(" Line: (") + sLine + ASCII(") in file url: ");
			sError += _aShareURL;
			OSL_ENSURE(0, rtl::OUStringToOString(sError,RTL_TEXTENCODING_ASCII_US).getStr());
			CFG_TRACE_WARNING_NI("SAXParseException occured in Line (%s) in file url: %s", OUSTRING2ASCII(sLine), OUSTRING2ASCII(_aShareURL));
			throw;
		}
		catch( SAXException &e )
		{
			sError = e.Message;
			OSL_ENSURE(0, rtl::OUStringToOString(sError,RTL_TEXTENCODING_ASCII_US).getStr());
			throw;
		}
		catch( IOException &e )
		{
			sError = e.Message;
			OSL_ENSURE(0, rtl::OUStringToOString(sError,RTL_TEXTENCODING_ASCII_US).getStr());
			throw;
		}
		aFile.close();
	}

// -----------------------------------------------------------------------------
	bool LocalSession::LoadUserAsSubtreeChange(TreeChangeList &_aChangeList, rtl::OUString const& _aModuleName) throw (uno::Exception)
	{
		// PRE: an initialised TreeChangeList, a ModuleName
		// BACK: true, if ChangeList was loaded.


		CFG_TRACE_INFO("LoadUserAsSubtreeChange: Load XML as SubtreeChange");

		// ------------- open file -------------
		m_aUserPath.setModule(_aModuleName);
		OUString aUserURL = m_aUserPath.createFileURL();
		
		
		File aFile(aUserURL);
		FileBase::RC eError = aFile.open(OpenFlag_Read);
		if (eError != osl_File_E_None)
		{
			CFG_TRACE_INFO_NI("local session: there is no user override file (%s)", OUSTRING2ASCII(aUserURL));
			return false;
		}

		rtl::OUString sError;
		try
		{
			// ------------- sax read --------------
			// create the writer and the parser we want to use
			XMLTreeChangeListBuilder *pChangeBuilder = new XMLTreeChangeListBuilder(_aChangeList);
			Reference< sax::XDocumentHandler > xChangeWriter = pChangeBuilder;
			
			// connect stream to input stream to the parser
			InputSource aInputSource;		
			aInputSource.aInputStream =  new configmgr::OSLInputStreamWrapper(aFile);
			
			
			// get filter
			Reference<XDocumentHandler> xFilter(new OSelectHandler(xChangeWriter, m_aFilterVector,
																   pChangeBuilder->getAttributeHandler()));	
			
			// connect parser and filter
			DocumentBuilder aSaxBuilder( m_xParser, xFilter );
			
			aSaxBuilder.parseStream( aInputSource );
		}
		catch( SAXParseException &e )
		{
			OUString sLine = OUString::valueOf(e.LineNumber);
			OUString aStr = ASCII("SAXParseException occured in ");
			sError = aStr + ASCII(" Line: (") + sLine + ASCII(") in file url: ");
			sError += aUserURL;
			OSL_ENSURE(0, rtl::OUStringToOString(sError,RTL_TEXTENCODING_ASCII_US).getStr());
			CFG_TRACE_WARNING_NI("SAXParseException occured in Line (%s) in file url: %s", OUSTRING2ASCII(sLine), OUSTRING2ASCII(aUserURL));
			// nRet = 3;
			throw;
			//	bNoMerge = true;
		}
		catch( SAXException &e )
		{
			sError = e.Message;
			OSL_ENSURE(0, rtl::OUStringToOString(sError,RTL_TEXTENCODING_ASCII_US).getStr());
			// nRet = 4;
			throw;
			//	bNoMerge = true;
		}
		catch( IOException &e )
		{
			sError = e.Message;
			OSL_ENSURE(0, rtl::OUStringToOString(sError,RTL_TEXTENCODING_ASCII_US).getStr());
			// nRet = 5;
			throw;
			//	bNoMerge = true;
		}
		
		aFile.close();

		return true; // file loaded
	}

	// -----------------------------------------------------------------------------

	std::auto_ptr<ISubtree> LocalSession::requestSubtreeOrTemplate( AbsolutePath const& _aSubtreePath, const vos::ORef<OOptions>& _rOptions, sal_Int16 nMinLevels, ShouldWriteBinary::Enum _eMode)
		throw (uno::Exception)
	{
		// PRE: the requested Value is not in the cache
		// POST: open the share file as TreeChangeList
		//       if exist, open the user file,
		//       Merge both TreeChangeLists together
		// Handle correct Modulename

		rtl::OUString sError;
		sal_Int32 nRet = 0;

		prepareFilter(_aSubtreePath);

        OUString aModuleName(_aSubtreePath.getModuleName().toString());

		m_aSharePath.setModule(aModuleName);
		// -------------------------------------

		RTL_LOGFILE_CONTEXT_AUTHOR(aLog, "configmgr::LocalSession", "ll93751", "requestSubtreeOrTemplate()");
		RTL_LOGFILE_CONTEXT_TRACE1(aLog, "modulename: %s ", RTL_LOGFILE_OU2A(_aSubtreePath.toString()));
		std::auto_ptr<ISubtree> pSubtree = LoadShareAsSubtree(_aSubtreePath, _rOptions, _eMode);
		
		// Special Test
		
		bool bNoMerge = (m_aSharePath.createFileURL().equals(m_aUserPath.createFileURL())) || /* Share and User path are equal, so Userfile must not load */ 
			m_bIsSetup ;						/* SetupMode is set, only Sharefile is to read */

		if (!bNoMerge)
		{
			CFG_TRACE_INFO_NI("local session: opened the user override file (%s) and create a TreeChangeList", OUSTRING2ASCII(m_aUserPath.createFileURL()));
			
			// Create a TreeChangeList with the right name, parentname and ConfigurationProperties
			TreeChangeList aChangeList(_rOptions, _aSubtreePath, Chg());

			RTL_LOGFILE_CONTEXT_TRACE(aLog, " load user as subtreechange");
			bool bLoaded = LoadUserAsSubtreeChange(aChangeList, aModuleName);
			if ( bLoaded )
			{
				// if we didn't found anything in share, but in the user file (set template)
				// we need a dummy tree
				RTL_LOGFILE_CONTEXT_TRACE(aLog, "subtree += subtreechange");
			
				if (pSubtree.get() == NULL)
				{
                    OTreeNodeFactory aNodeFactory;
                    pSubtree = ONodeConverter::createCorrespondingNode( aChangeList.root, aNodeFactory);
				}
				// pSubtree = pSubtree + aChangeList
				apply(aChangeList, *pSubtree);
			}
		}

		if (pSubtree.get())
		{
			static const OUString aDummyId(RTL_CONSTASCII_USTRINGPARAM("Generated by local session"));
			OIdPropagator::propagateIdToTree(aDummyId, *pSubtree);
		}
		return pSubtree;
	}

	// -----------------------------------------------------------------------------

	void LocalSession::updateTree(TreeChangeList& _aChanges)
		throw (uno::Exception)
	{
		::osl::MutexGuard aGuard(m_aMutex);		 // #87880# wait if other thread works

		RTL_LOGFILE_CONTEXT_AUTHOR(aLog, "configmgr::LocalSession", "ll93751", "updateTree()");

		m_aUserPath.setInstance(sInstanceDirectoryName);
		m_aSharePath.setInstance(sInstanceDirectoryName);

		// Handle correct Modulename
		AbsolutePath aPathIncludingRoot = _aChanges.getRootNodePath();
		prepareFilter(aPathIncludingRoot);

		RTL_LOGFILE_CONTEXT_TRACE1(aLog, " path %s", RTL_LOGFILE_OU2A(aPathIncludingRoot.toString()));
		Name aModuleName = aPathIncludingRoot.getModuleName();

		// m_aTree.updateTree(aChanges);
		rtl::OUString sError;
		rtl::OUString aFromURL;
		rtl::OUString aToURL;

		sal_Int32 nRet = 0;
		if (m_bIsSetup)
		{
			//! OLD Methode

			m_aSharePath.setModule(aModuleName.toString());
			aFromURL = m_aSharePath.createFileURL();

			aToURL   = m_aSharePath.createFileUpdateURL();
			
			nRet = configmgr::updatetree::doUpdateTree(
				aFromURL, aToURL, _aChanges, m_xServiceProvider,
				_aChanges.getOptions(), sError);
		}
		else
		{
			// The New Methode loads the userFileURL as a TreeChangeList
			// merges the present TreeChangeList in the FileVersion
			// and store this to the UserFile.

			m_aUserPath.setModule(aModuleName.toString());
			aFromURL = m_aUserPath.createFileURL();

			aToURL   = m_aUserPath.createFileUpdateURL();
			m_aUserPath.checkDirectory(PathHelper::convertFilenameToDirectory(aToURL));
			nRet = doUpdateTree(aFromURL, aToURL, aModuleName, _aChanges, _aChanges.getOptions(), sError);
		}
		
		// we now put an exception
		// if (nRet != 0)
		// {
		// 	   // create a wrappedTargetException
		// 	   throw lang::WrappedTargetException(sError, NULL, Any());
		// }
	}
	
	
// --------------------------------- OSelectHandler::Selector ---------------------------------
	OSelectHandler::Selector::Selector(const std::vector< rtl::OUString > &aFilterVector)
	: m_aTarget(aFilterVector)
	{
		reset();
	}
// -----------------------------------------------------------------------------
	OSelectHandler::Selector::Action OSelectHandler::Selector::start(OUString const& aName)
	{
		switch (m_eState)
		{
		case SEARCHING_DATA:
			OSL_ASSERT(m_nHandleDepth == 0);
			OSL_ASSERT(m_nSearchDepth < m_aTarget.size());
			if (aName != m_aTarget[m_nSearchDepth])
			{
				// mismatch - must ignore now
				m_eState		= IGNORING_DATA;
				++m_nHandleDepth;
				return IGNORE;
			}
			else if (++m_nSearchDepth == m_aTarget.size())
			{
				// found it
				m_eState		= HANDLING_DATA;
				++m_nHandleDepth;
				OSL_DEBUG_ONLY(--m_nSearchDepth);
				return START_HANDLING;
			}
			else 
			{
				// keep searching 
				return IGNORE;
			}
			
		case HANDLING_DATA:
			++m_nHandleDepth;
			return KEEP_HANDLING;

		case IGNORING_DATA:
			++m_nHandleDepth;
			return IGNORE;

		default: OSL_ASSERT(false);
		case DONE:
			OSL_DEBUG_ONLY(++m_nHandleDepth);
			return IGNORE;
		}
	}

// -----------------------------------------------------------------------------
	OSelectHandler::Selector::Action OSelectHandler::Selector::end()
	{
		switch (m_eState)
		{
		case SEARCHING_DATA:
			OSL_ASSERT(m_nHandleDepth == 0);
			OSL_ASSERT(m_nSearchDepth > 0);
			--m_nSearchDepth;
			return IGNORE;

		case HANDLING_DATA:
			OSL_ASSERT(m_nHandleDepth > 0);
			if (--m_nHandleDepth == 0)
			{
				m_eState = DONE;
				return END_HANDLING;
			}
			return KEEP_HANDLING;

		case IGNORING_DATA:
			OSL_ASSERT(m_nHandleDepth > 0);
			if (--m_nHandleDepth == 0)
			{
				m_eState = SEARCHING_DATA;
			}
			return IGNORE;

		default: OSL_ASSERT(false);
		case DONE:
			OSL_ASSERT(0 < (m_nHandleDepth ? m_nHandleDepth : m_nSearchDepth)); 
			OSL_DEBUG_ONLY( --(m_nHandleDepth ? m_nHandleDepth : m_nSearchDepth)); 
			return IGNORE;
		}
	}

// -----------------------------------------------------------------------------
	void OSelectHandler::Selector::reset()
	{
		if ( m_aTarget.empty() )
		{
			m_eState = HANDLING_DATA;
		}
		else
		{
			m_eState = SEARCHING_DATA;
		}
		m_nHandleDepth = 0;
		m_nSearchDepth = 0;
	}
// -----------------------------------------------------------------------------
// ------------------------------- OSelectHandler -------------------------------
// -----------------------------------------------------------------------------

	OSelectHandler::OSelectHandler( const uno::Reference< sax::XDocumentHandler > &xWriter,
									  const std::vector<rtl::OUString> &aFilterVector,
									  OAttributeParser& rParser)
	: m_aSelector(aFilterVector)
	, m_rParser(rParser)
	, m_xHandler(xWriter)
	{
	}

// -----------------------------------------------------------------------------
	rtl::OUString OSelectHandler::getSelectName(const rtl::OUString& aName,
									const uno::Reference< sax::XAttributeList > &xAttribs)
	{
		return m_rParser.getNodeName(aName,xAttribs);
	}
// -----------------------------------------------------------------------------

	void OSelectHandler::startDocument(void)
		throw (sax::SAXException, uno::RuntimeException)
	{
		m_aSelector.reset();
		if (m_aSelector.isHandling())
			m_xHandler->startDocument();
	}

// -----------------------------------------------------------------------------
	
	void OSelectHandler::endDocument(void)
		throw(sax::SAXException, uno::RuntimeException)
	{
		OSL_ENSURE(!m_aSelector.isHandling(),"Empty document for empty target path ?");
		if (m_aSelector.isHandling())
		{
			m_xHandler->endDocument();
			m_aSelector.reset();
		}
	}
	
// -----------------------------------------------------------------------------

	void OSelectHandler::startElement(const OUString& aName,
										const uno::Reference< sax::XAttributeList > &xAttrList)
		throw(sax::SAXException, uno::RuntimeException)
	{
		switch( m_aSelector.start( getSelectName(aName,xAttrList) ) )
		{
		case Selector::START_HANDLING:
			m_xHandler->startDocument();
			m_xHandler->startElement(aName, xAttrList);
			break;

		case Selector::KEEP_HANDLING:
			m_xHandler->startElement(aName, xAttrList);
			break;

		default: OSL_ASSERT(false);

		case Selector::IGNORE:
			break;
		}
	}
// -----------------------------------------------------------------------------
	
	void OSelectHandler::endElement(const OUString& aName)
		throw(sax::SAXException, uno::RuntimeException)
	{
		switch( m_aSelector.end() )
		{
		case Selector::END_HANDLING:
			m_xHandler->endElement(aName);
			m_xHandler->endDocument();
			break;

		case Selector::KEEP_HANDLING:
			m_xHandler->endElement(aName);
			break;

		default: OSL_ASSERT(false);

		case Selector::IGNORE:
			break;
		}
	}
// -----------------------------------------------------------------------------
	
	void OSelectHandler::characters(const OUString& aChars)
		throw(sax::SAXException, uno::RuntimeException)
	{
		if (m_aSelector.isHandling())
			m_xHandler->characters(aChars);
	}
// -----------------------------------------------------------------------------
	
	
	void OSelectHandler::ignorableWhitespace(const OUString& aWhitespaces)
		throw(sax::SAXException, uno::RuntimeException)
	{
		if (m_aSelector.isHandling())
			m_xHandler->ignorableWhitespace(aWhitespaces);
	}
// -----------------------------------------------------------------------------

	void OSelectHandler::processingInstruction(const OUString& aTarget,
												  const OUString& aData)
		throw(sax::SAXException, uno::RuntimeException)
	{
		if (m_aSelector.isHandling())
			m_xHandler->processingInstruction(aTarget, aData);
	}
// -----------------------------------------------------------------------------
	
	void OSelectHandler::setDocumentLocator(const uno::Reference< sax::XLocator > &xLocator)
		throw(sax::SAXException, uno::RuntimeException)
	{
		// if (m_aSelector.isActive())
		m_xHandler->setDocumentLocator(xLocator);
	}


// -----------------------------------------------------------------------------

	// -----------------------------------------------------------------------------
#ifdef DEBUG
	class TraceTree : public ChangeTreeAction
	{
	public:
		// ChangeTreeAction
		virtual void handle(SubtreeChange const& aSubtree)
			{
				aSubtree.forEachChange(*this);
			}
		
		virtual void handle(ValueChange const& aValueNode)
			{
				volatile int dummy = 0;
			}
		
		virtual void handle(AddNode const& aAddNode)
			{
				volatile int dummy = 0;
			}
		
		virtual void handle(RemoveNode const& aRemoveNode)
			{
				volatile int dummy = 0;
			}		
	};
#endif
	sal_Int32 LocalSession::doUpdateTree(const rtl::OUString& _aFromURL,
										 const rtl::OUString& _aToURL,
										 const Name & _aModuleName,
										 TreeChangeList& _aChanges,
										 const vos::ORef < OOptions >& _rOptions,
										 /* OUT */ rtl::OUString &sError)
		throw (uno::Exception)
	{
		// create a ChangeList from the UserFile

#ifdef DEBUG
		TraceTree aTracer;
		aTracer.handle(_aChanges.root);
#endif
		// TreeChangeList *pChangeList = new TreeChangeList(_aChanges, SubtreeChange::NoChildCopy());
		setFilter(_aModuleName.toString());
		
		// we need to load localized values as sets, to preserve multi-locale entries
		vos::ORef< OOptions > xLoadOptions = new OOptions( *_rOptions );
		xLoadOptions->setMultiLocaleMode();

        TreeChangeList *pChangeList = new TreeChangeList(xLoadOptions, AbsolutePath::makeModulePath(_aModuleName), Chg());
		std::auto_ptr<TreeChangeList> apDeleteChangeList(pChangeList);

		// ------------- open file -------------

		sal_Int32 nRet = 0;
		File aFile(_aFromURL);
		FileBase::RC eError = aFile.open(OpenFlag_Read);
		if (eError == osl_File_E_None)
		{
			try
			{
				// ------------- sax read --------------
				// connect stream to input stream to the parser
				InputSource aInputSource;			
				aInputSource.aInputStream =  new configmgr::OSLInputStreamWrapper(aFile);			
				
				// create the writer and the parser we want to use					
				XMLTreeChangeListBuilder *pChangeBuilder = new XMLTreeChangeListBuilder(*pChangeList);
				Reference< sax::XDocumentHandler > xChangeWriter = pChangeBuilder;
				
				// get filter
				Reference<XDocumentHandler> xFilter( new OSelectHandler(xChangeWriter, m_aFilterVector,
																		pChangeBuilder->getAttributeHandler()) );			
				
			// connect parser and filter
				DocumentBuilder aSaxBuilder( m_xParser, xFilter );

				aSaxBuilder.parseStream( aInputSource );
			}
			catch( SAXParseException &e )
			{
				OUString sLine = OUString::valueOf(e.LineNumber);
				OUString aStr = ASCII("SAXParseException occured in ");
				sError = aStr + ASCII(" Line: (") + sLine + ASCII(")");
				OSL_ENSURE(0, rtl::OUStringToOString(sError,RTL_TEXTENCODING_ASCII_US).getStr());
				nRet = 3;
			}
			catch( SAXException &e )
			{
				sError = e.Message;
				OSL_ENSURE(0, rtl::OUStringToOString(sError,RTL_TEXTENCODING_ASCII_US).getStr());
				nRet = 4;
			}
			catch( IOException &e )
			{
				sError = e.Message;
				OSL_ENSURE(0, rtl::OUStringToOString(sError,RTL_TEXTENCODING_ASCII_US).getStr());
				nRet = 5;
			}
			aFile.close();
		}
		
		if (nRet == 0 &&               /* no error */
			eError == osl_File_E_None) /* No Fileerror */
		{
			// XMLTreeChangeListBuilder creates allways addnodes or subtreechanges
			// but we need ValueChanges

			// merge the present TreeChangeList in the loaded one.

			OMergeTreeChangeList aMerge(*pChangeList);
			aMerge.mergeChanges(_aChanges);
		}
		else
		{
			// there is no user file, create one.
			CFG_TRACE_INFO("updateTree: There is no update file, we create one.");
			apDeleteChangeList.reset();
			pChangeList = &_aChanges;
		}
		
		// Write down the aChangeList

		try
		{
			FileHelper::tryToRemoveFile(_aToURL);
		}
		catch (io::IOException &e)
		{
			CFG_TRACE_ERROR("updateTree: the update file can't removed, check your file permissions.");
			sError = e.Message;
			OSL_ENSURE(false, rtl::OUStringToOString(sError,RTL_TEXTENCODING_ASCII_US).getStr());
			throw io::IOException(sError, NULL);
			// return 1;
		}
		
		// write the ChangeList down to the filesystem
		if (1) 
		{
			File aWriteFile(_aToURL);
			eError = aWriteFile.open(OpenFlag_Write | OpenFlag_Create);
			// TODO: E_EXIST
			if (eError != osl_File_E_None)
			{
				sError = FileHelper::createOSLErrorString(eError);
				CFG_TRACE_ERROR("LocalSession::doUpdateTree(): %s \n with URL: %s", OUSTRING2ASCII(sError), OUSTRING2ASCII(_aToURL));
				OString aStr = rtl::OUStringToOString(sError,RTL_TEXTENCODING_ASCII_US);
				OSL_ENSURE(0, aStr.getStr());
				throw io::IOException(sError, NULL);
				// return 2;
			}
			
			Reference<XOutputStream> xOutputStream = new configmgr::OSLOutputStreamWrapper(aWriteFile);
			
			Reference< sax::XDocumentHandler > xWriter( m_xServiceProvider->createInstance( ::rtl::OUString::createFromAscii("com.sun.star.xml.sax.Writer")), UNO_QUERY);						
			Reference< XActiveDataSource> xDataSource( xWriter , UNO_QUERY );
			xDataSource->setOutputStream(xOutputStream);
		
			std::auto_ptr<OXMLAttributeHandler> pAttributeHandler( m_bIsSetup ? new OXMLAttributeHandler : new OXMLChangeAttributeHandler);
			pAttributeHandler->setCurrentModule( pChangeList->getModuleName().toString() );

			XMLFormater aFormatter(&pChangeList->root, _rOptions, *pAttributeHandler);
		
			aFormatter.setHandler(xWriter);
			aFormatter.writeAsFlat(pChangeList->getRootNodePath(), m_aSharePath.isNewFileStructure());

			aWriteFile.close();

			// write(&pChangeList->root, m_aUserPath.createBinaryFileURL());
		}

		if (nRet == 0)
		{
			FileHelper::createBackupRemoveAndRename(_aFromURL, _aToURL);
		}
		else
		{
			File::remove(_aToURL);
		}

		return nRet;
	}

	// -----------------------------------------------------------------------------
	LocalSession::~LocalSession()
	{
	}
	

} // namespace configmgr


