/*************************************************************************
 *
 *  $RCSfile: MABColumnAlias.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: wvd $ $Date: 2001/07/19 13:14:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): Willem van Dorp
 *
 *
 ************************************************************************/

#ifndef _CONNECTIVITY_MAB_COLUMNALIAS_HXX_
#include "mozaddressbook/MABColumnAlias.hxx"
#endif
#ifndef _CONNECTIVITY_MAB_DRIVER_HXX_
#include "mozaddressbook/MABDriver.hxx"
#endif
#ifndef _UNOTOOLS_CONFIGNODE_HXX_
#include <unotools/confignode.hxx>
#endif

using namespace connectivity;
using namespace connectivity::mozaddressbook;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::utl;

static const ::rtl::OUString sProgrammaticNames[] = 
{
	::rtl::OUString::createFromAscii("FirstName"),
	::rtl::OUString::createFromAscii("LastName"),
	::rtl::OUString::createFromAscii("DisplayName"),
	::rtl::OUString::createFromAscii("NickName"),
	::rtl::OUString::createFromAscii("PrimaryEmail"),
	::rtl::OUString::createFromAscii("SecondEmail"),
	::rtl::OUString::createFromAscii("PreferMailFormat"),
	::rtl::OUString::createFromAscii("WorkPhone"),
	::rtl::OUString::createFromAscii("HomePhone"),
	::rtl::OUString::createFromAscii("FaxNumber"),
	::rtl::OUString::createFromAscii("PagerNumber"),
	::rtl::OUString::createFromAscii("CellularNumber"),
	::rtl::OUString::createFromAscii("HomeAddress"),
	::rtl::OUString::createFromAscii("HomeAddress2"),
	::rtl::OUString::createFromAscii("HomeCity"),
	::rtl::OUString::createFromAscii("HomeState"),
	::rtl::OUString::createFromAscii("HomeZipCode"),
	::rtl::OUString::createFromAscii("HomeCountry"),
	::rtl::OUString::createFromAscii("WorkAddress"),
	::rtl::OUString::createFromAscii("WorkAddress2"),
	::rtl::OUString::createFromAscii("WorkCity"),
	::rtl::OUString::createFromAscii("WorkState"),
	::rtl::OUString::createFromAscii("WorkZipCode"),
	::rtl::OUString::createFromAscii("WorkCountry"),
	::rtl::OUString::createFromAscii("JobTitle"),
	::rtl::OUString::createFromAscii("Department"),
	::rtl::OUString::createFromAscii("Company"),
	::rtl::OUString::createFromAscii("WebPage1"),
	::rtl::OUString::createFromAscii("WebPage2"),
	::rtl::OUString::createFromAscii("BirthYear"),
	::rtl::OUString::createFromAscii("BirthMonth"),
	::rtl::OUString::createFromAscii("BirthDay"),
	::rtl::OUString::createFromAscii("Custom1"),
	::rtl::OUString::createFromAscii("Custom2"),
	::rtl::OUString::createFromAscii("Custom3"),
	::rtl::OUString::createFromAscii("Custom4"),
	::rtl::OUString::createFromAscii("Notes")
};
//------------------------------------------------------------------------------
OMozabColumnAlias::OMozabColumnAlias()
{
	// Initialise m_aAlias with the default values from sProgrammaticNames.
	initialise();

	// Initialise m_aAlias map with the default values from sProgrammaticNames.
	setAliasMap();
}
//------------------------------------------------------------------
OMozabColumnAlias::~OMozabColumnAlias()
{
}
//------------------------------------------------------------------
void OMozabColumnAlias::initialise() 
{
	for (sal_Int32 i(FIRSTNAME); i < END; ++i) {
		m_aAlias.push_back(sProgrammaticNames[i]);
	}

	return;
}
//------------------------------------------------------------------
void OMozabColumnAlias::setAlias(const ::com::sun::star::uno::Reference< 
                                       ::com::sun::star::lang::XMultiServiceFactory >& _rxORB)
{
        // open our driver settings config node

        // the config path for the settings for all drivers
        const ::rtl::OUString sAllDriverSettingsNodeName = 
        ::rtl::OUString::createFromAscii("org.openoffice.Office.DataAccess/DriverSettings/");

        // the config path for our own driver's settings
        ::rtl::OUString sMyDriverSettingsNodeName = sAllDriverSettingsNodeName;
        sMyDriverSettingsNodeName += OMozabDriver::getImplementationName_Static();

        // open the settings node
        OConfigurationTreeRoot aDriverSettings =
	OConfigurationTreeRoot::createWithServiceFactory( 
		_rxORB, 				// service factory to create the ConfigurationProvider
                sMyDriverSettingsNodeName,   		// node name
                -1, 					// depth -> unlimited
                OConfigurationTreeRoot::CM_READONLY 	// open for read access only
        	);

        // the node for the column aliases
        OConfigurationNode aAliases = 
		aDriverSettings.openNode( ::rtl::OUString::createFromAscii("ColumnAliases"));

        // this is a set of string nodes
        Sequence< ::rtl::OUString > aColumnProgrammaticNames = aAliases.getNodeNames();

        // travel through all the set elements
        const ::rtl::OUString* pColumnProgrammaticNames = aColumnProgrammaticNames.getConstArray();
        const ::rtl::OUString* pColumnProgrammaticNamesEnd = 
		pColumnProgrammaticNames + aColumnProgrammaticNames.getLength();
        ::rtl::OUString sAssignedAlias;

        for (;pColumnProgrammaticNames < pColumnProgrammaticNamesEnd; ++pColumnProgrammaticNames)
        {
                OSL_ENSURE(m_aAliasMap.end() != m_aAliasMap.find(*pColumnProgrammaticNames),
                           "OMozabColumnAlias::initialize: found an invalid programmtic name!");
                // if this asserts, somebody stored a programmatic name in the configuration 
                // which is not allowed (i.e. not in the list of known programmatics).

#ifdef _DEBUG
                sal_Bool bExtractionSuccess =
#endif
                aAliases.getNodeValue(*pColumnProgrammaticNames) >>= sAssignedAlias;
                OSL_ENSURE(bExtractionSuccess, "OMozabColumnAlias::initialize: invalid config data!");

                // normalize in case the config data is corrupted
                // (what we really don't need is an empty alias ...)
                if (!sAssignedAlias.getLength()) {
                        sAssignedAlias = *pColumnProgrammaticNames;
		}
		
		// Check the value.
		sal_Int32 nPosition(FIRSTNAME);
		for (; nPosition < END; ++nPosition) {
			if ((*pColumnProgrammaticNames).equals(sProgrammaticNames[nPosition])) {
                                // add alias to the vector
				m_aAlias[nPosition] = sAssignedAlias;
				break;
			}
		}
        }
	
	// Initialise m_aAliasMap.
	setAliasMap();
	
	return;
}
//------------------------------------------------------------------
const ::std::vector< ::rtl::OUString> & OMozabColumnAlias::getAlias() const
{
	return m_aAlias;
}
//------------------------------------------------------------------
const ::std::map< ::rtl::OUString, ::rtl::OUString> & OMozabColumnAlias::getAliasMap() const
{
	return m_aAliasMap;
}
//------------------------------------------------------------------
void OMozabColumnAlias::setAliasMap()
{
    	// Fill the map with the values of m_aAlias 
        // and the sProgrammaticNames array.
	for (sal_Int32 i(FIRSTNAME); i < END; ++i) {
		m_aAliasMap[m_aAlias[i]] = sProgrammaticNames[i];
	}

    	return;
}
//------------------------------------------------------------------
