/*************************************************************************
 *
 *  $RCSfile: MABQuery.cxx,v $
 *
 *  $Revision: 1.21 $
 *
 *  last change: $Author: dkenny $ $Date: 2001/07/25 16:36:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): Willem van Dorp, Darren Kenny
 *
 *
 ************************************************************************/

#include <stdio.h>

#include "MABNSInclude.hxx"

#include <mozaddressbook/MABQueryHelper.hxx>
#include <MABNameMapper.hxx>
 
//TODO (1line)
// A lot of these includes can be removed at a later stage.

#ifndef _CONNECTIVITY_MAB_QUERY_HXX_
#include "mozaddressbook/MABQuery.hxx"
#endif
#ifndef _CONNECTIVITY_MAB_CONVERSIONS_HXX_
#include "MABTypeConverter.hxx"
#endif
#ifndef _COM_SUN_STAR_SDBC_COLUMNVALUE_HPP_
#include <com/sun/star/sdbc/ColumnValue.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_DATATYPE_HPP_
#include <com/sun/star/sdbc/DataType.hpp>
#endif
//#ifndef _COM_SUN_STAR_UCB_XCONTENTACCESS_HPP_
//#include <com/sun/star/ucb/XContentAccess.hpp>
//#endif
#ifndef _COM_SUN_STAR_SDBC_XROW_HPP_
#include <com/sun/star/sdbc/XRow.hpp>
#endif
//#ifndef _COM_SUN_STAR_UTIL_NUMBERFORMAT_HPP_
//#include <com/sun/star/util/NumberFormat.hpp>
//#endif
//#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HPP_
//#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
//#endif
//#ifndef _COM_SUN_STAR_TEXT_XTEXT_HPP_
//#include <com/sun/star/text/XText.hpp>
//#endif
//#ifndef _SV_CONVERTER_HXX_
//#include <svtools/converter.hxx>
//#endif
#ifndef _CONNECTIVITY_MAB_CONNECTION_HXX_
#include "mozaddressbook/MABConnection.hxx"
#endif
#ifndef _CONNECTIVITY_MAB_COLUMNS_HXX_
#include "mozaddressbook/MABColumns.hxx"
#endif
#ifndef _CONNECTIVITY_SDBCX_COLUMN_HXX_
#include "connectivity/sdbcx/VColumn.hxx"
#endif
#ifndef _RTL_USTRBUF_HXX_
#include <rtl/ustrbuf.hxx>
#endif
#ifndef _OSL_THREAD_H_
#include <osl/thread.h>
#endif
//#ifndef _CONFIG_HXX //autogen
//#include <vcl/config.hxx>
//#endif
#ifndef _COMPHELPER_SEQUENCE_HXX_
#include <comphelper/sequence.hxx>
#endif
//#ifndef _INTN_HXX //autogen
//#include <tools/intn.hxx>
//#endif
//#ifndef _SOLMATH_HXX //autogen wg. SolarMath
//#include <tools/solmath.hxx>
//#endif
//#ifndef _UCBHELPER_CONTENT_HXX
//#include <ucbhelper/content.hxx>
//#endif
#ifndef _CPPUHELPER_EXTRACT_HXX_
#include <cppuhelper/extract.hxx>
#endif
//#ifndef _UNTOOLS_UCBSTREAMHELPER_HXX
//#include <unotools/ucbstreamhelper.hxx>
//#endif
#ifndef _DBHELPER_DBEXCEPTION_HXX_
#include <connectivity/dbexception.hxx>
#endif
#ifndef _DBHELPER_DBCONVERSION_HXX_
#include <connectivity/dbconversion.hxx>
#endif

#include <../MABDebug.hxx>

// TODO (1line)
// Some of the macro calls are not necessary.
//static NS_DEFINE_CID(kPrefCID, NS_PREF_CID);
static NS_DEFINE_CID(kRDFServiceCID, NS_RDFSERVICE_CID);
//static NS_DEFINE_CID(kAppShellServiceCID, NS_APPSHELL_SERVICE_CID);
//static NS_DEFINE_CID(kAddressBookDBCID, NS_ADDRDATABASE_CID);
static NS_DEFINE_CID(kAddrBookSessionCID, NS_ADDRBOOKSESSION_CID);
static NS_DEFINE_CID(kAbDirectoryQueryArgumentsCID, NS_ABDIRECTORYQUERYARGUMENTS_CID);
static NS_DEFINE_CID(kBooleanConditionStringCID, NS_BOOLEANCONDITIONSTRING_CID);
static NS_DEFINE_CID(kBooleanExpressionCID, NS_BOOLEANEXPRESSION_CID);
static NS_DEFINE_CID(kAbDirectoryQueryProxyCID, NS_ABDIRECTORYQUERYPROXY_CID);
// static NS_DEFINE_CID(kAbDirectoryCID, NS_ABDIRECTORY_CID); 
// static NS_DEFINE_CID(kAbCardPropertyCID, NS_ABCARDPROPERTY_CID);
// static NS_DEFINE_CID(kAB4xUpgraderServiceCID, NS_AB4xUPGRADER_CID);
//
// const char *kDirectoryDataSourceRoot = kDirectoryRoot;
// const char *kCardDataSourceRoot = kCardRoot;

using namespace connectivity::mozaddressbook;
using namespace connectivity::file;
using namespace connectivity;
//  using namespace ::ucb;
using namespace ::cppu;
using namespace ::dbtools;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::ucb;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::sdbcx;
using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::container;
using namespace ::com::sun::star::lang;
//  using namespace ::com::sun::star::sheet;
//  using namespace ::com::sun::star::table;
//  using namespace ::com::sun::star::text;
using namespace ::com::sun::star::util;

//NS_IMPL_ISUPPORTS1(OMozabQuery,nsIAbDirectoryQueryResultListener)
// -------------------------------------------------------------------------
OMozabQuery::OMozabQuery()
{
    OSL_TRACE( "IN OMozabQuery::OMozabQuery()\n" );

    // Set default values. (For now just as a reminder).
    m_bQuerySubDirs   = sal_True;       // LDAP Queryies require this to be set!
    m_nMaxNrOfReturns = -1; // Unlimited number of returns.

    // OMozabQueryHelper is reference counted, so we need to add to the 
    // count here to prevent accidental deletion else where...
    // 
    m_aQueryHelper = new OMozabQueryHelper();
    NS_IF_ADDREF( m_aQueryHelper);

    OSL_TRACE( "\tOUT OMozabQuery::OMozabQuery()\n" );
}
// -------------------------------------------------------------------------
OMozabQuery::OMozabQuery(const ::std::map< ::rtl::OUString, ::rtl::OUString>  & ca)
{
    OSL_TRACE( "IN OMozabQuery::OMozabQuery()\n" );

    // Set default values. (For now just as a reminder).
    m_bQuerySubDirs   = sal_True;       // LDAP Queryies require this to be set!
    m_nMaxNrOfReturns = -1; // Unlimited number of returns.

        // OMozabQueryHelper is reference counted, so we need to add to the 
        // count here to prevent accidental deletion else where...
        // 
        m_aQueryHelper = new OMozabQueryHelper();
        NS_IF_ADDREF( m_aQueryHelper);
        m_aColumnAliasMap = ca;

    OSL_TRACE( "\tOUT OMozabQuery::OMozabQuery()\n" );
}
// -------------------------------------------------------------------------
OMozabQuery::~OMozabQuery()
{
    OSL_TRACE("IN OMozabQuery::~OMozabQuery()\n");
    
    // OMozabQueryHelper is reference counted, so we need to decrement the
    // count here.
    // 
    NS_IF_RELEASE( m_aQueryHelper);

    OSL_TRACE("\tOUT OMozabQuery::~OMozabQuery()\n");
}
// -------------------------------------------------------------------------
void OMozabQuery::setAttributes(::std::vector< ::rtl::OUString> &attrs)
{
    OSL_TRACE("IN OMozabQuery::setAttributes()\n");
    ::osl::MutexGuard aGuard( m_aMutex );

    m_aAttributes.clear();
    ::std::vector< ::rtl::OUString>::iterator aIterAttr = attrs.begin();
        ::std::map< ::rtl::OUString, ::rtl::OUString>::iterator aIterMap;
    for(aIterAttr; aIterAttr != attrs.end();++aIterAttr) {
        // TODO --> Catch a '*' wildcard character, or will the
        //          parser take care of this?
        if (aIterAttr->equals(::rtl::OUString::createFromAscii("*"))) {
            m_aAttributes.clear();
            // Add all field names to m_aAttributes.
            break;
        } else {
                        aIterMap = m_aColumnAliasMap.find(*aIterAttr);
                        if (aIterMap == m_aColumnAliasMap.end()) {
                // Not found.
                m_aAttributes.push_back(*aIterAttr);
                        } else {
                            m_aAttributes.push_back(aIterMap->second);
            }
        }
    }

    return;

    OSL_TRACE("\tOUT OMozabQuery::setAttributes()\n");
}
// -------------------------------------------------------------------------
const ::std::vector< ::rtl::OUString> &OMozabQuery::getAttributes() const
{
    OSL_TRACE("IN OMozabQuery::getAttributes()\n");
    //::osl::MutexGuard aGuard(m_aMutex);
    
    return(m_aAttributes);

    OSL_TRACE("\tOUT OMozabQuery::getAttributes()\n");
}
// -------------------------------------------------------------------------
void OMozabQuery::setAddressbook(::rtl::OUString &ab)
{
    OSL_TRACE("IN OMozabQuery::setAddressbook()\n");
    ::osl::MutexGuard aGuard(m_aMutex);
    
    m_aAddressbook = ab;
    return;

    OSL_TRACE("\tOUT OMozabQuery::setAddressbook()\n");
}
// -------------------------------------------------------------------------
::rtl::OUString OMozabQuery::getAddressbook() const
{
    OSL_TRACE("IN OMozabQuery::getAddressbook()\n");
    //::osl::MutexGuard aGuard(m_aMutex);
    
    return(m_aAddressbook);

    OSL_TRACE("\tOUT OMozabQuery::getAddressbook()\n");
}
// -------------------------------------------------------------------------
void OMozabQuery::setMatchItems(::std::vector< ::rtl::OUString> &mi)
{
    OSL_TRACE("IN OMozabQuery::setMatchItems()\n");
    ::osl::MutexGuard aGuard(m_aMutex);

    ::std::vector< ::rtl::OUString>::iterator aIter = mi.begin();
    ::std::map< ::rtl::OUString, ::rtl::OUString>::const_iterator aIterMap;

    m_aMatchItems.clear();
    for(aIter; aIter != mi.end();++aIter) {
        aIterMap = m_aColumnAliasMap.find(*aIter);
        if (aIterMap == m_aColumnAliasMap.end()) {
            // Not found.
            m_aMatchItems.push_back(*aIter);
        } 
        else {
            m_aMatchItems.push_back(aIterMap->second);
        }
    }
    return;

    OSL_TRACE("\tOUT OMozabQuery::setMatchItems()\n");
}
// -------------------------------------------------------------------------
const ::std::vector< ::rtl::OUString> &OMozabQuery::getMatchItems() const
{
    OSL_TRACE("IN OMozabQuery::getMatchItems()\n");
    //::osl::MutexGuard aGuard(m_aMutex);

    return(m_aMatchItems);

    OSL_TRACE("\tOUT OMozabQuery::getMatchItems()\n");
}
// -------------------------------------------------------------------------
void OMozabQuery::setMatchValues(::std::vector< ::rtl::OUString>& mv)
{
    OSL_TRACE("IN OMozabQuery::setMatchValues()\n");
    ::osl::MutexGuard aGuard(m_aMutex);

    ::std::vector< ::rtl::OUString>::iterator aIter = mv.begin();
    m_aMatchValues.clear();
    for(aIter; aIter != mv.end();++aIter) {
        m_aMatchValues.push_back(*aIter);
    }
    return;

    OSL_TRACE("\tOUT OMozabQuery::setMatchValues()\n");
}
// -------------------------------------------------------------------------
const ::std::vector< ::rtl::OUString>& OMozabQuery::getMatchValues( void ) const
{
    OSL_TRACE("IN OMozabQuery::getMatchValues()\n");
    //::osl::MutexGuard aGuard(m_aMutex);

    return(m_aMatchValues);

    OSL_TRACE("\tOUT OMozabQuery::getMatchValue()\n");
}
// -------------------------------------------------------------------------
void OMozabQuery::setMaxNrOfReturns(const sal_Int32 mnr)
{
    OSL_TRACE( "IN OMozabQuery::setMaxNrOfReturns()\n" );
    ::osl::MutexGuard aGuard(m_aMutex);

    m_nMaxNrOfReturns = mnr;
    return;

    OSL_TRACE("\tOUT OMozabQuery::setMaxNrOfReturns()\n" );
}
// -------------------------------------------------------------------------
sal_Int32 OMozabQuery::getMaxNrOfReturns() const
{
    OSL_TRACE("IN OMozabQuery::getMaxNrOfReturns()\n");
    //::osl::MutexGuard aGuard(m_aMutex);

    return(m_nMaxNrOfReturns);

    OSL_TRACE("\tOUT OMozabQuery::getMaxNrOfReturns()\n");
}
// -------------------------------------------------------------------------
void OMozabQuery::setQuerySubDirs(sal_Bool &qsd)
{
    OSL_TRACE("IN OMozabQuery::setQuerySubDirs()\n");
    ::osl::MutexGuard aGuard(m_aMutex);

    m_bQuerySubDirs = qsd;
    return;

    OSL_TRACE("\tOUT OMozabQuery::setQuerySubDirs()\n");
}
// -------------------------------------------------------------------------
sal_Bool OMozabQuery::getQuerySubDirs() const
{
    OSL_TRACE("IN OMozabQuery::getQuerySubDirs()\n");
    //::osl::MutexGuard aGuard(m_aMutex);

    return(m_bQuerySubDirs);

    OSL_TRACE("\tOUT OMozabQuery::getQuerySubDirs()\n");
}
// -------------------------------------------------------------------------
void OMozabQuery::setSqlOppr(::std::vector< OMozabQuery::eSqlOppr > &so)
{
    OSL_TRACE("IN OMozabQuery::setSqlOppr()\n");
    ::osl::MutexGuard aGuard(m_aMutex);

    m_aSqlOppr.clear();
    m_aSqlOppr = so;
    return;

    OSL_TRACE("\tOUT OMozabQuery::setSqlOppr()\n");
}
// -------------------------------------------------------------------------
const ::std::vector< OMozabQuery::eSqlOppr > &OMozabQuery::getSqlOppr() const
{
    OSL_TRACE("IN OMozabQuery::getSqlOppr()\n");
    //::osl::MutexGuard aGuard(m_aMutex);
    
    return(m_aSqlOppr);

    OSL_TRACE("\tOUT OMozabQuery::getSqlOppr()\n");
}
// -------------------------------------------------------------------------
sal_Int32 OMozabQuery::executeQuery(sal_Bool _bIsOutlookExpress)
{
    OSL_TRACE("IN OMozabQuery::executeQuery()\n");
    ::osl::MutexGuard aGuard(m_aMutex);

    /*
    // TODO MABQueryHelper() could perform the query with parameters
    // that we initialize in here.
    // In here we convert the members to mozilla-ish values and pass
    // that to MABQueryHelper::executeQuery().
    ::std::vector< ::std::string> aAttributes;
    ::std::vector< ::std::string> aMatchItems;
    nsString aMatchValue;
    ::std::vector<PRInt32> aSqlOppr;
    OMozabTypeConverter tc;
    // Initialise aAttributes.
    ::std::vector< ::rtl::OUString>::iterator iter = m_aAttributes.begin();
    for (iter; iter != m_aAttributes.end(); ++iter) {
        aAttributes.push_back(tc.ouStringToStlString(*iter));
    }
    // Initialise aAddressbook.
    ::std::string aAddressbook = tc.ouStringToStlString(m_aAddressbook);
    // Initialise aMatchItems.
    ::std::vector< ::rtl::OUString>::iterator iter = m_aMatchItems.begin();
    for (iter; iter != m_aMatchItems.end(); ++iter) {
        aMatchItems.push_back(tc.ouStringToStlString(*iter));
    }
    // Initialise aMatchValue.
    tc.ouStringToNsString(m_aMatchValue, aMatchValue);
    // Initialise aSqlOppr.
    ::std::vector<PRInt32>::iterator iter = m_aSqlOppr.begin();
    for (iter; iter != m_aSqlOppr.end(); ++iter) {
        aMatchItems.push_back(*iter);
    }
    // Execute the query.
    OMozabQueryHelper aQueryHelper;
    if (aQueryHelper.executeQuery(aAttributes, 
                                  aAddressbook, 
                                  aMatchItems, 
                                  aMatchValue,
                                  aSqlOppr,
                                  m_nMaxNrOfReturns,
                                  m_bQuerySubDirs) == -1)
    {
    OSL_TRACE("Error in OMozabQuery::executeQuery!\n");
    }
    
    nsresult rv;        // Store return values.
    // XXXX - Should we create an AB session?
    //
    //
    NS_WITH_SERVICE(nsIAddrBookSession, abSession, kAddrBookSessionCID, &rv);
    if(NS_SUCCEEDED(rv))
       OSL_TRACE("Created an ABSession\n");
    else
       OSL_TRACE("FAILED to create an ABSession\n");

    // Temp
    // Create a nsIAbDirectory object to initialise the nsIAbDirectoryQuery object.
    NS_WITH_SERVICE(nsIRDFService, rdfService, kRDFServiceCID, &rv);    
    if (NS_FAILED(rv)) 
        return(rv);
    nsCOMPtr<nsIRDFResource> dirResource;
    rv = rdfService->GetResource("abmdbdirectory://abook.mab", getter_AddRefs(dirResource));
    if (NS_FAILED(rv)) 
        return(rv);
    nsCOMPtr<nsIAbDirectory> directory = do_QueryInterface(dirResource, &rv);
    if (NS_FAILED(rv)) 
        return(rv);

    PRUnichar *uCharStr;
    directory->GetDirName( &uCharStr );
    if ( uCharStr ) {
        nsCAutoString temp1;
        temp1.AssignWithConversion( uCharStr );
    OSL_TRACE("dirName = %s\n", (char*)temp1 );
    } else
    OSL_TRACE("dirName = NULL\n" );
    */

    nsresult rv;        // Store return values.
    OMozabTypeConverter aTypeConverter;
    // Create a nsIAbDirectory object to initialise the nsIAbDirectoryQuery object.
    NS_WITH_SERVICE(nsIRDFService, rdfService, kRDFServiceCID, &rv);    
    if (NS_FAILED(rv)) 
        return(-1);

    nsCOMPtr<nsIAbDirectory> directory;
    OMozabNameMapper *nmap = OMozabNameMapper::getInstance();

    if ( nmap->getDir( m_aAddressbook, getter_AddRefs( directory ) ) == sal_False )
        return( -1 );

    // Create a nsIAbDirectoryQuery object which eventually will execute 
    // the query by calling DoQuery().
    nsCOMPtr< nsIAbDirectoryQueryProxy > directoryQueryProxy = do_CreateInstance( kAbDirectoryQueryProxyCID, &rv);

    nsCOMPtr<nsIAbDirectoryQuery> directoryQuery(do_QueryInterface(directory, &rv));

    if ( NS_FAILED(rv) || _bIsOutlookExpress) 
    {
        rv = directoryQueryProxy->Initiate (directory);
        NS_ENSURE_SUCCESS(rv, rv);

        directoryQuery = do_QueryInterface (directoryQueryProxy, &rv);
        NS_ENSURE_SUCCESS(rv, rv);
        OSL_TRACE("Using the directoryQueryProxy\n");
    }
#ifdef DEBUG
    else
        OSL_TRACE("Not using a Query Proxy, Query i/f supported by directory\n");
#endif /* DEBUG */

    // Array that holds all matchItems, to be passed to DoQuery().
    nsCOMPtr<nsISupportsArray> matchItems;
    NS_NewISupportsArray(getter_AddRefs(matchItems));

    // Add every individual boolString to matchItems array.
    ::std::vector< ::rtl::OUString>::iterator aIterMi = m_aMatchItems.begin();
    ::std::vector< eSqlOppr >::iterator aIterOp = m_aSqlOppr.begin();
    ::std::vector< ::rtl::OUString>::iterator aIterVal = m_aMatchValues.begin();
    nsString matchValue;
    // Initialise the matchItems container.
    for(aIterMi; aIterMi != m_aMatchItems.end();++aIterMi, ++aIterOp, ++aIterVal) 
    {
        // A single boolString, added to matchItems.
        // nsCOMPtr<nsIBooleanConditionString> boolString;
        // NS_NewIBooleanConditionString(getter_AddRefs (boolString));
        // NS_WITH_SERVICE(nsIBooleanConditionString, boolString, kBooleanConditionStringCID, &rv);
        nsCOMPtr<nsIBooleanConditionString> boolString = do_CreateInstance (kBooleanConditionStringCID, &rv);
        OSL_TRACE("0x%08X\n", (void*)boolString );
        NS_ENSURE_SUCCESS( rv, rv );
        // Set the 'name' property of the boolString. 
        string aMiName = aTypeConverter.ouStringToStlString(*aIterMi); 
        boolString->SetName(strdup(aMiName.c_str()));
        OSL_TRACE("Name = %s ;", aMiName.c_str() );
        // Set the 'matchType' property of the boolString. Check for equal length.
        if (aIterOp == m_aSqlOppr.end() && aIterMi != m_aMatchItems.end()) {
            m_aSqlOppr.push_back(matchIs); // Add matchIs for non-set value.
        }
        switch(*aIterOp) {
            case matchExists:
                boolString->SetCondition(nsIBooleanConditionTypes::Exists);
                break;
            case matchDoesNotExist:
                boolString->SetCondition(nsIBooleanConditionTypes::DoesNotExist);
                break;
            case matchContains:
                boolString->SetCondition(nsIBooleanConditionTypes::Contains);
                break;
            case matchDoesNotContain:
                boolString->SetCondition(nsIBooleanConditionTypes::DoesNotContain);
                break;
            case matchIs:
                boolString->SetCondition(nsIBooleanConditionTypes::Is);
                break;
            case matchIsNot:
                boolString->SetCondition(nsIBooleanConditionTypes::IsNot);
                break;
            case matchBeginsWith:
                boolString->SetCondition(nsIBooleanConditionTypes::BeginsWith);
                break;
            case matchEndsWith:
                boolString->SetCondition(nsIBooleanConditionTypes::EndsWith);
                break;
            case matchSoundsLike:
                boolString->SetCondition(nsIBooleanConditionTypes::SoundsLike);
                break;
            case matchRegExp:
                boolString->SetCondition(nsIBooleanConditionTypes::RegExp);
                break;
            default:
                boolString->SetCondition(nsIBooleanConditionTypes::Is);
                break;
        }
        // Set the 'matchValue' property of the boolString. Value returned in unicode.
        if ( (*aIterVal) )
        {
            OSL_TRACE("Value = %s \n", OUtoCStr( (*aIterVal) ) );
            aTypeConverter.ouStringToNsString( (*aIterVal), matchValue);
            boolString->SetValue(matchValue.ToNewUnicode ());
        }
        // Add the individual boolString to the container of matchItems.
        matchItems->AppendElement(boolString);
    }
    // Create a query expression.
    // nsCOMPtr<nsIBooleanExpression> queryExpression;
    // NS_NewIBooleanExpression(getter_AddRefs (queryExpression));
    nsCOMPtr< nsIBooleanExpression > queryExpression = do_CreateInstance( kBooleanExpressionCID , &rv);
    NS_ENSURE_SUCCESS( rv, rv );
    queryExpression->SetExpressions(matchItems);
    queryExpression->SetOperation(nsIBooleanOperationTypes::OR);

    // Array of return properties, fill this with the attributes we're interested in, i.e.
    // that we want as the resultset of the query.
    // nsCOMPtr<nsISupportsArray> returnProperties;
    // NS_NewISupportsArray(getter_AddRefs(returnProperties));

    // Add every atribute we're interested in to the return properties array.
    ::std::vector< ::rtl::OUString>::iterator aIterAttr = m_aAttributes.begin();
    char    **returnProperties = new char* [ m_aAttributes.size() + 2 ];

    // Insert this first as we need to check if items are mailing lists in the
    // OnMatchItem method of the QueryHelper
    PRInt32   count=0;
    returnProperties[count] = strdup( "card:nsIAbCard");
    for(aIterAttr, count=1; aIterAttr != m_aAttributes.end();++aIterAttr,++count) 
    {
        ::std::string aAttrName = aTypeConverter.ouStringToStlString(*aIterAttr);
        returnProperties[count] = strdup( aAttrName.c_str() );
        OSL_TRACE("returnProperties[%d] = %s\n", count, returnProperties[count] );
    }
    returnProperties[count] = NULL;

    // Arguments for the nsIAbDirectoryQuery->DoQuery() call.
    // nsCOMPtr<nsIAbDirectoryQueryArguments> arguments;
    // NS_NewIAbDirectoryQueryArguments(getter_AddRefs(arguments));
    nsCOMPtr< nsIAbDirectoryQueryArguments > arguments = do_CreateInstance( kAbDirectoryQueryArgumentsCID, &rv);

    NS_ENSURE_SUCCESS( rv, rv );
    rv = arguments->SetExpression(queryExpression);
    NS_ENSURE_SUCCESS( rv, rv );

    rv = arguments->SetReturnProperties(count, (const char **)returnProperties);
    NS_ENSURE_SUCCESS( rv, rv );

    rv = arguments->SetQuerySubDirectories(m_bQuerySubDirs);
    NS_ENSURE_SUCCESS( rv, rv );

    PRInt32 context;
    // Execute the query.
    OSL_TRACE( "****** calling DoQuery\n");

    m_aQueryHelper->reset();

    rv = directoryQuery->DoQuery(arguments, m_aQueryHelper, m_nMaxNrOfReturns, -1, &context);
    // rv = directoryQuery->DoQuery(arguments, this, m_nMaxNrOfReturns, &context);
    // XXX - Just testing!
#ifdef DARREN_WORK
    while ( ! m_aQueryHelper->queryComplete() ) {
        OSL_TRACE("Sleeping for 10 seconds\n");
        sleep(10);
    }
#endif /* DARREN_WORK */
    if (NS_FAILED(rv))  {
        OSL_TRACE( "****** DoQuery failed\n");
        OSL_TRACE("\tOUT OMozabQuery::executeQuery()\n");
        m_aQueryHelper->notifyQueryError() ;
        return(-1);
    } else {
        OSL_TRACE( "****** DoQuery succeeded \n");
    }

    OSL_TRACE("\tOUT OMozabQuery::executeQuery()\n");

    return(0);
}

// -------------------------------------------------------------------------
//
//
//  If the query executed is being done asynchronously then this may return
//  -1 as the count, ie. it's undetermined.
//
sal_Int32
OMozabQuery::getRowCount() 
{
    return( m_aQueryHelper->getResultCount() );
}

// -------------------------------------------------------------------------
//
//
// As opposed to getRowCount() this returns the actual number of rows fetched
// so far (if is an async query)
//
sal_Int32
OMozabQuery::getRealRowCount() 
{
    return( m_aQueryHelper->getRealCount() );
}

//
//  If the query executed is being done asynchronously then this may be
//  false
//
sal_Bool
OMozabQuery::queryComplete( void )
{
    return( m_aQueryHelper->queryComplete() );
}

// -------------------------------------------------------------------------

sal_Bool
OMozabQuery::checkRowAvailable( sal_Int32 nDBRow )
{
    while( !queryComplete() && m_aQueryHelper->getRealCount() <= nDBRow )
        m_aQueryHelper->waitForRow( nDBRow );

    return( getRowCount() > nDBRow );
}

// -------------------------------------------------------------------------
void
OMozabQuery::getRowValue( ORowSetValue& rValue, 
                          sal_Int32 nDBRow, rtl::OUString& aDBColumnName, sal_Int32 nType )
{
    rtl::OUString   sValue;

    OSL_TRACE( "IN OMozabQuery::getRowValue()\n");

    OMozabQueryHelperResultEntry*   xResEntry = m_aQueryHelper->getByIndex( nDBRow );

    if (xResEntry == NULL )
    { 
        rValue.setNull();
        OSL_TRACE( "xResEntry = null\n");
    }
    ::std::map< ::rtl::OUString, ::rtl::OUString>::const_iterator aIterMap;
    switch ( nType ) {
        case DataType::VARCHAR:
            aIterMap = m_aColumnAliasMap.find(aDBColumnName);
            if (aIterMap != m_aColumnAliasMap.end()) {
                sValue = xResEntry->getValue(aIterMap->second);
            } else {
                sValue = xResEntry->getValue( aDBColumnName );
            }
            rValue = ORowSetValue(sValue);
            break;
        default:
            OSL_TRACE("Unknown DataType : %d\n", nType );
            rValue.setNull();
            break;
    }

    // rValue.setTypeKind( nType );

    OSL_TRACE( "\tOUT OMozabQuery::getRowValue()\n");
}

// -------------------------------------------------------------------------
/*
NS_IMETHODIMP OMozabQuery::OnQueryItem(nsIAbDirectoryQueryResult *result)
{
    OSL_TRACE("IN OMozabQuery::OnQueryItem()\n");
    ::osl::MutexGuard aGuard(m_aMutex);
    /*

    nsresult rv;
    PRInt32 resultType;
    //NS_ENSURE_SUCCESS(rv, rv); --> For debugging (assertion).

    // Get return status of executeQuery() call.
    result->GetType(&resultType);

    // Check for errors of the executeQuery() call.
    if (resultType == nsIAbDirectoryQueryResult::queryResultError) {
        ;
        //return NS_OK;
    } else if (resultType == nsIAbDirectoryQueryResult::queryResultStopped) {
        ;
                //return NS_OK;
    } else if (resultType == nsIAbDirectoryQueryResult::queryResultComplete) {
        ;
                //return NS_OK;
    }

    // Initialise an array that holds the resultset of the query.
    nsCOMPtr<nsISupportsArray> properties;
    rv = result->GetResult(getter_AddRefs (properties));

    PRUint32 count;
    rv = properties->Count(&count);

    // Initialise the resultset (xResultSet).
    for (PRUint32 i = 0; i < count; i++) {
        nsCOMPtr<nsISupports> item;
        rv = properties->GetElementAt(i, getter_AddRefs(item));

        nsCOMPtr<nsIAbDirectoryQueryPropertyValue> property(do_QueryInterface(item, &rv));

        // TODO (1line)
        // Here we are going to initialise the xResultSet object.
        //nsXPIDLCString name;
        //rv = property->GetName(getter_Copies (name));
        //nsCString n (name.get ());

        // We don't need this I suppose...
        //if (n == "card:nsIAbCard") {
        //  nsCOMPtr<nsISupports> cardSupports;
        //  property->GetValueISupports (getter_AddRefs (cardSupports));
        //  nsCOMPtr<nsIAbCard> card(do_QueryInterface(cardSupports, &rv));
        //} else {
        //  nsXPIDLString v;
        //  property->GetValue (getter_Copies (v));
        //  nsString value (v);
        //  nsCString cvalue;
        //  cvalue.AssignWithConversion (v);
        //}
    }
    //return(NS_OK);
    return;
    OSL_TRACE("\tOUT OMozabQuery::OnQueryItem()\n");
}
    */
// -------------------------------------------------------------------------
