/*************************************************************************
 *
 *  $RCSfile: staticmbmozab.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: svesik $ $Date: 2001/05/17 13:41:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <cppuhelper/implbase1.hxx>
#include <cppuhelper/implbase9.hxx>
#include <cppuhelper/compbase2.hxx>
#include <cppuhelper/compbase3.hxx>
#include <cppuhelper/compbase4.hxx>
#include <cppuhelper/compbase5.hxx>
#include <cppuhelper/compbase7.hxx>
#include <cppuhelper/compbase8.hxx>
#include <cppuhelper/compbase11.hxx>

#include <com/sun/star/sdbc/XDatabaseMetaData.hpp>
#include <com/sun/star/sdbc/XResultSetMetaData.hpp>
#include <com/sun/star/sdbc/XStatement.hpp>
#include <com/sun/star/sdbc/XWarningsSupplier.hpp>
#include <com/sun/star/sdbc/XCloseable.hpp>
#include <com/sun/star/sdbc/XResultSet.hpp>
#include <com/sun/star/sdbc/XRow.hpp>
#include <com/sun/star/sdbc/XResultSetMetaDataSupplier.hpp>
#include <com/sun/star/sdbc/XResultSetUpdate.hpp>
#include <com/sun/star/sdbc/XRowUpdate.hpp>
#include <com/sun/star/sdbc/XColumnLocate.hpp>
#include <com/sun/star/sdbc/XDriver.hpp>
#include <com/sun/star/sdbc/XConnection.hpp>
#include <com/sun/star/sdbcx/XDataDescriptorFactory.hpp>
#include <com/sun/star/sdbcx/XAppend.hpp>
#include <com/sun/star/sdbcx/XDrop.hpp>
#include <com/sun/star/sdbcx/XTablesSupplier.hpp>
#include <com/sun/star/sdbcx/XViewsSupplier.hpp>
#include <com/sun/star/sdbcx/XUsersSupplier.hpp>
#include <com/sun/star/sdbcx/XGroupsSupplier.hpp>
#include <com/sun/star/sdbcx/XAuthorizable.hpp>
#include <com/sun/star/sdbcx/XUser.hpp>
#include <com/sun/star/sdbcx/XColumnsSupplier.hpp>
#include <com/sun/star/sdbcx/XIndexesSupplier.hpp>
#include <com/sun/star/sdbcx/XKeysSupplier.hpp>
#include <com/sun/star/sdbcx/XRename.hpp>
#include <com/sun/star/sdbcx/XAlterTable.hpp>
#include <com/sun/star/container/XNameAccess.hpp>
#include <com/sun/star/container/XIndexAccess.hpp>
#include <com/sun/star/container/XEnumerationAccess.hpp>
#include <com/sun/star/container/XNamed.hpp>
#include <com/sun/star/util/XCancellable.hpp>
#include <com/sun/star/util/XRefreshable.hpp>
#include <com/sun/star/lang/XServiceInfo.hpp>
#include <com/sun/star/lang/XUnoTunnel.hpp>

using namespace com::sun::star::sdbc;
using namespace com::sun::star::sdbcx;
using namespace com::sun::star::container;
using namespace com::sun::star::util;
using namespace com::sun::star::lang;

namespace cppu {

	ClassData1 WeakImplHelper1<XDatabaseMetaData>::s_aCD = ClassData1( 1 );
	ClassData9 WeakImplHelper9<XNameAccess, XIndexAccess, XEnumerationAccess, XColumnLocate, XRefreshable, XDataDescriptorFactory, XAppend, XDrop, XServiceInfo>::s_aCD = ClassData9( 1 );
	ClassData5 WeakComponentImplHelper5<XTablesSupplier, XViewsSupplier, XUsersSupplier, XGroupsSupplier, XServiceInfo>::s_aCD = ClassData5( 4 );
	ClassData4 WeakComponentImplHelper4<XDataDescriptorFactory, XColumnsSupplier, XNamed, XServiceInfo>::s_aCD = ClassData4( 4 );
	ClassData8 WeakComponentImplHelper8<XDataDescriptorFactory, XColumnsSupplier, XIndexesSupplier, XKeysSupplier, XRename, XAlterTable, XNamed, XServiceInfo>::s_aCD = ClassData8( 4 );
	ClassData3 WeakComponentImplHelper3<XConnection, XWarningsSupplier, XServiceInfo>::s_aCD = ClassData3( 4 );
	ClassData2 WeakComponentImplHelper2<XDriver, XServiceInfo>::s_aCD = ClassData2( 4 );
	ClassData3 WeakComponentImplHelper3<XDataDescriptorFactory, XNamed, XServiceInfo>::s_aCD = ClassData3( 4 );
	ClassData4 WeakComponentImplHelper4<XUser, XGroupsSupplier, XNamed, XServiceInfo>::s_aCD = ClassData4( 4 );
	ClassData4 WeakComponentImplHelper4<XUsersSupplier, XAuthorizable, XNamed, XServiceInfo>::s_aCD = ClassData4( 4 );
	ClassData1 WeakImplHelper1<XResultSetMetaData>::s_aCD = ClassData1( 1 );
	ClassData7 WeakComponentImplHelper7<XResultSet, XRow, XResultSetMetaDataSupplier, XCancellable, XWarningsSupplier, XCloseable, XColumnLocate>::s_aCD = ClassData7( 4 );
	ClassData11 WeakComponentImplHelper11<XResultSet, XRow, XResultSetMetaDataSupplier, XCancellable, XWarningsSupplier, XResultSetUpdate, XRowUpdate, XCloseable, XColumnLocate, XServiceInfo, XUnoTunnel>::s_aCD = ClassData11( 4 );
	ClassData4 WeakComponentImplHelper4<XStatement, XWarningsSupplier, XCancellable, XCloseable>::s_aCD = ClassData4( 4 );

}

#ifndef _COMPHELPER_PROPERTY_ARRAY_HELPER_HXX_
#include <comphelper/proparrhlp.hxx>
#endif

#include <file/FDatabaseMetaDataResultSet.hxx>
#include <file/FResultSet.hxx>
#include <file/FStatement.hxx>
#include <connectivity/PColumn.hxx>
#include <connectivity/sdbcx/VIndex.hxx>
#include <connectivity/sdbcx/VIndexColumn.hxx>
#include <connectivity/sdbcx/VColumn.hxx>
#include <connectivity/sdbcx/VKeyColumn.hxx>
#include <connectivity/sdbcx/VUser.hxx>
#include <connectivity/sdbcx/VGroup.hxx>
#include <connectivity/sdbcx/VTable.hxx>
#include <connectivity/sdbcx/VKey.hxx>
#include <connectivity/sdbcx/VView.hxx>

using namespace connectivity::file;
using namespace connectivity::parse;
using namespace connectivity::sdbcx;


namespace comphelper {

	sal_Int32 OPropertyArrayUsageHelper<ODatabaseMetaDataResultSet>::s_nRefCount = 0;
	::cppu::IPropertyArrayHelper *OPropertyArrayUsageHelper<ODatabaseMetaDataResultSet>::s_pProps = NULL;
	::osl::Mutex OPropertyArrayUsageHelper<ODatabaseMetaDataResultSet>::s_aMutex;
	sal_Int32 OPropertyArrayUsageHelper<OResultSet>::s_nRefCount = 0;
	::cppu::IPropertyArrayHelper *OPropertyArrayUsageHelper<OResultSet>::s_pProps = NULL;
	::osl::Mutex OPropertyArrayUsageHelper<OResultSet>::s_aMutex;
	sal_Int32 OPropertyArrayUsageHelper<OStatement_Base>::s_nRefCount = 0;
	::cppu::IPropertyArrayHelper *OPropertyArrayUsageHelper<OStatement_Base>::s_pProps = NULL;
	::osl::Mutex OPropertyArrayUsageHelper<OStatement_Base>::s_aMutex;
	sal_Int32 OPropertyArrayUsageHelper<OParseColumn>::s_nRefCount = 0;
	::cppu::IPropertyArrayHelper *OPropertyArrayUsageHelper<OParseColumn>::s_pProps = NULL;
	::osl::Mutex OPropertyArrayUsageHelper<OParseColumn>::s_aMutex;
	sal_Int32 OPropertyArrayUsageHelper<OIndex>::s_nRefCount = 0;
	::cppu::IPropertyArrayHelper *OPropertyArrayUsageHelper<OIndex>::s_pProps = NULL;
	::osl::Mutex OPropertyArrayUsageHelper<OIndex>::s_aMutex;
	sal_Int32 OPropertyArrayUsageHelper<OIndexColumn>::s_nRefCount = 0;
	::cppu::IPropertyArrayHelper *OPropertyArrayUsageHelper<OIndexColumn>::s_pProps = NULL;
	::osl::Mutex OPropertyArrayUsageHelper<OIndexColumn>::s_aMutex;
	sal_Int32 OPropertyArrayUsageHelper<OColumn>::s_nRefCount = 0;
	::cppu::IPropertyArrayHelper *OPropertyArrayUsageHelper<OColumn>::s_pProps = NULL;
	::osl::Mutex OPropertyArrayUsageHelper<OColumn>::s_aMutex;
	sal_Int32 OPropertyArrayUsageHelper<OKeyColumn>::s_nRefCount = 0;
	::cppu::IPropertyArrayHelper *OPropertyArrayUsageHelper<OKeyColumn>::s_pProps = NULL;
	::osl::Mutex OPropertyArrayUsageHelper<OKeyColumn>::s_aMutex;
    sal_Int32 OPropertyArrayUsageHelper<OGroup>::s_nRefCount = 0;
    ::cppu::IPropertyArrayHelper *OPropertyArrayUsageHelper<OGroup>::s_pProps = NULL;
    ::osl::Mutex OPropertyArrayUsageHelper<OGroup>::s_aMutex;
    sal_Int32 OPropertyArrayUsageHelper<OUser>::s_nRefCount = 0;
    ::cppu::IPropertyArrayHelper *OPropertyArrayUsageHelper<OUser>::s_pProps = NULL;
    ::osl::Mutex OPropertyArrayUsageHelper<OUser>::s_aMutex;
    sal_Int32 OPropertyArrayUsageHelper<OTable>::s_nRefCount = 0;
    ::cppu::IPropertyArrayHelper *OPropertyArrayUsageHelper<OTable>::s_pProps = NULL;
    ::osl::Mutex OPropertyArrayUsageHelper<OTable>::s_aMutex;
    sal_Int32 OPropertyArrayUsageHelper<OKey>::s_nRefCount = 0;
    ::cppu::IPropertyArrayHelper *OPropertyArrayUsageHelper<OKey>::s_pProps = NULL;
    ::osl::Mutex OPropertyArrayUsageHelper<OKey>::s_aMutex;
    sal_Int32 OPropertyArrayUsageHelper<OView>::s_nRefCount = 0;
    ::cppu::IPropertyArrayHelper *OPropertyArrayUsageHelper<OView>::s_pProps = NULL;
    ::osl::Mutex OPropertyArrayUsageHelper<OView>::s_aMutex;

}
