/*************************************************************************
 *
 *  $RCSfile: docfilter.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: fs $ $Date: 2001/05/15 09:39:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc..
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _EXTENSIONS_DBI_DOCFILTER_HXX_
#define _EXTENSIONS_DBI_DOCFILTER_HXX_

#ifndef _COM_SUN_STAR_DOCUMENT_XTYPEDETECTION_HPP_ 
#include <com/sun/star/document/XTypeDetection.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMEACCESS_HPP_ 
#include <com/sun/star/container/XNameAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_ 
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _COM_SUN_STAR_IO_XINPUTSTREAM_HPP_
#include <com/sun/star/io/XInputStream.hpp>
#endif

class Window;
//.........................................................................
namespace dbi
{
//.........................................................................

	/// a (rather rudimentary) filter descriptor
	struct FilterDescriptor
	{
		::rtl::OUString		sName;
		::rtl::OUString		sExtension;
	};

	//=====================================================================
	//= ODocumentFilterInfo
	//=====================================================================
	class ODocumentFilterInfo
	{
	protected:
		::com::sun::star::uno::Reference< ::com::sun::star::document::XTypeDetection >		
							m_xTypeDetection;
		::com::sun::star::uno::Reference< ::com::sun::star::container::XNameAccess >
							m_xAvailableTypes;
		::com::sun::star::uno::Reference< ::com::sun::star::container::XNameAccess >
							m_xFilterFactory;

	public:
		ODocumentFilterInfo(
			const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& _rxORB,
			Window* _pErrorParent
		);

		FilterDescriptor	getFilter( const ::rtl::OUString& _rFileName );
		FilterDescriptor	getPreferedFilter( const ::rtl::OUString& _rFileName );

		FilterDescriptor	getFilter( const ::com::sun::star::uno::Reference< ::com::sun::star::io::XInputStream >& _rxSource );
		FilterDescriptor	getPreferedFilter( const ::com::sun::star::uno::Reference< ::com::sun::star::io::XInputStream >& _rxSource );

		FilterDescriptor	getPreferedFilter( const FilterDescriptor& _rFilter );

		sal_Bool			isValid( ) const { return m_xAvailableTypes.is(); }

	protected:
		::rtl::OUString				implGetTypeDescription( const ::rtl::OUString& _rFileName );
		::rtl::OUString				implGetTypeDescription( const ::com::sun::star::uno::Reference< ::com::sun::star::io::XInputStream >& _rxSource );

		::com::sun::star::uno::Any	implLookupPropertyValue( const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& _rProps, const sal_Char* _pProperty );
		::com::sun::star::uno::Any	implLookupFilterProperty( const ::rtl::OUString& _rFileName, const sal_Char* _pProperty );
		::rtl::OUString				implLookupExtension( const ::rtl::OUString& _rFilterAndTypeName );

		void implGetPreferedFilter( FilterDescriptor& _rDesc );
	};

//.........................................................................
}	// namespace dbi
//.........................................................................

#endif // _EXTENSIONS_DBI_DOCFILTER_HXX_

/*************************************************************************
 * history:
 *	$Log: docfilter.hxx,v $
 *	Revision 1.3  2001/05/15 09:39:51  fs
 *	#85437# new getPreferredFilter versions
 *	
 *	Revision 1.2  2001/04/03 06:23:38  fs
 *	#85437# +getFilter(XInputStream)
 *	
 *	Revision 1.1  2001/04/02 15:53:44  fs
 *	initial checkin - encapuslating document filters
 *	
 *
 *	Revision 1.0 02.04.01 15:39:32  fs
 ************************************************************************/

