/*************************************************************************
 *
 *  $RCSfile: fixededit.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: fs $ $Date: 2001/02/20 10:30:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc..
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _EXTENSIONS_DBI_FIXEDEDIT_HXX_
#include "fixededit.hxx"
#endif
#ifndef _SV_SVAPP_HXX 
#include <vcl/svapp.hxx>
#endif

//.........................................................................
namespace dbi
{
//.........................................................................

	//=====================================================================
	//= GrayedControl
	//=====================================================================
	//---------------------------------------------------------------------
	void GrayedControl::implSetColors(Control* _pControl, sal_Bool _bGray)
	{
		StyleSettings aSystemStyle = Application::GetSettings().GetStyleSettings();
		const Color& rNewColor = _bGray ? aSystemStyle.GetDialogColor() : aSystemStyle.GetFieldColor();
		_pControl->SetBackground(Wallpaper(rNewColor));
		_pControl->SetControlBackground(rNewColor);
	}

	//=====================================================================
	//= FixedEdit
	//=====================================================================
	//---------------------------------------------------------------------
	FixedEdit::FixedEdit( Window* _pParent, const ResId& _rResId )
		:Edit(_pParent, _rResId)
	{
		implSetColors(this);
	}

	//=====================================================================
	//= FixedMultiEdit
	//=====================================================================
	//---------------------------------------------------------------------
	FixedMultiEdit::FixedMultiEdit( Window* _pParent, const ResId& _rResId )
		:MultiLineEdit(_pParent, _rResId)
	{
		implSetColors(this);
	}

	//=====================================================================
	//= AutoFixedEdit
	//=====================================================================
	//---------------------------------------------------------------------
	AutoFixedEdit::AutoFixedEdit( Window* _pParent, const ResId& _rResId )
		:FixedEdit(_pParent, _rResId)
	{
		implSetColors(this, !IsEnabled());
	}

	//---------------------------------------------------------------------
	void AutoFixedEdit::StateChanged( StateChangedType _nStateChange )
	{
		FixedEdit::StateChanged(_nStateChange);
		if (STATE_CHANGE_ENABLE == _nStateChange)
			implSetColors(this, !IsEnabled());
	}

//.........................................................................
}	// namespace dbi
//.........................................................................

/*************************************************************************
 * history:
 *	$Log: fixededit.cxx,v $
 *	Revision 1.2  2001/02/20 10:30:55  fs
 *	added pictures to the pages
 *	
 *	Revision 1.1  2001/02/12 07:12:28  fs
 *	initial checkin - importing StarOffice 5.2 database files
 *	
 *
 *	Revision 1.0 31.01.01 15:59:54  fs
 ************************************************************************/

