/*************************************************************************
 *
 *  $RCSfile: InteractionContinuation.cxx,v $
 *
 *  $Revision: 1.1 $
 *
 *  last change: $Author: mtg $ $Date: 2001/07/04 14:56:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _INTERACTION_CONTINUATION_HXX_
#include <InteractionContinuation.hxx>
#endif
#ifndef _RTL_UUID_H_
#include <rtl/uuid.h>
#endif

using namespace ::rtl;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::task;
using namespace ::com::sun::star::lang;

InteractionContinuation::InteractionContinuation( sal_uInt16 ErrorContinuation )
: mbSelected( sal_False )
, mEC( ErrorContinuation )
{
}

InteractionContinuation::~InteractionContinuation ()
{
}

void SAL_CALL InteractionApprove::select(void) throw(RuntimeException)
{
	mbSelected = sal_True;
}

void SAL_CALL InteractionDisapprove::select(void) throw(RuntimeException)
{
	mbSelected = sal_True;
}

void SAL_CALL InteractionRetry::select(void) throw(RuntimeException)
{
	mbSelected = sal_True;
}

void SAL_CALL InteractionAbort::select(void) throw(RuntimeException)
{
	mbSelected = sal_True;
}

const Sequence< sal_Int8 > & InteractionContinuation::getUnoTunnelId() throw()
{
	static Sequence< sal_Int8 > * pSeq = 0;
	if( !pSeq )
	{
		::osl::Guard< ::osl::Mutex > aGuard( ::osl::Mutex::getGlobalMutex() );
		if( !pSeq )
		{
			static Sequence< sal_Int8 > aSeq( 16 );
			rtl_createUuid( (sal_uInt8*)aSeq.getArray(), 0, sal_True );
			pSeq = &aSeq;
		}
	}
	return *pSeq;
}
\
InteractionContinuation* InteractionContinuation::getImplementation( Reference< XInterface > xInt ) throw()
{
	Reference< ::com::sun::star::lang::XUnoTunnel > xUT( xInt, UNO_QUERY );
	if( xUT.is() )
		return (InteractionContinuation*)xUT->getSomething( InteractionContinuation::getUnoTunnelId() );
	else
		return NULL;
}
\
sal_Int64 SAL_CALL InteractionContinuation::getSomething( const Sequence< sal_Int8 >& rId ) throw(RuntimeException)
{
	if( rId.getLength() == 16 && 0 == rtl_compareMemory( getUnoTunnelId().getConstArray(),
														 rId.getConstArray(), 16 ) )
	{
		return (sal_Int64)this;
	}
	return 0;
}

Any SAL_CALL InteractionRetry::queryInterface( const Type& rType ) 
	throw(RuntimeException)
{
		return ::cppu::queryInterface ( rType,
										// OWeakObject interfaces
										reinterpret_cast< XInterface*		> ( this ),
										static_cast< XWeak*					> ( this ),
										// my own interfaces
							   			static_cast< XInteractionRetry*> ( this ), 
							   			static_cast< XUnoTunnel*			> ( this ) );
}

Any SAL_CALL InteractionApprove::queryInterface( const Type& rType ) 
	throw(RuntimeException)
{
		return ::cppu::queryInterface ( rType,
										// OWeakObject interfaces
										reinterpret_cast< XInterface*		> ( this ),
										static_cast< XWeak*					> ( this ),
										// my own interfaces
							   			static_cast< XInteractionApprove*> ( this ), 
							   			static_cast< XUnoTunnel*			> ( this ) );
}

Any SAL_CALL InteractionDisapprove::queryInterface( const Type& rType ) 
	throw(RuntimeException)
{
		return ::cppu::queryInterface ( rType,
										// OWeakObject interfaces
										reinterpret_cast< XInterface*		> ( this ),
										static_cast< XWeak*					> ( this ),
										// my own interfaces
							   			static_cast< XInteractionDisapprove*> ( this ), 
							   			static_cast< XUnoTunnel*			> ( this ) );
}

Any SAL_CALL InteractionAbort::queryInterface( const Type& rType ) 
	throw(RuntimeException)
{
		return ::cppu::queryInterface ( rType,
										// OWeakObject interfaces
										reinterpret_cast< XInterface*		> ( this ),
										static_cast< XWeak*					> ( this ),
										// my own interfaces
							   			static_cast< XInteractionAbort*		> ( this ), 
							   			static_cast< XUnoTunnel*			> ( this ) );
}
