/*************************************************************************
 *
 *  $RCSfile: InteractionContinuation.hxx,v $
 *
 *  $Revision: 1.1 $
 *
 *  last change: $Author: mtg $ $Date: 2001/07/04 14:56:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _INTERACTION_CONTINUATION_HXX_
#define _INTERACTION_CONTINUATION_HXX_

#ifndef _CPPUHELPER_WEAK_HXX
#include <cppuhelper/weak.hxx>
#endif
#ifndef _COM_SUN_STAR_TASK_XINTERACTIONCONTINUATION_HPP_
#include <com/sun/star/task/XInteractionContinuation.hpp>
#endif
#ifndef _COM_SUN_STAR_TASK_XINTERACTIONRETRY_HPP_
#include <com/sun/star/task/XInteractionRetry.hpp>
#endif
#ifndef _COM_SUN_STAR_TASK_XINTERACTIONAPPROVE_HPP_
#include <com/sun/star/task/XInteractionApprove.hpp>
#endif
#ifndef _COM_SUN_STAR_TASK_XINTERACTIONDISAPPROVE_HPP_
#include <com/sun/star/task/XInteractionDisapprove.hpp>
#endif
#ifndef _COM_SUN_STAR_TASK_XINTERACTIONABORT_HPP_
#include <com/sun/star/task/XInteractionAbort.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_XUNOTUNNEL_HPP_
#include <com/sun/star/lang/XUnoTunnel.hpp>
#endif
#ifndef _ERROR_CODES_HXX_
#include <ErrorCodes.hxx>
#endif

class InteractionContinuation: public cppu::OWeakObject,
							   public com::sun::star::lang::XUnoTunnel
{
protected:
	sal_Bool	mbSelected;
	sal_uInt16	mEC;
	InteractionContinuation( sal_uInt16 ErrorContinuation );
public:

	virtual ~InteractionContinuation ();
	sal_Bool isSelected() const { return mbSelected; }
	sal_uInt16 getErrorContinuation() const { return mEC; }

	static const ::com::sun::star::uno::Sequence< sal_Int8 > & getUnoTunnelId() 
		throw();
	static InteractionContinuation* getImplementation( ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > xInt ) 
		throw();
    virtual sal_Int64 SAL_CALL getSomething( const ::com::sun::star::uno::Sequence< sal_Int8 >& aIdentifier ) 
		throw(::com::sun::star::uno::RuntimeException);
};
class InteractionApprove : public InteractionContinuation,
						   public com::sun::star::task::XInteractionApprove
{
public:
	InteractionApprove() : InteractionContinuation ( EC_YES ) {}
    virtual ::com::sun::star::uno::Any SAL_CALL queryInterface( const ::com::sun::star::uno::Type& rType ) 
		throw(::com::sun::star::uno::RuntimeException);
	virtual void SAL_CALL select(void) 
		throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL acquire(  ) throw () { OWeakObject::acquire(); }
    virtual void SAL_CALL release(  ) throw () { OWeakObject::release(); }

};
class InteractionDisapprove : public InteractionContinuation,
							  public com::sun::star::task::XInteractionDisapprove 
{
public:
	InteractionDisapprove() : InteractionContinuation ( EC_NO ) {}
    virtual ::com::sun::star::uno::Any SAL_CALL queryInterface( const ::com::sun::star::uno::Type& rType ) 
		throw(::com::sun::star::uno::RuntimeException);
	virtual void SAL_CALL select(void) 
		throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL acquire(  ) throw () { OWeakObject::acquire(); }
    virtual void SAL_CALL release(  ) throw () { OWeakObject::release(); }

};
class InteractionRetry : public InteractionContinuation,
						 public com::sun::star::task::XInteractionRetry
{
public:
	InteractionRetry() : InteractionContinuation ( EC_RETRY ) {}
    virtual ::com::sun::star::uno::Any SAL_CALL queryInterface( const ::com::sun::star::uno::Type& rType ) 
		throw(::com::sun::star::uno::RuntimeException);
	virtual void SAL_CALL select(void) 
		throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL acquire(  ) throw () { OWeakObject::acquire(); }
    virtual void SAL_CALL release(  ) throw () { OWeakObject::release(); }

};
class InteractionAbort : public InteractionContinuation,
					     public com::sun::star::task::XInteractionAbort
{
public:
	InteractionAbort() : InteractionContinuation ( EC_ABORT ) {}
    virtual ::com::sun::star::uno::Any SAL_CALL queryInterface( const ::com::sun::star::uno::Type& rType ) 
		throw(::com::sun::star::uno::RuntimeException);
	virtual void SAL_CALL select(void) 
		throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL acquire(  ) throw () { OWeakObject::acquire(); }
    virtual void SAL_CALL release(  ) throw () { OWeakObject::release(); }

};
#endif
