/*************************************************************************
 *
 *  $RCSfile: filedlg2.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: pl $ $Date: 2001/07/09 15:46:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif
#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif
#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#include <filedlg2.hxx>
#include <filedlg.hxx>
#include <filedlg2.hrc>

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _VOS_SECURITY_HXX_
#include <vos/security.hxx>
#endif

#ifdef VCL
#include <vcl/rcid.h>
#endif

#include <helper.hxx>

DECLARE_LIST( StringList, String* );

#define STD_BTN_WIDTH	80
#define STD_BTN_HEIGHT	26

#define ALLFILES				"*"
//		#define STD_BTN_WIDTH	90
//		#define STD_BTN_HEIGHT	35


#define INITCONTROL( p, ControlClass, nBits, aPos, aSize, aTitel, nHelpId ) \
	p = new ControlClass( GetPathDialog(), WinBits( nBits ) ); \
	p->SetHelpId( nHelpId ); \
	p->SetPosSizePixel( aPos, aSize ); \
	p->SetText( aTitel ); \
	p->Show();


using namespace padmin;

long
KbdListBox::PreNotify( NotifyEvent& rNEvt )
{
	if ( rNEvt.GetType() == EVENT_KEYINPUT )
	{
		KeyEvent aKeyEvt		= *rNEvt.GetKeyEvent();
		sal_Unicode	 cCharCode	= aKeyEvt.GetCharCode();

		if ( cCharCode >= 32 && cCharCode != 127 )
		{
			USHORT nCurrentPos = GetSelectEntryPos();
			USHORT nEntries    = GetEntryCount();

			for ( USHORT i = 1; i < nEntries; i++ )
			{
				String aEntry = GetEntry ( (i + nCurrentPos) % nEntries );
				aEntry.EraseLeadingChars( ' ' );

				if ( aEntry.CompareIgnoreCaseToAscii( &cCharCode, 1 ) == COMPARE_EQUAL )
				{
					SelectEntryPos ( (i + nCurrentPos) % nEntries );
					break;
				}
			}
		}
		else
		if ( aKeyEvt.GetKeyCode().GetCode() == KEY_RETURN )
		{
			DoubleClick();
		}
	}

	return ListBox::PreNotify ( rNEvt );
}

ImpPathDialog::ImpPathDialog( PathDialog* pDlg, WinBits nWinBits, RESOURCE_TYPE nType )
{
	pSvPathDialog = pDlg;
	nDirCount = 0;

	// initialize Controls if not used as a base class
	if ( nType == WINDOW_PATHDIALOG )
		InitControls();
}

ImpPathDialog::~ImpPathDialog()
{
	delete pEdit;
	delete pDirTitel;
	delete pDirList;
	delete pDirPath;
	delete pDriveList;
	delete pDriveTitle;
	delete pLoadBtn;
	delete pOkBtn;
	delete pCancelBtn;
	delete pNewDirBtn;
#	ifdef UNX
	delete pHomeBtn;
#	endif
}

void ImpPathDialog::InitControls()
{
	PathDialog* pDlg = GetPathDialog();
	pDlg->SetText( String( PaResId( STR_FILEDLG_SELECT ) ) );

	Size a3Siz = pDlg->LogicToPixel( Size( 3, 3 ), MAP_APPFONT );
	Size a6Siz = pDlg->LogicToPixel( Size( 6, 6 ), MAP_APPFONT );
	Size aBtnSiz = pDlg->LogicToPixel( Size( 70, 14 ), MAP_APPFONT );
	Size aFTSiz = pDlg->LogicToPixel( Size( 142, 10 ), MAP_APPFONT );
	Size aEDSiz = pDlg->LogicToPixel( Size( 142, 12 ), MAP_APPFONT );
	Point aPnt( a6Siz.Width(), a6Siz.Height() );
	long nLbH1 = pDlg->LogicToPixel( Size( 0, 93 ), MAP_APPFONT ).Height();
	long nLbH2 = pDlg->LogicToPixel( Size( 0, 60 ), MAP_APPFONT ).Height();
	long nH = 0;
	String aEmptyStr;

	INITCONTROL( pDirTitel, FixedText, 0,
				 aPnt, aFTSiz, String( PaResId( STR_FILEDLG_DIR ) ), 0 );
	aPnt.Y() += aFTSiz.Height() + a3Siz.Height();
	INITCONTROL( pEdit, Edit, WB_BORDER, aPnt, aEDSiz, aPath.GetFull(), 0 );

	aPnt.Y() += aEDSiz.Height() + a3Siz.Height();
	long nNewH = nLbH1 + 3 * a3Siz.Height() +
				 aFTSiz.Height() + aEDSiz.Height();
	INITCONTROL( pDirList, KbdListBox, WB_AUTOHSCROLL | WB_BORDER,
				 aPnt, Size( aEDSiz.Width(), nNewH ), aEmptyStr, 0 );
	nH = aPnt.Y() + nNewH + a6Siz.Height();
	pDriveTitle = NULL;
	pDriveList = NULL;

	aPnt.X() = 2 * a6Siz.Width() + aEDSiz.Width();
	aPnt.Y() = a6Siz.Height();
	INITCONTROL( pOkBtn, PushButton, WB_DEFBUTTON,
				 aPnt, aBtnSiz, Button::GetStandardText( BUTTON_OK ), 0 );
	aPnt.Y() += aBtnSiz.Height() + a3Siz.Height();
	INITCONTROL( pCancelBtn, CancelButton, 0,
				 aPnt, aBtnSiz, Button::GetStandardText( BUTTON_CANCEL ), 0 );
	aPnt.Y() += aBtnSiz.Height() + a3Siz.Height();
	INITCONTROL( pNewDirBtn, PushButton, WB_DEFBUTTON,
				 aPnt, aBtnSiz, String( PaResId( STR_FILEDLG_NEWDIR ) ), 0 );
	aPnt.Y() += aBtnSiz.Height() + a3Siz.Height();
	INITCONTROL( pHomeBtn, PushButton, WB_DEFBUTTON,
				 aPnt, aBtnSiz, String( PaResId( STR_FILEDLG_HOME ) ), 0 );

	pDirPath = 0;
	pLoadBtn = 0;
	// Dialogbreite == OKBtn-Position + OKBtn-Breite + Rand
	long nW = aPnt.X() + aBtnSiz.Width() + a6Siz.Width();

	pDlg->SetOutputSizePixel( Size( nW, nH ) );  // Groesse ggf. auch Resource wird geplaettet?

	if (pDirList)
		pDirList->SetDoubleClickHdl(LINK( this, ImpPathDialog, DblClickHdl) );

	if (pDirList)
		pDirList->SetSelectHdl( LINK( this, ImpPathDialog, SelectHdl ) );

	if (pDriveList)
		pDriveList->SetSelectHdl( LINK( this, ImpPathDialog, SelectHdl ) );

	if (pOkBtn)
		pOkBtn->SetClickHdl( LINK( this, ImpPathDialog, ClickHdl) );

	if (pCancelBtn)
		pCancelBtn->SetClickHdl( LINK( this, ImpPathDialog, ClickHdl) );

	if (pHomeBtn)
		pHomeBtn->SetClickHdl( LINK( this, ImpPathDialog, ClickHdl) );

	if (pNewDirBtn)
		pNewDirBtn->SetClickHdl( LINK( this, ImpPathDialog, ClickHdl) );

	nOwnChilds = pDlg->GetChildCount();
}



IMPL_LINK( ImpPathDialog, SelectHdl, ListBox *, p )
{
	if( p == pDriveList )
	{
		String aDrive ( pDriveList->GetSelectEntry(), 0, 2);
		pEdit->SetText( aDrive );
		// pEdit->SetText( pDriveList->GetSelectEntry() );
		ClickHdl( pOkBtn );
	}
	else
	if( p == pDirList )
	{
		// isolate the pure name of the entry
		// removing trainling stuff and leading spaces
		String aEntry( pDirList->GetSelectEntry() );

		aEntry.EraseLeadingChars( ' ' );
		USHORT nPos = aEntry.Search( '/' );
		aEntry.Erase( nPos );

		// build the absolute path to the selected item
		DirEntry aNewPath;
		aNewPath.ToAbs();

		USHORT nCurPos = pDirList->GetSelectEntryPos();

		// Wird nach oben gewechselt
		if( nCurPos < nDirCount )
			aNewPath = aNewPath[nDirCount-nCurPos-1];
		else
			aNewPath += aEntry;

		pEdit->SetText( aNewPath.GetFull() );
	}

	return 0;
}


IMPL_LINK( ImpPathDialog, ClickHdl, Button*, pBtn )
{
	if ( pBtn == pOkBtn || pBtn == pLoadBtn )
	{
		DirEntry aFile( pEdit->GetText() );

		// Existiert File / File ueberschreiben
		if( IsFileOk( aFile ) )
		{
			// Ja, dann kompletten Pfad mit Filenamen merken und Dialog beenden
			aPath = aFile;
			aPath.ToAbs();
			GetPathDialog()->EndDialog( TRUE );
		}
		else
		{
			aFile.ToAbs();
			SetPath( aFile.GetFull() );
			pEdit->SetSelection( Selection( 0x7FFFFFFF, 0x7FFFFFFF ) );
		}
	}
	else
	if ( pBtn == pCancelBtn )
	{
		GetPathDialog()->EndDialog( FALSE );
	}
	else
	if ( pBtn == pHomeBtn )
	{
		::rtl::OUString aHomeDir;
		NAMESPACE_VOS( OSecurity ) aSecurity;
		if ( aSecurity.getHomeDir(aHomeDir) )
		{
			DirEntry aFile ( aHomeDir );
			if ( IsFileOk( aFile ) )
			{
				aFile.ToAbs();
				SetPath( aFile.GetFull() );
			}
		}
	}
	else
	if ( pBtn == pNewDirBtn )
	{
		DirEntry aFile( pEdit->GetText() );
		if( ! aFile.Exists() && ! FileStat( aFile ).IsKind( FSYS_KIND_WILD ) )
			aFile.MakeDir();

		if( IsFileOk ( aFile ) )
		{
			aFile.ToAbs();
			SetPath( aFile.GetFull() );
		}
	}

	return 0;
}


IMPL_LINK( ImpPathDialog, DblClickHdl, ListBox*, pBox )
{
	// isolate the pure name of the entry
	// removing trainling stuff and leading spaces
	String aEntry( pBox->GetSelectEntry() );

	aEntry.EraseLeadingChars( ' ' );
	USHORT nPos = aEntry.Search( '/' );
	aEntry.Erase( nPos );

	// build the absolute path to the selected item
	DirEntry aNewPath;
	aNewPath.ToAbs();
	if( pBox == pDirList )
	{
		USHORT nCurPos = pDirList->GetSelectEntryPos();

		// Wenn es schon das aktuelle ist, dann mache nichts
		if( nCurPos == nDirCount-1 )
			return 0;

		// Wird nach oben gewechselt
		if( nCurPos < nDirCount )
			aNewPath = aNewPath[nDirCount-nCurPos-1];
		else
			aNewPath += aEntry;
	}
	else
		aNewPath += aEntry;

	USHORT nCurPos = pBox->GetSelectEntryPos();

	Application::EnterWait();

	if( FileStat( aNewPath ).GetKind() & FSYS_KIND_DIR )
	{
		// Neuen Pfad setzen und Listboxen updaten
		aPath = aNewPath;
		if( !aPath.SetCWD( TRUE ) )
		{
			ErrorBox aBox( GetPathDialog(),
						   WB_OK_CANCEL | WB_DEF_OK,
						   String( PaResId( STR_FILEDLG_CANTCHDIR ) ) );
			if( aBox.Execute() == RET_CANCEL )
				GetPathDialog()->EndDialog( FALSE );
		}
		UpdateEntries( TRUE );
	}

	Application::LeaveWait();
	return 0;
}

void ImpPathDialog::UpdateEntries( const BOOL dummy_bWithDirs )
{
	String aTabString;
	DirEntry aTmpPath;
	aTmpPath.ToAbs();
	nDirCount = aTmpPath.Level();

	pDirList->SetUpdateMode( FALSE );
	pDirList->Clear();

	for( USHORT i = nDirCount; i > 0; i-- )
	{
		String aName( aTabString );
		aName += aTmpPath[i-1].GetName();
		pDirList->InsertEntry( aName );
		aTabString += ' ';
		aTabString += ' ';
	}

	// scan the directory
	DirEntry aCurrent;
	aCurrent.ToAbs();
	Dir aDir( aCurrent, FSYS_KIND_DIR|FSYS_KIND_FILE );

	USHORT nEntries = aDir.Count();
	if( nEntries )
	{
		StringList aSortDirList;
		for ( USHORT n = 0; n < nEntries; n++ )
		{
			DirEntry& rEntry = aDir[n];
			String aName( rEntry.GetName() );
			if( aName.Len() && ( aName.GetChar(0) != '.' ) && rEntry.Exists() )
			{
				if( FileStat( rEntry ).GetKind() & FSYS_KIND_DIR )
				{
					ULONG l;
					for( l = 0; l < aSortDirList.Count(); l++ )
						if( *aSortDirList.GetObject(l) > aName )
							break;
					aSortDirList.Insert( new String( aName ), l );
				}
			}
		}

		for( ULONG l = 0; l < aSortDirList.Count(); l++ )
		{
			String aEntryStr( aTabString );
			aEntryStr += *aSortDirList.GetObject(l);
			pDirList->InsertEntry( aEntryStr );
			delete aSortDirList.GetObject(l);
		}
	}

	UpdateDirs( aTmpPath );
}

void ImpPathDialog::UpdateDirs( const DirEntry& rTmpPath )
{
	pDirList->SelectEntryPos( nDirCount-1 );
	pDirList->SetTopEntry( nDirCount > 1
						   ? nDirCount - 2
						   : nDirCount - 1 );
	pDirList->SetUpdateMode( TRUE );
	pDirList->Invalidate();
	pDirList->Update();

	String aDirName = rTmpPath.GetFull();
	if( pDirPath )
		pDirPath->SetText( aDirName );
	else
		pEdit->SetText( aDirName );
}

BOOL ImpPathDialog::IsFileOk( const DirEntry& rDirEntry )
{
	if( FileStat( rDirEntry ).GetKind() & (FSYS_KIND_WILD | FSYS_KIND_DEV) )
		return FALSE;
	else
	{
		// Datei vorhanden ?
		if( ! rDirEntry.Exists() )
		{
			String aQueryTxt( PaResId( STR_FILEDLG_ASKNEWDIR ) );
			aQueryTxt.SearchAndReplaceAscii( "%s", rDirEntry.GetFull() );
			QueryBox aQuery( GetPathDialog(),
							 WB_YES_NO | WB_DEF_YES,
							 aQueryTxt	);
			if( aQuery.Execute() == RET_YES )
				rDirEntry.MakeDir();
			else
				return FALSE;
		}
		if( !FileStat( rDirEntry ).IsKind( FSYS_KIND_DIR ) )
		{
			String aBoxText( PaResId( STR_FILEDLG_CANTOPENDIR ) );
			aBoxText += '\n';
			aBoxText +=	'[';
			aBoxText += rDirEntry.GetFull();
			aBoxText += ']';
			InfoBox aBox( GetPathDialog(), aBoxText );
			aBox.Execute();
			return FALSE;
		}
	}
	return GetPathDialog()->OK() != 0;
}


void ImpPathDialog::PreExecute()
{
	// Neues Verzeichnis setzen und Listboxen updaten
	aPath.SetCWD( TRUE );
	UpdateEntries( TRUE );

	// Zusaetzliche Buttons anordnen
	Point	aPos;
	Size	aSize;
	long	nDY;
	if( pLoadBtn )
	{
		aPos  = pLoadBtn->GetPosPixel();
		aSize = pLoadBtn->GetSizePixel();
		nDY   = pLoadBtn->GetSizePixel().Height() * 2;
	}
	else
	{
		aPos  = pCancelBtn->GetPosPixel();
		aSize = pCancelBtn->GetSizePixel();
		nDY   = pCancelBtn->GetPosPixel().Y() - pOkBtn->GetPosPixel().Y();
	}

	// Standard-Controls anpassen
	long nMaxWidth = 0;

	// Maximale Breite ermitteln
	USHORT nChilds = GetPathDialog()->GetChildCount();
	USHORT n;
	for ( n = nOwnChilds; n < nChilds; n++ )
	{
		Window* pChild = GetPathDialog()->GetChild( n );
		pChild = pChild->GetWindow( WINDOW_CLIENT );
		if( pChild->GetType() != WINDOW_WINDOW )
		{
			long nWidth = pChild->GetTextWidth( pChild->GetText() ) + 12;
			if( nMaxWidth < nWidth )
				nMaxWidth = nWidth;
			nWidth = pChild->GetSizePixel().Width();
			if( nMaxWidth < nWidth )
				nMaxWidth = nWidth;
		}
	}

	if( nMaxWidth > aSize.Width() )
	{
		Size aDlgSize = GetPathDialog()->GetOutputSizePixel();
		GetPathDialog()->SetOutputSizePixel( Size( aDlgSize.Width()+nMaxWidth-aSize.Width(), aDlgSize.Height() ) );
		aSize.Width() = nMaxWidth;

		if( pOkBtn )
			pOkBtn->SetSizePixel( aSize );
		if( pCancelBtn )
			pCancelBtn->SetSizePixel( aSize );
		if( pLoadBtn )
			pLoadBtn->SetSizePixel( aSize );
	}
	else
		nMaxWidth = aSize.Width();

	for ( n = nOwnChilds; n < nChilds; n++ )
	{
		Window* pChild = GetPathDialog()->GetChild( n );
		pChild = pChild->GetWindow( WINDOW_CLIENT );
		if( pChild->GetType() != WINDOW_WINDOW )
		{
			aPos.Y() += nDY;
			pChild->SetPosSizePixel( aPos, aSize );
		}
		else
		{
			Size aDlgSize = GetPathDialog()->GetOutputSizePixel();
			long nExtra = Min( aDlgSize.Height(), (long)160);
			GetPathDialog()->SetOutputSizePixel( Size( aDlgSize.Width()+nExtra, aDlgSize.Height() ) );
			Size aSz( nExtra, nExtra );
			aSz.Width() -= 8;
			aSz.Height() -= 8;
			Point aCtrlPos( aDlgSize.Width() + 2, (aDlgSize.Height()-aSz.Height())/2 );
			pChild->SetPosSizePixel( aCtrlPos, aSz );
		}
	}

	// Laufwerke-LB fuellen
	if( pDriveList )
	{
		DirEntry aTmpDirEntry;
		Dir aDir( aTmpDirEntry, FSYS_KIND_BLOCK );

		USHORT nCount = aDir.Count(), i;
		for( i = 0; i < nCount; ++i )
		{
			DirEntry& rEntry = aDir[i];
			String aStr    = rEntry.GetFull( FSYS_STYLE_HOST, FALSE );

			String aVolume = rEntry.GetVolume() ;
			if ( aVolume.Len() )
				pDriveList->InsertEntry(
					aStr.ToUpperAscii().Append( ' ' ).Append( aVolume )
					);
			else
				pDriveList->InsertEntry(  aStr.ToUpperAscii() );

		}
		String aPathStr = aPath.GetFull();

		for ( i = 0; i < pDriveList->GetEntryCount(); ++i )
		{
			String aEntry = pDriveList->GetEntry(i);
			int    nLen   = aEntry.Len();
			nLen = nLen > 2 ? 2 : nLen;
			if ( aEntry.CompareIgnoreCaseToAscii( aPathStr, nLen ) == COMPARE_EQUAL )
			{
				pDriveList->SelectEntryPos(i);
				break;
			}
		}
	}
}

void ImpPathDialog::PostExecute()
{
}

void ImpPathDialog::SetPath( String const & rPath )
{
	aPath = DirEntry( rPath );

	Application::EnterWait();

	DirEntry aFile( rPath );
	// Falls der Pfad eine Wildcard oder einen Filenamen enthaelt
	// -> abschneiden und merken
	if( FileStat( aFile ).GetKind() & (FSYS_KIND_FILE | FSYS_KIND_WILD) || !aFile.Exists() )
		aFile.CutName();

	// Neue Maske und neues Verzeichnis setzen, und Listboxen updaten
	pEdit->SetText( rPath );
	aFile.SetCWD( TRUE );
	UpdateEntries( TRUE );

	Application::LeaveWait();
}

void ImpPathDialog::SetPath( Edit const & rEdit )
{
	String aPresetText = rEdit.GetText();
	if( aPresetText.Len() )
		SetPath( aPresetText );
}


String ImpPathDialog::GetPath() const
{
	DirEntry aFile( pEdit->GetText() );
	aFile.ToAbs();
	return aFile.GetFull();
}


ImpFileDialog::ImpFileDialog( PathDialog* pDlg, WinBits nWinBits, RESOURCE_TYPE nType ) :
  ImpPathDialog( pDlg, nWinBits, nType )
{
	bOpen = (nWinBits & WB_SAVEAS) == 0;

	ResId aPaResId = PaResId( bOpen ? STR_FILEDLG_OPEN : STR_FILEDLG_SAVE );

	// Titel setzen
	GetFileDialog()->SetText( String( aPaResId ) );
	nDirCount = 0;

	// initialize Controls if not used as a base class
	if ( nType == WINDOW_FILEDIALOG )
		InitControls();
}

ImpFileDialog::~ImpFileDialog()
{
	ImpFilterItem* pItem = aFilterList.First();
	while( pItem )
	{
		delete pItem;
		pItem = aFilterList.Next();
	}

	delete pFileTitel;
	if (pFileList && ( pFileList != pDirList ) )
		delete pFileList;

	delete pTypeTitel;
	delete pTypeList;
}

void ImpFileDialog::InitControls()
{
	String aEmptyStr;

	const nW = 160;
	const nH = 48; // Um den Dialog in eine akzeptable Form zu bringen

	INITCONTROL( pFileTitel, FixedText, 0,
		Point(10, 12), Size(nW, 18), String( PaResId( STR_FILEDLG_FILE ) ), 0 );
	INITCONTROL( pEdit, Edit, WB_BORDER,
		Point(10, 31), Size(nW, 20), aMask(), 0 );
	INITCONTROL( pFileList, ListBox, WB_SORT | WB_AUTOHSCROLL | WB_BORDER,
		Point(10, 58), Size(nW, 180-nH), aEmptyStr, 0 );

	INITCONTROL( pDirTitel, FixedText, 0,
		Point(nW+20, 12), Size(nW, 18), String( PaResId( STR_FILEDLG_DIR ) ), 0 );
	INITCONTROL( pDirPath, FixedText, WB_PATHELLIPSIS,
		Point(nW+20, 33), Size(nW, 20), aPath.GetFull(), 0 );
	INITCONTROL( pDirList, KbdListBox, WB_AUTOHSCROLL | WB_BORDER,
		Point(nW+20, 58), Size(nW, 180-nH ), aEmptyStr, 0 );

	INITCONTROL( pTypeTitel, FixedText, 0,
		Point(10, 246-nH), Size(nW, 18), String( PaResId( STR_FILEDLG_TYPE ) ), 0 );

	INITCONTROL( pTypeList, ListBox, WB_DROPDOWN,
		Point(10, 265-nH ), Size(2*nW+20, 100 ), aEmptyStr, 0 );

	pDriveTitle = NULL;
	pDriveList = NULL;
	pNewDirBtn = NULL;
	pHomeBtn   = NULL;

	const long nButtonStartX = 2*nW+20+15;
	INITCONTROL( pOkBtn, PushButton, WB_DEFBUTTON,
		Point(nButtonStartX, 10), Size(STD_BTN_WIDTH, STD_BTN_HEIGHT),
		Button::GetStandardText( BUTTON_OK ), 0 );
	INITCONTROL( pCancelBtn, CancelButton, 0,
		Point(nButtonStartX, 45 ), Size(STD_BTN_WIDTH, STD_BTN_HEIGHT),
		Button::GetStandardText( BUTTON_CANCEL ), 0 );

	pLoadBtn = 0;

	GetFileDialog()->SetOutputSizePixel( Size(nButtonStartX+STD_BTN_WIDTH+10, 298-nH) );

	nOwnChilds = GetPathDialog()->GetChildCount();

	// Handler setzen
	if (pDriveList)
		pDriveList->SetSelectHdl( LINK( this, ImpFileDialog, SelectHdl ) );

	if (pDirList)
		pDirList->SetDoubleClickHdl(LINK( this, ImpFileDialog, DblClickHdl) );

	if (pOkBtn)
		pOkBtn->SetClickHdl( LINK( this, ImpFileDialog, ClickHdl) );

	if (pCancelBtn)
		pCancelBtn->SetClickHdl( LINK( this, ImpFileDialog, ClickHdl) );

	if( pFileList )
	{
		pFileList->SetSelectHdl( LINK( this, ImpFileDialog, SelectHdl ) );
		pFileList->SetDoubleClickHdl( LINK( this, ImpFileDialog, DblClickHdl ) );
	}

	if( pTypeList )
		pTypeList->SetSelectHdl( LINK( this, ImpFileDialog, DblClickHdl ) );
}

IMPL_LINK( ImpFileDialog, SelectHdl, ListBox *, p )
{
	if( p == pDriveList )
	{
		String aDrive ( pDriveList->GetSelectEntry(), 0, 2);
		pEdit->SetText( aDrive );
		// pEdit->SetText( pDriveList->GetSelectEntry() );
		ClickHdl( pOkBtn );
	}
	else if (p == pFileList)
	{
		// Ausgewaehltes File in das Edit stellen
		pEdit->SetText( pFileList->GetSelectEntry() );
		GetFileDialog()->FileSelect();
	}
	return 0;
}


IMPL_LINK( ImpFileDialog, DblClickHdl, ListBox *, pBox )
{
  // isolate the pure name of the entry
  // removing trailing stuff and leading spaces
	String aEntry( pBox->GetSelectEntry() );

	aEntry.EraseLeadingChars( ' ' );
	USHORT nPos = aEntry.Search( '/' );
	aEntry.Erase( nPos );

	// build the absolute path to the selected item
	DirEntry aNewPath;
	aNewPath.ToAbs();

	if( ( pDirList != pFileList ) && ( pBox == pDirList ) )
	{
		// SVLOOK
		USHORT nCurPos = pDirList->GetSelectEntryPos();

		// Wenn es schon das aktuelle ist, dann mache nichts
		if( nCurPos == nDirCount-1 )
			return 0;

		// Wird nach oben gewechselt
		if( nCurPos < nDirCount )
			aNewPath = aNewPath[nDirCount-nCurPos-1];
		else
			aNewPath += aEntry;
	}
	else
	{
		// non-SVLOOK
		if( aEntry == String( PaResId( STR_FILEDLG_GOUP ) ) )
			aEntry = String::CreateFromAscii( ".." );
		aNewPath += aEntry;
	}

	if( pBox == pFileList )
	{
		DirEntry aFile( aEntry );

		// Abfrage, ob File ueberschrieben werden soll...
		if( !FileStat(aFile).IsKind(FSYS_KIND_DIR) && IsFileOk( aFile ) )
		{
			// dann kompletten Pfad mit Filenamen merken und Dialog beenden
			aPath = aNewPath;
			GetFileDialog()->EndDialog( TRUE );
		}
	}

	USHORT nCurPos = pBox->GetSelectEntryPos();

	Application::EnterWait();

	String aFull = aNewPath.GetFull();

	if( ( ( pBox == pDirList ) && ( pDirList != pFileList ) ) ||
		( ( pDirList == pFileList ) && FileStat( aNewPath ).GetKind() & FSYS_KIND_DIR ) )
	{
		// Neuen Pfad setzen und Listboxen updaten
		aPath = aNewPath;
		if( !aPath.SetCWD( TRUE ) )
		{
			if( ErrorBox( GetFileDialog(), WB_OK_CANCEL|WB_DEF_OK,
								String( PaResId( STR_FILEDLG_CANTCHDIR ) ) ).Execute() == RET_CANCEL )
			{
				GetFileDialog()->EndDialog( FALSE );
			}
		}
		UpdateEntries( TRUE );
		GetFileDialog()->FileSelect();
	}

	if( pBox == pTypeList )
	{
		// Neue Maske setzen, und Listboxen updaten
		USHORT nCurPos = pTypeList->GetSelectEntryPos();
		if( nCurPos+1 > (USHORT)aFilterList.Count() )
			aMask = String::CreateFromAscii( ALLFILES );
		else
		{
			String aFilterListMask = aFilterList.GetObject( nCurPos )->aMask;
//						if( aFilterListMask.Search( ';' ) == STRING_NOTFOUND ) // kein ; in der Maske
//								aMask = WildCard( aFilterListMask, '\0' );
//						else // ; muss beruecksichtigt werden
				aMask = WildCard( aFilterListMask, ';' );
		}

		pEdit->SetText( aMask() );
		UpdateEntries( FALSE );
		GetFileDialog()->FilterSelect();
	}

  Application::LeaveWait();

  return 0;
}

IMPL_LINK( ImpFileDialog, ClickHdl, Button*, pBtn )
{
	if( ( pBtn == pOkBtn ) || ( pBtn == pLoadBtn ) )
	{
		DirEntry aFile( pEdit->GetText() );

		// Existiert File / File ueberschreiben
		if( IsFileOk( aFile ) )
		{
			// Ja, dann kompletten Pfad mit Filenamen merken und Dialog beenden
			aPath = aFile;
			aPath.ToAbs();
			GetFileDialog()->EndDialog( TRUE );
		}
		else
		{
			Application::EnterWait();

			// Falls der Pfad eine Wildcard oder einen Filenamen enthaelt
			// -> abschneiden und merken
			if( FileStat( aFile ).GetKind() & (FSYS_KIND_FILE | FSYS_KIND_WILD) || !aFile.Exists() )
			{
				aMask = aFile.CutName();
			}

			// Neue Maske und neues Verzeichnis setzen, und Listboxen updaten
			pEdit->SetText( aMask() );
			aFile.SetCWD( TRUE );
			UpdateEntries( TRUE );

			Application::LeaveWait();

		}
	}
	else if( pBtn == pCancelBtn )
		GetFileDialog()->EndDialog( FALSE );

	return 0;
}

void ImpFileDialog::UpdateEntries( const BOOL bWithDirs )
{
	Application::EnterWait();

	String aTabString;
	DirEntry aTmpPath;
	aTmpPath.ToAbs();
	nDirCount = aTmpPath.Level();

	if( pFileList )
	{
	pFileList->SetUpdateMode( FALSE );
		pFileList->Clear();
	}

	if( bWithDirs && (pDirList != pFileList) )
	{
		pDirList->SetUpdateMode( FALSE );
		pDirList->Clear();

		for( USHORT i = nDirCount; i > 0; i-- )
		{
			String aEntryStr( aTabString );
			aEntryStr += aTmpPath[i-1].GetName();
			pDirList->InsertEntry( aEntryStr );
			aTabString += ' ';
			aTabString += ' ';
		}
	}

	// for the combined box insert a '..'
	// (this happens only if WB_SVLOOK is not set)

	if( pDirList == pFileList && nDirCount != 1 )
		pFileList->InsertEntry( String( PaResId( STR_FILEDLG_GOUP ) ) );

	// scan the directory
	DirEntry aCurrent;
	aCurrent.ToAbs();
	Dir aDir( aCurrent, FSYS_KIND_DIR|FSYS_KIND_FILE );
	USHORT nEntries = aDir.Count();

	// TempMask, weil Vergleich case-sensitiv
	BOOL bMatchCase = aCurrent.IsCaseSensitive();
	String aWildCard( aMask.GetWildCard() );
	if ( !bMatchCase )
		aWildCard.ToLowerAscii();
	WildCard aTmpMask( aWildCard, ';' );
	if ( nEntries )
	{
		StringList	aSortDirList;
	for ( USHORT n = 0; n < nEntries; n++ )
		{
			DirEntry& rEntry = aDir[n];
		String aName( rEntry.GetName() );

			if( aName.Len() &&
				( ( ( aName.GetChar(0) != '.' ) ||
				  ( ( aName.GetChar(0) == '.' ) && ( aMask.GetWildCard() ).GetChar(0) == '.' ) )
						&& rEntry.Exists() ) )
			{
				FileStat aFileStat( rEntry );
				String aTmpName( aName );
				if ( !bMatchCase )
					aTmpName.ToLowerAscii();
				if( ( aFileStat.GetKind() & FSYS_KIND_FILE ) && aTmpMask.Matches( aTmpName ) )
				{
					ULONG n = aFileStat.GetKind();
					if( pFileList )
			pFileList->InsertEntry( aName );
				}
		else if( bWithDirs && ( aFileStat.GetKind() & FSYS_KIND_DIR ) )
				{
					if( pDirList == pFileList )
					{
						String aEntryStr( aName );
						aEntryStr += '/';
						pDirList->InsertEntry( aEntryStr );
					}
					else
					{
			ULONG l;			
			for( l = 0; l < aSortDirList.Count(); l++ )
				if( *aSortDirList.GetObject(l) > aName )
								break;
			aSortDirList.Insert( new String( aName ), l );
			}
		}
		}
	}
	for( ULONG l = 0; l < aSortDirList.Count(); l++ )
		{
			String aEntryStr( aTabString );
			aEntryStr += *aSortDirList.GetObject(l);
		pDirList->InsertEntry( aEntryStr );
		delete aSortDirList.GetObject(l);
	}
	}

	if( bWithDirs )
		UpdateDirs( aTmpPath );

	if( pFileList )
	{
	if ( pDirList == pFileList && nDirCount > 1 )
		pFileList->SelectEntryPos( 1 );
	else
		pFileList->SetNoSelection();
	pFileList->SetUpdateMode( TRUE );
	pFileList->Invalidate();
	pFileList->Update();
	}

	if( pDriveList )
	{
		if( pDirList->GetEntryCount() > 0 )
		{
			String aStr( pDirList->GetEntry( 0 ) );
			aStr.Erase( 2 );
			aStr.ToLowerAscii();
			pDriveList->SelectEntry( aStr );
		}
	}

  Application::LeaveWait();
}

BOOL ImpFileDialog::IsFileOk( const DirEntry& rDirEntry )
{
	if( FileStat( rDirEntry ).GetKind() & (FSYS_KIND_WILD | FSYS_KIND_DEV) )
	return FALSE;
	if( FileStat( rDirEntry ).GetKind() & FSYS_KIND_DIR )
	{
		if( pFileList )
			return FALSE;
	}
	else if( bOpen )
	{
	// Datei vorhanden ?
	if( !FileStat( rDirEntry ).IsKind( FSYS_KIND_FILE ) )
		{
			String aErrorString( PaResId( STR_FILEDLG_CANTOPENFILE ) );
			aErrorString += '\n';
			aErrorString += '[';
			aErrorString += rDirEntry.GetFull();
			aErrorString += ']';
			InfoBox aBox( GetFileDialog(),
						  aErrorString );
			aBox.Execute();
		return FALSE;
	}
	}
	else
	{
	// Datei vorhanden ?
		if( FileStat( ExtendFileName( rDirEntry ) ).IsKind( FSYS_KIND_FILE ) )
		{
			String aQueryString( PaResId( STR_FILEDLG_OVERWRITE ) );
			aQueryString += '\n';
			aQueryString += '[';
			aQueryString += rDirEntry.GetFull();
			aQueryString += ']';
			QueryBox aBox( GetFileDialog(),
						   WinBits( WB_YES_NO | WB_DEF_NO ),
						   aQueryString );
			if( aBox.Execute() != RET_YES )
				return FALSE;
	}
	}
	return GetFileDialog()->OK() != 0;
}

void ImpFileDialog::SetPath( String const & rPath )
{
	aPath = DirEntry( rPath );
	Application::EnterWait();

	DirEntry aFile( rPath );

	// Falls der Pfad eine Wildcard oder einen Filenamen enthaelt
	// -> abschneiden und merken
	if( FileStat( aFile ).GetKind() & (FSYS_KIND_FILE | FSYS_KIND_WILD) 	|| !aFile.Exists() )
		aMask = aFile.CutName();

	// Neue Maske und neues Verzeichnis setzen, und Listboxen updaten
	if( pDirList )
		pEdit->SetText( aMask() );
	else
		pEdit->SetText( rPath );

	aFile.SetCWD( TRUE );

	UpdateEntries( TRUE );

	Application::LeaveWait();
}

void ImpFileDialog::SetPath( Edit const& rEdit )
{
	String aPresetText = rEdit.GetText();
	if( aPresetText.Len() )
		SetPath( aPresetText );
}


void ImpFileDialog::AddFilter( const String& rFilter, const String& rMask )
{
	aFilterList.Insert( new ImpFilterItem( rFilter, rMask ), LIST_APPEND );
	if( pTypeList )
		pTypeList->InsertEntry( rFilter, LISTBOX_APPEND );

	if( !GetCurFilter().Len() )
		SetCurFilter( rFilter );
}

void ImpFileDialog::RemoveFilter( const String& rFilter )
{
	ImpFilterItem* pItem = aFilterList.First();
	while( pItem && pItem->aName != rFilter )
		pItem = aFilterList.Next();

	if( pItem )
	{
		delete aFilterList.Remove();
		if( pTypeList )
			pTypeList->RemoveEntry( rFilter );
	}
}

void ImpFileDialog::RemoveAllFilter()
{
	ImpFilterItem* pItem = aFilterList.First();
	while( pItem )
	{
		delete pItem;
		pItem = aFilterList.Next();
	}
	aFilterList.Clear();

	if( pTypeList )
		pTypeList->Clear();
}

void ImpFileDialog::SetCurFilter( const String& rFilter )
{
	if( !pTypeList )
		return;

	ImpFilterItem* pItem = aFilterList.First();
	while( pItem && pItem->aName != rFilter )
		pItem = aFilterList.Next();

	if( pItem )
		pTypeList->SelectEntryPos( (USHORT)aFilterList.GetCurPos() );
	else
		pTypeList->SetNoSelection();
}

String ImpFileDialog::GetCurFilter() const
{
	String aFilter;
	if ( pTypeList )
		aFilter = pTypeList->GetSelectEntry();
	return aFilter;
}

void ImpFileDialog::PreExecute()
{
	// ListBoxen erst unmittelbar vor Execute fuellen
	// (damit vor Execute der Pfad umgesetzt werden kann, ohne das immer die
	//	Listboxen sofort upgedatet werden)

	Application::EnterWait();

	// Wenn kein Filter vorhanden, dann auch keine FilterBox
	if( pTypeList && !pTypeList->GetEntryCount() )
	{
		// pTypeList->InsertEntry( "* (all files)" );
		pTypeTitel->Disable();
		pTypeList->Disable();
	}

	if( pTypeList )
	{
		USHORT nCurType = pTypeList->GetSelectEntryPos();
		if( nCurType < aFilterList.Count() )
		{
			String aFilterListMask = aFilterList.GetObject( nCurType )->aMask;
			if( aFilterListMask.Search( ';' ) == STRING_NOTFOUND ) // kein ; in der Maske
				aMask = WildCard( aFilterListMask, '\0' );
			else // ; in der Maske, muss in der Wildcard beruecksichtigt werden
				aMask = WildCard( aFilterListMask, ';' );
		}
		else
			aMask = String::CreateFromAscii( ALLFILES );
	}
	else
		aMask = String::CreateFromAscii( ALLFILES );

	// Neue Maske setzen
	pEdit->SetText( aMask() );

	ImpPathDialog::PreExecute();

	Application::LeaveWait();
}

String ImpFileDialog::GetPath() const
{
	DirEntry aFile( pEdit->GetText() );
	return ExtendFileName( aFile );
}

String ImpFileDialog::ExtendFileName( DirEntry aEntry ) const
{
	aEntry.ToAbs();
	// das ganze Theater hier ohnehin nur machen, wenn Dateiname
	// ohne Extension angegeben wurde
	if( !aEntry.GetExtension().Len() )
	{
		String aPostfix; // hier kommt die ausgesuchte Extension herein

		// ist ein Filter mit Extension gesetzt?
		USHORT nChosenFilterPos = pTypeList->GetSelectEntryPos();
		if( nChosenFilterPos != LISTBOX_ENTRY_NOTFOUND )
		{
			String aExtensionMask = GetFileDialog()->GetFilterType( nChosenFilterPos );
			// aExtension ist z.B. *.sdw, alles bis einschliesslich Punkt abschneiden
			String aExtension = aExtensionMask.Erase( aExtensionMask.Search( '.' )+1 );

			// hat der Filter ueberhaupt eine Extension
			if( aExtension.Len() )
			{
				// keine Wildcards enthalten?
				if( ( aExtension.Search( '*' ) == STRING_NOTFOUND ) &&
					( aExtension.Search( '?' ) == STRING_NOTFOUND ) )
				{
					// OK, Filter hat Extension ohne Wildcards -> verwenden
					aPostfix = aExtension;
				}
				else
				{
					// Filter hat Extension mit Wildcards (z.B. *.*) -> nicht verwenden
					aPostfix.Erase();
				}
			}
			else
			{
				// Filter hatte keine Extension (schwer vorstellbar) -> nichts anhaengen
				aPostfix.Erase();
			}
		}
		else
		{
			// kein Filter gefunden (merkwrdig) -> Default-Extension anhaengen
			aPostfix = GetFileDialog()->GetDefaultExt();
		}

		// jetzt kann es mit dem Anhaengen losgehen
		const sal_Unicode* pExt = aPostfix.GetBuffer();
		while( *pExt == '*' || *pExt == '?' )
			pExt++;

		if( *pExt )
		{
			String aName = aEntry.GetName();
			if( *pExt != '.' )
				aName += '.';
			aName += pExt;
			aEntry.SetName( aName );
		}
	}
	return aEntry.GetFull();
}


void ImpSvFileDlg::CreateDialog( PathDialog* pSvDlg, WinBits nStyle, RESOURCE_TYPE nType )
{
	delete pDlg;
	if ( nType == WINDOW_PATHDIALOG )
		pDlg = new ImpPathDialog( pSvDlg, nStyle, nType );
	else
		pDlg = new ImpFileDialog( pSvDlg, nStyle, nType );
}

/*************************************************************************

	Source Kontroll-System

	$Log: filedlg2.cxx,v $
	Revision 1.2  2001/07/09 15:46:37  pl
	must change due to international->settings
	
	Revision 1.1.1.1  2001/05/08 11:56:34  pl
	Administration utility for Unix PS-Print Environment
	
	Revision 1.1.1.1  2000/11/13 09:27:12  pl
	
	
	Revision 1.6  2000/06/13 13:25:23  pl
	namespace to avoid duplicate symbols
	
	Revision 1.5  2000/05/12 13:52:53  pl
	Unicode
	
	Revision 1.4  2000/02/11 14:26:10  hr
	#70473# changes for unicode ( patched by automated patchtool )
	
	Revision 1.3  1999/11/03 15:16:08  hr
	#65293# syntax changes for C50
	
	Revision 1.2  1999/09/20 12:35:04  pl
	resource changes
	
	Revision 1.1  1999/06/07 12:39:23  pl
	#66621# halbes svtools hieher kopieren
	
   
      Rev 1.30   18 Feb 1999 14:16:16   TJ
   DirEntry::IsCaseSensitive nicht mehr static
   
      Rev 1.29   18 Jan 1999 19:24:46   TH
   #59490# - ButtonText -> StandardText

	  Rev 1.28	 23 Nov 1998 14:11:42	MT
   #58968# HelpIds fuer FileDlg

	  Rev 1.27	 13 Oct 1998 13:48:22	TH
   #57272#/#54145# - WB_PATHELLIPSES und ersten Eintrag im FileDialog nicht selektieren

	  Rev 1.26	 27 Jul 1998 16:14:20	PL
   #53715# PathDialog intelligenter

	  Rev 1.25	 30 Jun 1998 10:42:22	cp
   #51811# FileDialog bereinigt

	  Rev 1.24	 29 Jun 1998 19:58:14	cp
   #51808# Fehler im Destruktor des PathDlgs

	  Rev 1.23	 26 Jun 1998 18:35:14	cp
   #51270# Steuerung des Pathdialogs mit Tastatur: Enter entspricht jetzt DoubleClick

	  Rev 1.22	 26 Jun 1998 18:33:36	cp


	  Rev 1.21	 20 Jun 1998 14:13:46	TH
   #51270# #49948# #49952# Erweiterte Funktionalitaet fuer Pathdialog

	  Rev 1.20	 03 Mar 1998 19:29:28	MI
   Laufwerksseletion ging nicht mehr

	  Rev 1.19	 23 Feb 1998 11:38:48	PB
   fix: falsches Define

	  Rev 1.18	 23 Feb 1998 10:05:34	PB
   fix: #47473# Pfad-Dialog ohne Laufwerke unter UNIX; chg: schoener

	  Rev 1.17	 19 Jan 1998 18:58:00	MH
   chg: header

	  Rev 1.16	 28 Nov 1997 15:28:18	TJ
   include

	  Rev 1.15	 27 Nov 1997 16:32:46	DV
   (HRO)Pathdialog jetzt mit Laufwerken

	  Rev 1.14	 05 Nov 1997 10:17:06	DV
   DirEntries auf das aktuelle Verzeichnis erzeugt man besser ohne '.'

	  Rev 1.13	 28 Oct 1997 11:33:06	MT
   #45121: PathDialog: Laufwerk wechseln

	  Rev 1.12	 17 Oct 1997 10:13:00	SOH
   Dialog um Laufwerksauswahl erweitert (Nicht UNX); Groessen- und Positions-Korrekturen

*************************************************************************/

