#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.5 $
#
#   last change: $Author: khendricks $ $Date: 2001/07/04 19:46:09 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=.

PRJNAME=pspell
TARGET=pspell

.IF "$(GUI)"=="UNX"
MKDIR=mkdir -p
ZIP=zip -j -q
.ENDIF			# "$(GUI)"=="UNX"

# --- Settings -----------------------------------------------------

.INCLUDE :	settings.mk

# --- Files --------------------------------------------------------

.IF "$(BUILD_SOSL)" == ""
all_target: ALLTAR MYTAR
.ELSE
all_target: ALLTAR MYTAR TG_DELIVER

TG_DELIVER : MYTAR
	$(DELIVER)

.ENDIF

TARFILE_NAME=pspell-.12.2

#patching
PATCH_FILE_NAME=pspell_patch.diff

.IF "$(GUI)"=="UNX"
CONFIGURE_DIR=.$/
#relative to CONFIGURE_DIR
CONFIGURE_ACTION=.$/configure
CONFIGURE_FLAGS=--disable-static --enable-ltdl --enable-ltdl-install=yes
BUILD_DIR=$(CONFIGURE_DIR)
BUILD_ACTION=make
.ENDIF			# "$(GUI)"=="UNX"

OUT2LIB= \
	$(BUILD_DIR)$/libltdl$/.libs$/libltdl.so \
	$(BUILD_DIR)$/modules$/.libs$/libpspell-modules.so \
	$(BUILD_DIR)$/interface$/.libs$/libpspell-impl.so \
	$(BUILD_DIR)$/interface$/.libs$/libpspell.so 
 
OUT2BIN= \
	$(BUILD_DIR)$/data$/cp1252.map \
	$(BUILD_DIR)$/data$/koi8-r.map \
	$(BUILD_DIR)$/data$/region-to-spelling.map \
	$(BUILD_DIR)$/data$/viscii.map \
	$(BUILD_DIR)$/data$/iso8859-1.map \
	$(BUILD_DIR)$/data$/iso8859-2.map \
	$(BUILD_DIR)$/data$/iso8859-3.map \
	$(BUILD_DIR)$/data$/iso8859-4.map \
	$(BUILD_DIR)$/data$/iso8859-5.map \
	$(BUILD_DIR)$/data$/iso8859-6.map \
	$(BUILD_DIR)$/data$/iso8859-7.map \
	$(BUILD_DIR)$/data$/iso8859-8.map \
	$(BUILD_DIR)$/data$/iso8859-9.map \
	$(BUILD_DIR)$/data$/iso8859-10.map \
	$(BUILD_DIR)$/data$/iso8859-13.map \
	$(BUILD_DIR)$/data$/iso8859-14.map \
	$(BUILD_DIR)$/data$/iso8859-15.map


OUT2INC= \
	$(BUILD_DIR)$/interface$/pspell.h \
	$(BUILD_DIR)$/interface$/config.h \
	$(BUILD_DIR)$/interface$/error.h \
	$(BUILD_DIR)$/interface$/manager.h \
	$(BUILD_DIR)$/interface$/mutable_container.h \
	$(BUILD_DIR)$/interface$/string_emulation.h \
	$(BUILD_DIR)$/interface$/string_list.h \
	$(BUILD_DIR)$/interface$/string_map.h \
	$(BUILD_DIR)$/interface$/string_pair.h \
	$(BUILD_DIR)$/interface$/string_pair_emulation.h \
	$(BUILD_DIR)$/interface$/wordlist.h \
	$(BUILD_DIR)$/interface$/string.hh \
	$(BUILD_DIR)$/interface$/file_util.hh \
	$(BUILD_DIR)$/interface$/app_string.hh \
	$(BUILD_DIR)$/interface$/config_impl.hh \
	$(BUILD_DIR)$/interface$/error_messages.hh \
	$(BUILD_DIR)$/interface$/string_list_impl.hh \
	$(BUILD_DIR)$/interface$/error_impl.hh \
	$(BUILD_DIR)$/interface$/getdata.hh \
	$(BUILD_DIR)$/interface$/itemize.hh \
	$(BUILD_DIR)$/interface$/string_map_impl.hh \
	$(BUILD_DIR)$/interface$/convert.hh \
	$(BUILD_DIR)$/interface$/string_list.hh \
	$(BUILD_DIR)$/interface$/manager_impl.hh

MYTAR : build$/$(INPATH)$/so_predeliver
	+$(ZIP) - $(BIN)$/* > $(MISC)$/pspell_data.zip


# --- Targets ------------------------------------------------------

.INCLUDE : 	set_ext.mk
.INCLUDE :	target.mk
.INCLUDE :	tg_ext.mk

