/*************************************************************************
 *
 *  $RCSfile: advapi9x.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: tra $ $Date: 2001/07/11 13:41:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _WINDOWS_
#include <windows.h>
#endif

#include "..\inc\systsettings.h"

#include <registry.h>
#include <systools/win32/AutoSystoolInit.hxx>

//------------------------------------------------------------------------
// forward declaration
//------------------------------------------------------------------------

static void WINAPI Advapi9xInit( );
static void WINAPI Advapi9xDeInit( );

//------------------------------------------------------------------------
// global object, used to automatically initialize the systools 
//------------------------------------------------------------------------

static OAutoSystoolInit initAdvapi9x( Advapi9xInit, Advapi9xDeInit );


//------------------------------------------------------------------------
// function pointers, used instead of the real functions
//------------------------------------------------------------------------

extern "C"
{

typedef LONG ( WINAPI * RegOpenKeyExW_Proc_T ) (
  HKEY hKey,         // handle to open key
  LPCWSTR lpSubKey,  // subkey name
  DWORD ulOptions,   // reserved
  REGSAM samDesired, // security access mask
  PHKEY phkResult    // handle to open key
);
RegOpenKeyExW_Proc_T lpfnRegOpenKeyExW;

typedef LONG (WINAPI * RegEnumKeyExW_Proc_T ) (
  HKEY hKey,                  // handle to key to enumerate
  DWORD dwIndex,              // subkey index
  LPWSTR lpName,              // subkey name
  LPDWORD lpcName,            // size of subkey buffer
  LPDWORD lpReserved,         // reserved
  LPWSTR lpClass,             // class string buffer
  LPDWORD lpcClass,           // size of class string buffer
  PFILETIME lpftLastWriteTime // last write time
);
RegEnumKeyExW_Proc_T lpfnRegEnumKeyExW;

typedef LONG (WINAPI * RegCreateKeyExW_Proc_T )(
  HKEY hKey,                                  // handle to open key
  LPCWSTR lpSubKey,                           // subkey name
  DWORD Reserved,                             // reserved
  LPWSTR lpClass,                             // class string
  DWORD dwOptions,                            // special options
  REGSAM samDesired,                          // desired security access
  LPSECURITY_ATTRIBUTES lpSecurityAttributes, // inheritance
  PHKEY phkResult,                            // key handle 
  LPDWORD lpdwDisposition                     // disposition value buffer
);
RegCreateKeyExW_Proc_T lpfnRegCreateKeyExW;

typedef LONG (WINAPI * RegDeleteKeyW_Proc_T ) (
  HKEY hKey,         // handle to open key
  LPCWSTR lpSubKey   // subkey name
);
RegDeleteKeyW_Proc_T lpfnRegDeleteKeyW;

typedef LONG (WINAPI *RegEnumValueW_Proc_T ) (
  HKEY hKey,             // handle to key to query
  DWORD dwIndex,         // index of value to query
  LPWSTR lpValueName,    // value buffer
  LPDWORD lpcValueName,  // size of value buffer
  LPDWORD lpReserved,    // reserved
  LPDWORD lpType,        // type buffer
  LPBYTE lpData,         // data buffer
  LPDWORD lpcbData       // size of data buffer
);
RegEnumValueW_Proc_T lpfnRegEnumValueW;

typedef LONG (WINAPI *RegQueryValueExW_Proc_T ) (
  HKEY hKey,            // handle to key
  LPCWSTR lpValueName,  // value name
  LPDWORD lpReserved,   // reserved
  LPDWORD lpType,       // type buffer
  LPBYTE lpData,        // data buffer
  LPDWORD lpcbData      // size of data buffer
);
RegQueryValueExW_Proc_T lpfnRegQueryValueExW;

typedef LONG (WINAPI *RegSetValueExW_Proc_T )(
  HKEY hKey,           // handle to key
  LPCWSTR lpValueName, // value name
  DWORD Reserved,      // reserved
  DWORD dwType,        // value type
  CONST BYTE *lpData,  // value data
  DWORD cbData         // size of value data
);
RegSetValueExW_Proc_T lpfnRegSetValueExW;

typedef LONG (WINAPI * RegDeleteValueW_Proc_T ) (
  HKEY hKey,            // handle to key
  LPCWSTR lpValueName   // value name
);
RegDeleteValueW_Proc_T lpfnRegDeleteValueW;

} // extern "C"

//------------------------------------------------------------------------
// initialize the Advapi9x systools
//------------------------------------------------------------------------

static void WINAPI Advapi9xInit( )
{
	HMODULE			hModule;
	OSVERSIONINFO	OSVerInfo;
	
	OSVerInfo.dwOSVersionInfoSize = sizeof( OSVERSIONINFO );
	GetVersionEx( &OSVerInfo );	

	// if windows 95/98
	if ( VER_PLATFORM_WIN32_WINDOWS == OSVerInfo.dwPlatformId )
	{		
		hModule = LoadLibraryA( SYSTOOLS_DLL_NAME );
		if ( NULL != hModule )
		{
			lpfnRegOpenKeyExW = ( RegOpenKeyExW_Proc_T )GetProcAddress( 
									hModule, "RegOpenKeyExW_9x" );
			lpfnRegEnumKeyExW = ( RegEnumKeyExW_Proc_T )GetProcAddress(
									hModule, "RegEnumKeyExW_9x" );
			lpfnRegCreateKeyExW = ( RegCreateKeyExW_Proc_T )GetProcAddress(
									hModule, "RegCreateKeyExW_9x" );
			lpfnRegDeleteKeyW = ( RegDeleteKeyW_Proc_T )GetProcAddress(
									hModule, "RegDeleteKeyW_9x" );
			lpfnRegEnumValueW = ( RegEnumValueW_Proc_T )GetProcAddress(
									hModule, "RegEnumValueW_9x" );
			lpfnRegQueryValueExW = ( RegQueryValueExW_Proc_T )GetProcAddress(
									hModule, "RegQueryValueExW_9x" );
			lpfnRegSetValueExW = ( RegSetValueExW_Proc_T )GetProcAddress(
									hModule, "RegSetValueExW_9x" );
			lpfnRegDeleteValueW = ( RegDeleteValueW_Proc_T )GetProcAddress(
									hModule, "RegDeleteValueW_9x" );
		}	
	}
	else // WinNT/Win2000
	{
		lpfnRegOpenKeyExW    = RegOpenKeyExW;
		lpfnRegEnumKeyExW    = RegEnumKeyExW;
		lpfnRegCreateKeyExW  = RegCreateKeyExW;
		lpfnRegDeleteKeyW    = RegDeleteKeyW;
		lpfnRegEnumValueW    = RegEnumValueW;
		lpfnRegQueryValueExW = RegQueryValueExW;
		lpfnRegSetValueExW   = RegSetValueExW;
		lpfnRegDeleteValueW  = RegDeleteValueW;
	}
}

//------------------------------------------------------------------------
// deinitialize the Advapi9x systools
//------------------------------------------------------------------------

static void WINAPI Advapi9xDeInit( )
{
	// we do not explicitly free the shell9x library but rely
	// on the fact that sal will not be unloaded while the 
	// office is running, so the library will be free at
	// the office shutdown

    // we use this approach in order to unload the w9xucwrp.dll
    // GetModuleHandle will be used in order to avoid a global
    // variable HMODULE which would be set in ...Init
    // if the module handle is valid a LoadLibrary should have
    // been successful
    // nobody should use any of the above function pointer after
    // this call
    HMODULE hModule = GetModuleHandleA( SYSTOOLS_DLL_NAME );
    if ( hModule )
        FreeLibrary( hModule );
}

