/*************************************************************************
 *
 *  $RCSfile: flttools.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: dr $ $Date: 2001/06/13 12:36:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
#include "filt_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------------

#ifndef _FLTTOOLS_HXX
#include "flttools.hxx"
#endif

#ifndef _UNOTOOLS_CHARCLASS_HXX
#include <unotools/charclass.hxx>
#endif

#include <math.h>

#ifndef SC_SCGLOB_HXX
#include "global.hxx"
#endif

#ifndef _EXCDEFS_HXX
#include "excdefs.hxx"
#endif

//___________________________________________________________________
// ScFilterTools::ReadLongDouble()

#ifdef _MSC_VER
#if _MSC_VER <= 800
#undef __SIMPLE_FUNC
#define __SIMPLE_FUNC
#endif
#endif

double ScFilterTools::ReadLongDouble( SvStream& rStrm )

#ifdef __SIMPLE_FUNC
// ========== nur fuer VC 1.5 oder kleiner ===============================
{
	long double fRet;
	rStrm.Read( &fRet, 10 );
	return ( double ) fRet;
}
#undef __SIMPLE_FUNC
#else
{
// ========== ausfuehrliche Version fuer'n Rest ==========================
/*

" M a p p i n g - G u i d e "

10-Byte Intel

77777777 77666666 66665555 55555544 44444444 33333333 33222222 22221111 1111110  00000000		x10
98765432 10987654 32109876 54321098 76543210 98765432 10987654 32109876 54321098 76543210	Bit-# insgesamt
9      9 8      8 7      7 6      6 5      5 4      4 3      3 2      2 1      1 0      0	Byte-#
76543210 76543210 76543210 76543210 76543210 76543210 76543210 76543210 76543210 76543210	Bit-# im Byte
SEEEEEEE EEEEEEEE IMMMMMMM MMMMMMMM MMMMMMMM MMMMMMMM MMMMMMMM MMMMMMMM MMMMMMMM MMMMMMMM	Gruppe
01111110 00000000 06665555 55555544 44444444 33333333 33222222 22221111 11111100 00000000		x10
14321098 76543210 02109876 54321098 76543210 98765432 10987654 32109876 54321098 76543210	Bit in Gruppe
*/

	register long double	lfDouble = 0.0;
	register long double	lfFakt = 256.0;
	BYTE					pDouble10[ 10 ];

	rStrm.Read( pDouble10, 10 );			// Intel-10 in pDouble10

	lfDouble = ( long double ) pDouble10[ 7 ];	// Byte 7
	lfDouble *= lfFakt;							// Byte 6
	lfDouble += ( long double ) pDouble10[ 6 ];
	lfDouble *= lfFakt;							// Byte 5
	lfDouble += ( long double ) pDouble10[ 5 ];
	lfDouble *= lfFakt;							// Byte 4
	lfDouble += ( long double ) pDouble10[ 4 ];
	lfDouble *= lfFakt;							// Byte 3
	lfDouble += ( long double ) pDouble10[ 3 ];
	lfDouble *= lfFakt;							// Byte 2
	lfDouble += ( long double ) pDouble10[ 2 ];
	lfDouble *= lfFakt;							// Byte 1
	lfDouble += ( long double ) pDouble10[ 1 ];
	lfDouble *= lfFakt;							// Byte 0
	lfDouble += ( long double ) pDouble10[ 0 ];

	//	Bei 0.0 sind alle Bits 0, und pow(2.0,-16446) kommt mit dem
	//	CSet Compiler nicht so gut
	if( lfDouble != 0.0 )
	{
		// Exponent
		register INT32			nExp;
		nExp = ( pDouble10[ 9 ] & 0x7F );
		nExp <<= 8;
		nExp += pDouble10[ 8 ];
		nExp -= 16446;

		lfDouble *= pow( 2.0, ( double ) nExp );
	}

	// Sign
	if( pDouble10[ 9 ] & 0x80 )
		lfDouble *= ( long double ) -1.0;

	return ( double ) lfDouble;
}
#endif

//___________________________________________________________________

CharSet ScFilterTools::GetSystemCharSet()
{
	return gsl_getSystemTextEncoding();
}

String ScFilterTools::GetHexStr( UINT16 nValue )
{
	static const sal_Char pH[] = "0123456789ABCDEF";
	String aStr;

	aStr += pH[ nValue >> 12 ];
	aStr += pH[ (nValue >> 8) & 0x000F ];
	aStr += pH[ (nValue >> 4) & 0x000F ];
	aStr += pH[ nValue & 0x000F ];
	return aStr;
}

//___________________________________________________________________
// string functions

void ScFilterTools::AddToken( String& rTokenList, const String& rToken, sal_Unicode cSep )
{
	if( rToken.Len() )
	{
		if( rTokenList.Len() )
			rTokenList += cSep;
		rTokenList += rToken;
	}
}

void ScFilterTools::AddQuotes( String& rString, sal_Unicode cQuote )
{
    rString.Insert( cQuote, 0 ).Append( cQuote );
}

void ScFilterTools::EraseQuotes( String& rString, sal_Unicode cQuote )
{
	xub_StrLen nLastIx = rString.Len() - 1;
    if( (nLastIx > 0) && (rString.GetChar( 0 ) == cQuote) && (rString.GetChar( nLastIx ) == cQuote) )
		rString.Erase( nLastIx ).Erase( 0, 1 );
}

//___________________________________________________________________
// Excel built in names

const sal_Char* ScFilterTools::GetBuiltInName( sal_Unicode nIndex )
{
	static const sal_Char* pNames[] = {
		"BuiltIn_Consolidate_Area","BuiltIn_Auto_Open","BuiltIn_Auto_Close",
		"BuiltIn_Extract","BuiltIn_Database","BuiltIn_Criteria","BuiltIn_Print_Area",
		"BuiltIn_Print_Titles","BuiltIn_Recorder","BuiltIn_Data_Form",
		"BuiltIn_Auto_Activate","BuiltIn_Auto_Deactivate","BuiltIn_SheetTitle",
		"BuiltIn_AutoFilter","BuiltIn_UNKNOWN" };

	if( nIndex < 0x00 || nIndex > EXC_BUILTIN_UNKNOWN )
		nIndex = EXC_BUILTIN_UNKNOWN;

	return pNames[ nIndex ];
}

void ScFilterTools::GetBuiltInName( String& rName, sal_Unicode nIndex, UINT16 nSheet )
{
    rName.AssignAscii( GetBuiltInName( nIndex ) );
    rName.AppendAscii( "___" );
    rName += String::CreateFromInt32( nSheet );
}

BOOL ScFilterTools::IsBuiltInName( UINT16& rnSheet, const String& rName, sal_Unicode nIndex )
{
    String aBuiltIn;
    aBuiltIn.AssignAscii( GetBuiltInName( nIndex ) );
    aBuiltIn.AppendAscii( "___" );
    if( !rName.EqualsIgnoreCaseAscii( aBuiltIn, 0, aBuiltIn.Len() ) )
        return FALSE;
    sal_Int32 nTab = rName.Copy( aBuiltIn.Len() ).ToInt32();
    if( (nTab < 1) || (nTab > MAXTAB + 1) )
        return FALSE;
    if( String::CreateFromInt32( nTab ).Len() != (rName.Len() - aBuiltIn.Len()) )
        return FALSE;
    rnSheet = (UINT16)nTab;
    return TRUE;
}

//___________________________________________________________________
// convert to valid calc name

void ScFilterTools::ConvertName( String& rName )
{
	if( !rName.Len() ) return;

	static const sal_Unicode cUnderSc = '_';
	static const sal_Unicode cBlank = ' ';

	String	sNewTable;
	BOOL	bSpace = FALSE;

	for( const sal_Unicode*	pChar = rName.GetBuffer(); *pChar; pChar++ )
	{
		if( !( ScGlobal::pCharClass->isLetterNumeric( rName, pChar - rName.GetBuffer() ) ||
			(*pChar == cUnderSc) || (*pChar == cBlank) ) )
		{
			sNewTable += cUnderSc;
			bSpace = FALSE;
		}
		else if( *pChar == cBlank )
		{
			if( bSpace )
				sNewTable += cUnderSc;
			else
				bSpace = TRUE;
		}
		else
		{
			sNewTable += *pChar;
			bSpace = FALSE;
		}
	}
	rName = sNewTable;
}

//___________________________________________________________________
// string import operations

ByteString ScFilterTools::ReadCString( SvStream& rStrm )
{
	ByteString	aRet;
	sal_Char	c;

	rStrm >> c;
	while( c )
	{
		aRet += c;
		rStrm >> c;
	}

	return aRet;
}

ByteString ScFilterTools::ReadCString( SvStream& rStrm, INT32& rBytesLeft )
{
	ByteString	aRet;
	sal_Char	c;

	rStrm >> c;
	rBytesLeft--;
	while( c )
	{
		aRet += c;
		rStrm >> c;
		rBytesLeft--;
	}

	return aRet;
}

void ScFilterTools::AppendCString(	SvStream& rStrm, ByteString& rString )
{
	sal_Char	c;

	rStrm >> c;
	while( c )
	{
		rString += c;
		rStrm >> c;
	}
}

void ScFilterTools::AppendCString(	SvStream& rStrm, String& rString, CharSet eSrc )
{
	ByteString	aByteString;
	AppendCString( rStrm, aByteString );
	rString += String( aByteString, eSrc );
}

//___________________________________________________________________
// HTML table names -> named range names

#define HTML_DOCNAME		"HTML_all"
#define HTML_TABLESNAME		"HTML_tables"
#define HTML_TABLEINDEX		"HTML_"
#define HTML_TABLENAME		"HTML__"

String ScFilterTools::GetHTMLDocName()
{
	return String( RTL_CONSTASCII_USTRINGPARAM( HTML_DOCNAME ) );
}

String ScFilterTools::GetHTMLTablesName()
{
	return String( RTL_CONSTASCII_USTRINGPARAM( HTML_TABLESNAME ) );
}

String ScFilterTools::GetNameFromHTMLIndex( ULONG nIndex )
{
	String aName( RTL_CONSTASCII_USTRINGPARAM( HTML_TABLEINDEX ) );
	aName += String::CreateFromInt32( (sal_Int32) nIndex );
	return aName;
}

String ScFilterTools::GetNameFromHTMLName( const String& rTabName )
{
	String aName( RTL_CONSTASCII_USTRINGPARAM( HTML_TABLENAME ) );
	aName += rTabName;
	return aName;
}

BOOL ScFilterTools::IsHTMLDocName( const String& rSource )
{
	return rSource.EqualsIgnoreCaseAscii( HTML_DOCNAME );
}

BOOL ScFilterTools::IsHTMLTablesName( const String& rSource )
{
	return rSource.EqualsIgnoreCaseAscii( HTML_TABLESNAME );
}

BOOL ScFilterTools::GetHTMLNameFromName( const String& rSource, String& rName )
{
	rName.Erase();
	if( rSource.EqualsIgnoreCaseAscii( HTML_TABLENAME, 0, sizeof( HTML_TABLENAME ) - 1 ) )
	{
		rName = rSource.Copy( sizeof( HTML_TABLENAME ) - 1 );
		AddQuotes( rName );
	}
	else if( rSource.EqualsIgnoreCaseAscii( HTML_TABLEINDEX, 0, sizeof( HTML_TABLEINDEX ) - 1 ) )
	{
		String aIndex( rSource.Copy( sizeof( HTML_TABLEINDEX ) - 1 ) );
		if( CharClass::isAsciiNumeric( aIndex ) && (aIndex.ToInt32() > 0) )
			rName = aIndex;
	}
	return rName.Len() > 0;
}

#undef HTML_DOCNAME
#undef HTML_TABLESNAME
#undef HTML_TABLEINDEX
#undef HTML_TABLENAME

