/*************************************************************************
 *
 *  $RCSfile: centraldlg.cxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: thb $ $Date: 2001/07/04 13:15:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _TOOLS_DEBUG_HXX //autogen wg. DBG_ASSERT
#include <tools/debug.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen wg. RET_OK
#include <vcl/msgbox.hxx>
#endif
#ifndef _UNOTOOLS_LOCALFILEHELPER_HXX
#include <unotools/localfilehelper.hxx>
#endif

#include <strings.hrc>
#include "sdresid.hxx"
#include "centraldlg.hrc"
#include "centraldlg.hxx"
#include "filedlg.hxx"
#include "options.hxx"


extern void SipShowAboutDlg( Window* pParent );

///////////////////////////////////////////////////////////////////////
// class SipCentralDlg
///////////////////////////////////////////////////////////////////////

SipCentralDlg::SipCentralDlg( Window* pParent, const String& aDefaultURL ) :
	ModalDialog( pParent, SdResId( DLG_CENTRAL ) ),
	m_aFtFile( this, SdResId(FT_FILE) ),
	m_aEdtFile( this, SdResId(EDT_FILE) ),
	m_aBtnBrowse( this, SdResId(BTN_BROWSE) ),
	m_aBtnOk( this, SdResId(BTN_OK) ),
	m_aBtnCancel( this, SdResId(BTN_CANCEL) ),
	m_aBtnMore( this, SdResId(BTN_MORE) ),
	m_aFlPageChg( this, SdResId( FL_PAGECHG ) ),
	m_aRbtChgDoc( this, SdResId( RBT_TIMINGS ) ),
	m_aRbtChgManual( this, SdResId( RBT_CHG_MAN ) ),
	m_aRbtChgSemi( this, SdResId( RBT_CHG_SEMI ) ),
	m_aRbtChgAuto( this, SdResId( RBT_CHG_AUTOM ) ),
	m_aFtSlide( this, SdResId( FT_SLIDE ) ),
	m_aTmfSlide( this, SdResId( TMF_SLIDE ) ),
	m_aCbxEndless( this, SdResId( CBX_ENDLESS ) ),
	m_aFtPause( this, SdResId( FT_PAUSE ) ),
	m_aTmfPause( this, SdResId( TMF_PAUSE ) ),
	m_aCbxAutologo( this, SdResId( CBX_AUTOLOGO ) ),
	m_aFlOptions( this, SdResId( FL_OPTIONS ) ),
	m_aCbxWindowed( this, SdResId( CBX_WINDOWED ) ),
	m_aCbxPointer( this, SdResId( CBX_MOUSEPOINTER ) ),
	m_aCbxPen( this, SdResId( CBX_PEN ) ),
	m_aCbxAnimAllowed( this, SdResId( CBX_ANIMATION_ALLOWED ) ),
	m_aCbxChangePage( this, SdResId( CBX_CHANGE_PAGE ) ),
	m_aCbxAlwaysOnTop( this, SdResId( CBX_ALWAYS_ON_TOP ) ),
	m_aBtnAbout( this, SdResId( BTN_ABOUT ) ),
	m_bMoreShown(sal_False)
{
	FreeResource();

	if( !m_aOptions.GetPresFile().getLength() )
	{
		// use default URL
		SetPathURL(aDefaultURL);	
	}
	else
	{
		// use config value
		SetPathURL(m_aOptions.GetPresFile());	
	}

	m_aCbxWindowed.EnableTriState();
	m_aCbxPointer.EnableTriState();
	m_aCbxPen.EnableTriState();
	m_aCbxAnimAllowed.EnableTriState();
	m_aCbxChangePage.EnableTriState();
	m_aCbxAlwaysOnTop.EnableTriState();
	m_aCbxEndless.EnableTriState();

	m_aRbtChgDoc.Check( m_aOptions.GetPresChange() == 0 );
	m_aRbtChgManual.Check( m_aOptions.GetPresChange() == 1 );
	m_aRbtChgSemi.Check( m_aOptions.GetPresChange() == 2 );
	m_aRbtChgAuto.Check( m_aOptions.GetPresChange() == 3 );

	m_aBtnBrowse.SetClickHdl(LINK(this,SipCentralDlg, BrowseHdl ));
	m_aBtnOk.SetClickHdl(LINK(this,SipCentralDlg, FinishHdl ));
	m_aBtnMore.SetClickHdl(LINK(this,SipCentralDlg, MoreHdl ));
	SetMoreButtonText();
	m_aBtnAbout.SetClickHdl(LINK(this,SipCentralDlg, AboutHdl ));

	m_aFlPageChg.Hide();
	m_aRbtChgDoc.SetClickHdl(LINK(this,SipCentralDlg,PresChgHdl));
	m_aRbtChgManual.SetClickHdl(LINK(this,SipCentralDlg,PresChgHdl));
	m_aRbtChgAuto.SetClickHdl(LINK(this,SipCentralDlg,PresChgHdl));
	m_aRbtChgSemi.SetClickHdl(LINK(this,SipCentralDlg,PresChgHdl));
	m_aCbxEndless.SetClickHdl(LINK(this,SipCentralDlg,PresChgHdl));
	m_aTmfPause.SetModifyHdl( LINK( this, SipCentralDlg, PresChgHdl ) );

	Time aTime;
	aTime.MakeTimeFromMS( m_aOptions.GetPageTimeout() * 1000 );
	m_aTmfSlide.SetFormat( TIMEF_SEC );
	m_aTmfSlide.SetTime( aTime );

	// set cursor in timefield
	Edit *pEdit = m_aTmfSlide.GetField();
	Selection aSel( pEdit->GetMaxTextLen(), pEdit->GetMaxTextLen() );
	pEdit->SetSelection( aSel );

	aTime.MakeTimeFromMS( m_aOptions.GetPauseTimeout() * 1000 );
	m_aTmfPause.SetFormat( TIMEF_SEC );
	m_aTmfPause.SetTime( aTime );

	// set cursor in timefield
	pEdit = m_aTmfPause.GetField();
	aSel = Selection( pEdit->GetMaxTextLen(), pEdit->GetMaxTextLen() );
	pEdit->SetSelection( aSel );

	m_aCbxEndless.SetState( m_aOptions.GetEndless() );
	m_aCbxAutologo.SetState( m_aOptions.GetShowPauseLogo() );

	PresChgHdl( NULL );

	m_aCbxWindowed.SetState( m_aOptions.GetFullScreen() );
	m_aCbxPointer.SetState( m_aOptions.GetMouseVisible() );
	m_aCbxPen.SetState( m_aOptions.GetMouseAsPen() );
	m_aCbxAnimAllowed.SetState( m_aOptions.GetAnimationAllowed() );
	m_aCbxChangePage.SetState( m_aOptions.GetLockedPages() );
	m_aCbxAlwaysOnTop.SetState( m_aOptions.GetAlwaysOnTop() );
}

SipCentralDlg::~SipCentralDlg()
{
	// Update options
	if( m_aRbtChgDoc.IsChecked() )
		m_aOptions.SetPresChange(0);
	else if( m_aRbtChgManual.IsChecked() )
		m_aOptions.SetPresChange(1);
	else if( m_aRbtChgSemi.IsChecked() )
		m_aOptions.SetPresChange(2);
	else if( m_aRbtChgAuto.IsChecked() )
		m_aOptions.SetPresChange(3);

	m_aOptions.SetPageTimeout((UINT32)m_aTmfSlide.GetTime().GetMSFromTime() / 1000);
	m_aOptions.SetEndless(m_aCbxEndless.GetState());

	m_aOptions.SetPauseTimeout((UINT32)m_aTmfPause.GetTime().GetMSFromTime() / 1000);
	m_aOptions.SetShowPauseLogo(m_aCbxAutologo.GetState());

	m_aOptions.SetFullScreen(m_aCbxWindowed.GetState());
	m_aOptions.SetMouseVisible(m_aCbxPointer.GetState());
	m_aOptions.SetMouseAsPen(m_aCbxPen.GetState());
	m_aOptions.SetAnimationAllowed(m_aCbxAnimAllowed.GetState());
	m_aOptions.SetLockedPages(m_aCbxChangePage.GetState());
	m_aOptions.SetAlwaysOnTop(m_aCbxAlwaysOnTop.GetState());
	m_aOptions.SetPresFile(GetPathURL());
}

void SipCentralDlg::SetMoreButtonText()
{
	String aMoreStr( SdResId( STR_MORE ) );

	aMoreStr += String::CreateFromAscii(m_bMoreShown ? " <<" : " >>");
	m_aBtnMore.SetText(aMoreStr);	
}

void SipCentralDlg::SetPathURL(const String& aURLStr)
{
	String			aPath;
	INetURLObject	aURL;
		
	aURL.SetURL(aURLStr);
	::utl::LocalFileHelper::ConvertURLToPhysicalName( aURL.GetMainURL(INetURLObject::NO_DECODE), aPath );
	
	m_aEdtFile.SetText(aPath);	
}

String SipCentralDlg::GetPathURL() const
{
	String			aPath;	
	INetURLObject	aURL;
	
	::utl::LocalFileHelper::ConvertPhysicalNameToURL( m_aEdtFile.GetText(), aPath );
	aURL.SetURL(aPath);

	return aURL.GetMainURL(INetURLObject::NO_DECODE);
}

IMPL_LINK( SipCentralDlg, BrowseHdl, PushButton *, EMPTYARG )
{
	SIPFileDialog	aFileDlg;

	aFileDlg.SetDisplayDirectory(GetPathURL());
	aFileDlg.Execute();
	SetPathURL(aFileDlg.GetPath());

    return 0;
}

IMPL_LINK( SipCentralDlg, FinishHdl, OKButton *, EMPTYARG )
{
	EndDialog(RET_OK);
    return 0;
}

IMPL_LINK( SipCentralDlg, MoreHdl, PushButton *, EMPTYARG )
{
	// toggle state	
	m_bMoreShown = m_bMoreShown	? sal_False : sal_True;
	SetMoreButtonText();

	SetSizePixel(LogicToPixel(Size(MA_DIALOG_WIDTH , m_bMoreShown ? MA_DIALOG_HEIGHT : MA_DIALOG_INITIALHEIGHT), MAP_APPFONT));	

	// otherwise upper pixel visible
	if( m_bMoreShown )
		m_aFlPageChg.Show();
	else
		m_aFlPageChg.Hide();

    return 0;
}

IMPL_LINK( SipCentralDlg, AboutHdl, PushButton *, EMPTYARG )
{
	SipShowAboutDlg( this );
    return 0;
}

IMPL_LINK( SipCentralDlg, PresChgHdl, RadioButton*, pButton )
{
	BOOL bAutomatic = m_aRbtChgAuto.IsChecked();
	BOOL bEndless = m_aCbxEndless.IsChecked();
	BOOL bPause = m_aTmfPause.GetTime().GetMSFromTime() != 0;

	m_aFtSlide.Enable( bAutomatic );
	m_aTmfSlide.Enable( bAutomatic );
//	m_aCbxEndless.Enable( bAutomatic );

	m_aFtPause.Enable( bEndless );
	m_aTmfPause.Enable( bEndless );
	m_aCbxAutologo.Enable( bEndless && bPause );
	return 0;
}

