/*************************************************************************
 *
 *  $RCSfile: viewshel.hxx,v $
 *
 *  $Revision: 1.8 $
 *
 *  last change: $Author: thb $ $Date: 2001/05/29 14:48:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SIP_VIEWSHEL_HXX
#define _SIP_VIEWSHEL_HXX

#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#ifndef _TABBAR_HXX //autogen wg. TabBar
#include <svtools/tabbar.hxx>
#endif
#ifndef _UNOTOOLS_TEMPFILE_HXX
#include <unotools/tempfile.hxx>
#endif
#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif

class FuPoor;
class SdView;
class SdPage;
class SdShowWindow;
class SdrOle2Obj;		// fuer die, die Teile von SVDRAW rausdefiniert haben
class FuSearch;
class ScrollBarBox;
class SdDrawDocShell;
class SdDrawDocument;
class SdClient;
class FuSlideShow;
class ZoomList;
class ScrollBar;
class E3dView;
class SipView;
class Options;
class SdDrawDocShell;

class SdOptionsPrintItem;
class MultiSelection;
class SdShowWindow;
class WorkWindow;

/*************************************************************************
|*
|* Basisklasse zur Verwaltung des Fenster-Interfaces
|*
\************************************************************************/

class SipViewShell
{
 protected:
	// aktives Fenster
	SdShowWindow*		pWindow;
	SdDrawDocument*		pDoc;
	SdDrawDocShell*		pDocShell;
	SotStorageRef		rStorage;
	FuSlideShow*		pFuSlideShow;
	WorkWindow*			pWorkWindow;
	SipView*			pView;
	String				aDocName;
	String				aDocPath;
	String				aPasswd;
	BOOL				bLocked;
	ULONG				nUnlockEvt;
	ULONG				nLockEvt;
	const Options&		rOptions;	

	List				aTempFiles;
	::utl::TempFile		aTempDir;
	Point				aPopupMousePos;
						DECL_LINK( ContextMenuHdl, void* );
						DECL_LINK( ContextMenuSelectHdl, Menu * );
						DECL_LINK( UnlockHdl, void* );
						DECL_LINK( LockHdl, void* );

	BOOL LoadOwn( const String& rPath );
	BOOL LoadXML( const String& rPath );
	BOOL LoadPacked( const String& rPath );

	void DeleteSlideShow( void );

 public:
	 SipViewShell(Window *pParent, const Options& rOptions );
	~SipViewShell();

	SipView*			GetView() const { return pView; }
	void				SetView( SipView* _pView ) { pView = _pView; }

	SdDrawDocument*		GetDoc() const { return pDoc; }
	FuSlideShow*		GetSlideShow() const { return pFuSlideShow; }
	SdPage*				GetActualPage();
	BOOL				IsSlideShowRunning() const { return pFuSlideShow != NULL; }

	SdShowWindow* GetActiveWindow() { return pWindow; }
	void		  SetActiveWindow(SdShowWindow* pWindow);

	const Rectangle& GetAllWindowRect();

								   // Mouse- & Key-Events
	void Paint(const Rectangle& rRect, SdShowWindow* pWin);
	BOOL KeyInput(const KeyEvent& rKEvt, SdShowWindow* pWin);
	void MouseMove(const MouseEvent& rMEvt, SdShowWindow* pWin);
	void MouseButtonUp(const MouseEvent& rMEvt, SdShowWindow* pWin);
	void MouseButtonDown(const MouseEvent& rMEvt, SdShowWindow* pWin);
	void Command(const CommandEvent& rCEvt, SdShowWindow* pWin);

	void OpenSlideShow();
	void StartSlideShow();
	void StopSlideShow();

	BOOL Load( const String& rPath );

	void Resize();
	BOOL Close();

	const String& GetName() const { return aDocName; }
	const String& GetPath() const { return aDocPath; }

	BOOL	isLocked() const { return bLocked; }
	void	Unlock();
	void	Lock();
};



#endif			// _SIP_VIEWSHEL_HXX
