/*************************************************************************
 *
 *  $RCSfile: ProgressHandler.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mh $ $Date: 2000/10/23 16:22:19 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CPPUHELPER_IMPLBASE1_HXX_
#include <cppuhelper/implbase1.hxx>
#endif
#ifndef _COM_SUN_STAR_UCB_XPROGRESSHANDLER_HPP_
#include <com/sun/star/ucb/XProgressHandler.hpp>
#endif
#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif
#include "sdresid.hxx"
#include "strings.hrc"

using namespace ::rtl;
//using namespace ::vos;
using namespace ::com::sun::star;

class ProgressHandler : public ::cppu::WeakAggImplHelper1< ucb::XProgressHandler >
{
private:
	Link aIOProgressLink;

public:
	ProgressHandler( const Link& rLink );

	virtual void SAL_CALL push(const uno::Any& Status) throw( uno::RuntimeException );
	virtual void SAL_CALL update(const uno::Any& Status) throw( uno::RuntimeException );
	virtual void SAL_CALL pop(void) throw( uno::RuntimeException );
};

ProgressHandler::ProgressHandler( const Link& rLink )
: aIOProgressLink( rLink )
{
}

void SAL_CALL ProgressHandler::push(const uno::Any& Status) throw( uno::RuntimeException )
{
}

void SAL_CALL ProgressHandler::update(const uno::Any& Status) throw( uno::RuntimeException )
{
	sal_uInt16 nPercent;
	Status >>= nPercent;
	if( aIOProgressLink.IsSet() )
		aIOProgressLink.Call(&nPercent);
}

void SAL_CALL ProgressHandler::pop(void) throw( uno::RuntimeException )
{
}

uno::Reference< ucb::XProgressHandler > ProgressHandler_createInstance( const Link& rLink )
{
	return new ProgressHandler( rLink );
}

