#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.11 $
#
#   last change: $Author: thb $ $Date: 2001/07/31 12:19:39 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRUNTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRUNTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc..
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************


PRJ=..

PRJNAME=sip
TARGET=soplayer
GEN_HID=TRUE

# --- Settings ---------------------------------------------------

.INCLUDE :  settings.mk

VERINFONAME=verinfo

.IF "$(COM)"=="MSC"
.IF "$(CPU)"=="I"
# use (careful) linker optimizations for Windows
# Note: not specifying "/OPT:NOICF" leads to severe
# trouble in the old RTTI macro code (static functions
# symbols seem to be randomly intermixed)
.IF "$(PRODUCT)"=="full"
LINKFLAGS+=/OPT:REF /OPT:NOICF
.ENDIF
.ENDIF
.ENDIF

# --- Resourcen ----------------------------------------------------

.IF "$(GUI)" == "WNT" || "$(GUI)" == "WIN"
RCFILES=verinfo.rc
.ENDIF


APP1TARGET=soplayer

APP1STDLIBS= \
			$(OSLLIB) \
			$(TOOLSLIB) \
			$(SVLIB) \
			$(VCLLIB) \
			$(UNOLIB) \
			$(VOSLIB) \
			$(SOTLIB) \
			$(TKLIB) \
			$(SVTOOLLIB) \
			$(SVLLIB) \
			$(ONELIB) \
			$(GOODIESLIB)\
			$(SDLLIB) \
			$(SVXLLIB) \
			$(XMLOFFLLIB) \
			$(SALLIB) \
			$(CPPULIB) \
			$(CPPUHELPERLIB) \
			$(UCBHELPERLIB) \
			$(UNOTOOLSLIB) \
			$(COMPHELPERLIB)

.IF "$(USE_NAMESPACE)"!=""
APP1STDLIBS+=$(CPPULIB)
.ENDIF

APP1LIBS=	$(LB)$/view.lib \
			$(LB)$/app.lib \
			$(LB)$/func.lib	\
			$(LB)$/dlg.lib


APP1OBJS = $(OBJ)$/app.obj

APP1DEPN=\
		$(LB)$/view.lib \
		$(LB)$/app.lib \
		$(LB)$/func.lib \
		$(LB)$/dlg.lib	\
		$(SVLIBDEPEND) \
		verinfo.rc

RESLIB1NAME=sop
RESLIB1SRSFILES= $(SRS)$/app.srs\
				 $(SRS)$/idlg.srs \
				 $(SOLARRESDIR)$/sdcore.srs \
				 $(SOLARRESDIR)$/svtools.srs \
				 $(SOLARRESDIR)$/sfx.srs \
				 $(SOLARRESDIR)$/so2.srs \
				 $(SOLARRESDIR)$/basic.srs

RESLIB2NAME=opl
RESLIB2SRSFILES= $(SRS)$/app.srs\
				 $(SRS)$/odlg.srs \
				 $(SOLARRESDIR)$/sdcore.srs \
				 $(SOLARRESDIR)$/svtools.srs \
				 $(SOLARRESDIR)$/sfx.srs \
				 $(SOLARRESDIR)$/so2.srs \
				 $(SOLARRESDIR)$/basic.srs

APP1RES= \
		$(RES)$/$(TARGET).res

APP1RES= \
		$(RES)$/$(RESLIB2NAME).res

.IF "$(GUI)"=="WNT"
APP1ICON=$(SOLARRESDIR)$/icons/100_player.ico
APP1VERINFO=verinfo.rc
.ENDIF

APP1LINKRES=$(MISC)$/$(TARGET).res

.IF "$(depend)" == ""
ALL:    \
	$(SRS)$/hidother.hid\
	ALLTAR
.ENDIF


# ------------------------------------------------------------------------

.INCLUDE :  target.mk

$(SRS)$/hidother.hid: hidother.src
.IF "$(GUI)$(CPU)"=="WNTI"
.IF "$(BUILD_SOSL)"==""
	@+echo NO HIDS!!!!
	@+-mhids hidother.src ..\$(INPATH)$/srs soplayer hidother
.ENDIF
.ELSE
	@echo nix
.ENDIF
