#*************************************************************************
#
#   $RCSfile: unxsols2.mk,v $
#
#   $Revision: 1.5 $
#
#   last change: $Author: hjs $ $Date: 2001/02/02 11:58:57 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
ASM=
AFLAGS=


CDEFS+=-D_PTHREADS -DSYSV -DSUN -DSUN4 -D_REENTRANT -D_POSIX_PTHREAD_SEMANTICS -DSTLPORT_VERSION=321

.IF "$(SOLAR_JAVA)"!=""
JAVADEF=-DSOLAR_JAVA
JAVAFLAGSDEBUG=-g
.IF "$(debug)"==""
JAVA_RUNTIME=-ljava
.ELSE
JAVA_RUNTIME=-ljava_g
.ENDIF
.ENDIF

CC=CC
cc=cc

.IF "$(WARN)"!=""
WARNINGS =
.ELSE
WARNINGS = -w
.ENDIF

CFLAGS=$(PREENVCFLAGS) $(WARNINGS) -c -temp=/tmp $(INCLUDE)
CFLAGSCC=-xCC
CFLAGSCXX=-features=no%altspell,no%localfor

CFLAGSEXCEPTIONS=
CFLAGS_NO_EXCEPTIONS=-noex

CFLAGSOBJGUIST=-KPIC
CFLAGSOBJCUIST=-KPIC
CFLAGSOBJGUIMT=-KPIC
CFLAGSOBJCUIMT=-KPIC
CFLAGSSLOGUIMT=-KPIC
CFLAGSSLOCUIMT=-KPIC
CFLAGSPROF=
CFLAGSDEBUG=-g
CFLAGSDBGUTIL=
CFLAGSOPT=-O
CFLAGSNOOPT=
CFLAGSOUTOBJ=-o

STDOBJVCL=$(L)$/salmain.o

THREADLIB=-lposix4
.IF "$(PURIFY)"!=""
LINK=/usr/local/purify-4.2-solaris2/purify CC
.ELSE
LINK=CC
.ENDIF

#set RPATH to prevent the compiler from setting this to his own libs
LINKFLAGS=-w -PIC -temp=/tmp -R /usr/lib

.IF "$(TARGETTHREAD)"=="MT"
#hack to get libthread.so linked first
LINKFLAGSAPPGUI=-lthread
LINKFLAGSAPPCUI=-lthread
LINKFLAGSSHLGUI=-G -lthread
LINKFLAGSSHLCUI=-G -lthread
.ELSE			# "$(TARGETTHREAD)"=="MT"
LINKFLAGSSHLGUI=-G
LINKFLAGSSHLCUI=-G
.ENDIF			# "$(TARGETTHREAD)"=="MT"

.IF "$(NO_BSYMBOLIC)"==""
.IF "$(PRJNAME)"!="schedule"
#.IF "$(PRJNAME)"!="envtest"
LINKFLAGSSHLGUI+=-Bsymbolic
LINKFLAGSSHLCUI+=-Bsymbolic
#.ENDIF
.ENDIF
.ENDIF				# "$(NO_BSYMBOLIC)"==""

# switches for dynamic and static linking
STATIC		= -Bstatic
DYNAMIC		= -Bdynamic

LINKFLAGSTACK=
LINKFLAGSPROF=
LINKFLAGSDEBUG=
LINKFLAGSOPT=
LINKVERSIONMAPFLAG=-M
APPLINKSTATIC=-Bstatic
APPLINKSHARED=-Bdynamic
APP_LINKTYPE=

# reihenfolge der libs NICHT egal!
STDOBJGUI=
.IF "DBG_UTIL" != ""
STDSLOGUI=#-lpthread
.ELSE
STDSLOGUI=
.ENDIF
STDOBJCUI=
STDSLOCUI=
STDLIBGUIST=-lnsl -lsocket -ldl -lm -lCstd -lCrun
STDLIBCUIST=-Bdynamic -lnsl -lsocket -ldl -lCstd -lCrun 
STDLIBGUIMT=
STDLIBCUIMT=-Bdynamic -lnsl -lsocket -ldl -lCstd -lCrun
STDSHLGUIMT=-lnsl -lsocket -ldl -lm -lCstd -lCrun 
STDSHLCUIMT=-Bdynamic -ldl -lCstd -lCrun 

STDLIBGUIST+=-lXm -lXt -lX11
STDLIBGUIMT+=-lXm -lXt -lX11

LIBMGR=CC
LIBFLAGS=-xar -o 

IMPLIB=
IMPLIBFLAGS=

MAPSYM=
MAPSYMFLAGS=

RC=irc
RCFLAGS=-fo$@ $(RCFILES)
RCLINK=
RCLINKFLAGS=
RCSETVERSION=

DLLPOSTFIX=ss

DLLPRE=lib
DLLPOST=.so

LDUMP=cppfilt /b /n /o /p

CDEFS += -D_PTHREADS  
#CFLAGS += -U_REENTRANT -U_POSIX_PTHREAD_SEMANTICS
CFLAGSCXXSLO += -instances=static
CFLAGSCXXOBJ += -instances=static

LINKFLAGSAPPGUI+= -instances=static
LINKFLAGSSHLGUI+= -instances=static
LINKFLAGSAPPCUI+= -instances=static
LINKFLAGSSHLCUI+= -instances=static

