/*************************************************************************
 *
 *  $RCSfile: tutil.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: sz $ $Date: 2001/05/23 15:01:21 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "tutil.hxx"

// <namespace_tstutl>
namespace tstutl {


// <function_cnvrtPth>
::rtl::OUString cnvrtPth( ::rtl::OString sysPth ) {

    ::rtl::OUString sysPath( ::rtl::OUString::createFromAscii( sysPth.getStr() ) );
    ::rtl::OUString fURL;
	if ( sysPth.indexOf("..") != -1 ) {

        rtl_uString* cururl = 0;
        osl_getProcessWorkingDir( &cururl );
        ::rtl::OUString curURL( cururl );
        ::rtl::OUString curDir;

        ::osl::FileBase::getSystemPathFromFileURL( curURL, curDir );
        ::osl::FileBase::getAbsoluteFileURL( curDir, sysPath, fURL );
        return fURL;
    }

    ::osl::FileBase::getFileURLFromSystemPath( sysPath, fURL );
    return fURL;

} // </function_cnvrtPth>

// <function_getEntriesFromFile>
sal_uInt32 getEntriesFromFile( sal_Char* fName,
                                            vector< sal_Char* >& entries ) {
    oslFileHandle inFile;
    rtl_uString* sysPth = 0;
    rtl_uString* fURL = 0;
    rtl_uString_newFromAscii( &sysPth, fName );
    osl_getFileURLFromSystemPath( sysPth, &fURL );

    if ( osl_openFile( fURL, &inFile, osl_File_OpenFlag_Read )
                                                        == osl_File_E_None ) {
        while ( ! isEOF( inFile ) ) {
            sal_Sequence* pSeq = 0;
            osl_readLine( inFile, &pSeq );
            if ( ! pSeq->nElements || pSeq->elements[0] == '#' ) {
                continue;
            }
            sal_Int32 i;
            sal_Char* pEnt = new sal_Char[ pSeq->nElements+1 ];
            sal_Char* bsPtr = pSeq->elements;
            for ( i=0; i < pSeq->nElements; i++ ) {
                pEnt[i] = bsPtr[i];
            }
            pEnt[pSeq->nElements] = '\0';
            entries.push_back( pEnt );
        }
    }
    return ( entries.size() );

} // </function_getEntriesFromFile>

sal_Bool isEOF( oslFileHandle file ) {

    sal_uInt64 curPos;
    sal_uInt64 fSize;

    // save current filepointer position
    osl_getFilePos( file, &curPos );

    // set filepointer to end of file
    osl_setFilePos( file, osl_Pos_End, 0 );

    // store filepointer position in fSize
    osl_getFilePos( file, &fSize );

    // set filepointer position to it's origin pos
    osl_setFilePos( file, osl_Pos_Absolut, curPos );

    return( curPos == fSize );
}

// <function_cpy>
sal_Char* cpy( sal_Char** dest, const sal_Char* src ) {

    *dest = new sal_Char[ ln(src)+1 ];
    // set pointer
    sal_Char* pdest = *dest;
    const sal_Char* psrc = src;

    // copy string by char
    while( *pdest++ = *psrc++ );

    return ( *dest );

} // </function_cpy>

// <function_cat>
sal_Char* cat( const sal_Char* str1, const sal_Char* str2 ) {

    // allocate memory for destination string
    sal_Char* dest = new sal_Char[ ln(str1)+ln(str2)+1 ];

    // set pointers
    sal_Char* pdest = dest;
    const sal_Char* psrc = str1;

    // copy string1 by char to dest
    while( *pdest++ = *psrc++ );
    pdest--;
    psrc = str2;
    while( *pdest++ = *psrc++ );

    return ( dest );

} // </function_cat>

// <function_ln>
sal_uInt32 ln( const sal_Char* str ) {

    sal_uInt32 len = 0;
    const sal_Char* ptr = str;

    if( ptr ) {
        while( *ptr++ ) len++;
    }

    return(len);
} // <function_ln>

} // </namespace_tstutl>

