/*************************************************************************
 *
 *  $RCSfile: rapofflinedbadapter.hxx,v $
 *
 *  $Revision: 1.1 $
 *
 *  last change: $Author: sb $ $Date: 2001/06/07 12:58:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef INCLUDED_UCB_RAPOFFLINEDBADAPTER_HXX
#define INCLUDED_UCB_RAPOFFLINEDBADAPTER_HXX

#ifndef _COM_SUN_STAR_SYNC_XDBADAPTER_HPP_
#include "com/sun/star/sync/XDBAdapter.hpp"
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include "com/sun/star/uno/Reference.hxx"
#endif
#ifndef _CPPUHELPER_IMPLBASE1_HXX_
#include "cppuhelper/implbase1.hxx"
#endif
#ifndef _RTL_REF_HXX_
#include "rtl/ref.hxx"
#endif

namespace com { namespace sun { namespace star {
    namespace lang { class XMultiServiceFactory; }
} } }
namespace ucprmt { namespace offline { class StorageNodeContainer; } }

namespace ucprmt { namespace offline {

class DBAdapter:
    public cppu::WeakImplHelper1< com::sun::star::sync::XDBAdapter >
{
public:
    DBAdapter(com::sun::star::uno::Reference<
                      com::sun::star::lang::XMultiServiceFactory > const &
                  rServiceFactory,
              rtl::Reference< StorageNodeContainer > const & rNodes);

    virtual ~DBAdapter();

    virtual sal_Bool SAL_CALL dbaOpen(rtl::OUString const & rUserId)
        throw (com::sun::star::uno::RuntimeException);

    virtual com::sun::star::sync::IndexContainable SAL_CALL
    dbaGetEntry(rtl::OUString const & rId)
        throw (com::sun::star::uno::RuntimeException);

    virtual void SAL_CALL
    dbaAddEntry(com::sun::star::sync::IndexContainable const & rContainable)
        throw (com::sun::star::uno::RuntimeException);

    virtual void SAL_CALL
    dbaUpdateEntry(
        com::sun::star::sync::IndexContainable const & rContainable)
        throw (com::sun::star::uno::RuntimeException);

    virtual void SAL_CALL dbaDeleteEntry(rtl::OUString const & rId)
        throw (com::sun::star::uno::RuntimeException);

    virtual void SAL_CALL dbaClose()
        throw (com::sun::star::uno::RuntimeException);

    virtual
    com::sun::star::uno::Sequence< com::sun::star::sync::Changes > SAL_CALL
    dbaGetChanged()
        throw (com::sun::star::uno::RuntimeException);

    virtual com::sun::star::uno::Sequence< rtl::OUString > SAL_CALL
    dbaGetAdded()
        throw (com::sun::star::uno::RuntimeException);

    virtual com::sun::star::uno::Sequence< rtl::OUString > SAL_CALL
    dbaGetDeleted()
        throw (com::sun::star::uno::RuntimeException);

private:
    com::sun::star::uno::Reference<
            com::sun::star::lang::XMultiServiceFactory >
        m_xServiceFactory;
    rtl::Reference< StorageNodeContainer > m_xNodes;
};

} }

#endif // INCLUDED_UCB_RAPOFFLINEDBADAPTER_HXX
