*** orig/dmake/dbug/malloc/realloc.c	Sat Sep  9 18:36:36 2000
--- modified/dmake/dbug/malloc/realloc.c	Sat Sep  9 18:36:36 2000
***************
*** 18,68 ****
   *
   * Narrative:	verify pointer is within malloc region
   *		obtain mlist pointer from cptr
   *		verify magic number is correct
   *		verify inuse flag is set
   *		verify connection to adjoining segments is correct
   *		save requested size
   *		round-up size to appropriate boundry
   *		IF size is bigger than what is in this segment
   *		    try to join next segment to this segment
   *		IF size is less than what is is this segment
   *		    determine leftover amount of space
   *		ELSE
   *		    allocate new segment of size bites
   *		    IF allocation failed
   *		        return NULL
   *		    copy previous data to new segment
   *		    free previous segment
   *		    return new pointer
   *		split of extra space in this segment (if any)
   *		clear bytes beyound what they had before
   *		return pointer to data 
   */
  #ifndef lint
  static
! char rcs_hdr[] = "$Id: realloc.c,v 1.1.1.1 1997/07/15 16:02:26 dvadura Exp $";
  #endif
  
  char *
  realloc(cptr,size)
  	char			* cptr;
  	unsigned int		  size;
  {
  	void			  free();
  	char			* func = "realloc";
  	int			  i;
  	char			* malloc();
  	extern int		  malloc_checking;
  	extern struct mlist 	* malloc_end;
  	extern int		  malloc_errno;
  	extern char		* malloc_data_end;
  	extern char		* malloc_data_start;
  	void			  malloc_join();
  	void			  malloc_memset();
  	void			  malloc_split();
  	char			* memcpy();
  	char			* new_cptr;
  	struct mlist		* ptr;
  	int			  r_size;
  
  	/*
--- 18,68 ----
   *
   * Narrative:	verify pointer is within malloc region
   *		obtain mlist pointer from cptr
   *		verify magic number is correct
   *		verify inuse flag is set
   *		verify connection to adjoining segments is correct
   *		save requested size
   *		round-up size to appropriate boundry
   *		IF size is bigger than what is in this segment
   *		    try to join next segment to this segment
   *		IF size is less than what is is this segment
   *		    determine leftover amount of space
   *		ELSE
   *		    allocate new segment of size bites
   *		    IF allocation failed
   *		        return NULL
   *		    copy previous data to new segment
   *		    free previous segment
   *		    return new pointer
   *		split of extra space in this segment (if any)
   *		clear bytes beyound what they had before
   *		return pointer to data 
   */
  #ifndef lint
  static
! char rcs_hdr[] = "$Id: realloc.c,v 1.1.1.1 1997/09/22 14:51:11 hjs Exp $";
  #endif
  
  char *
  realloc(cptr,size)
  	char			* cptr;
  	unsigned int		  size;
  {
  	void			  free();
  	char			* func = "realloc";
  	int			  i;
  	char			* malloc();
  	extern int		  malloc_checking;
  	extern struct mlist 	* malloc_end;
  	extern int		  malloc_errno;
  	extern char		* malloc_data_end;
  	extern char		* malloc_data_start;
  	void			  malloc_join();
  	void			  malloc_memset();
  	void			  malloc_split();
  	char			* memcpy();
  	char			* new_cptr;
  	struct mlist		* ptr;
  	int			  r_size;
  
  	/*
***************
*** 158,207 ****
--- 158,210 ----
  	{
  		i = ptr->r_size;
  	}
  	else
  	{
  		i = r_size;
  	}
  
  	ptr->r_size = r_size;
  
  	/*
  	 * split off extra free space at end of this segment, if possible...
  	 */
  
  	malloc_split(ptr);
  
  	malloc_memset( ptr->data+i, M_FILL, (int) (ptr->s.size - i));
  		
  	return(ptr->data);
  
  } /* realloc(... */
  
  
  /*
   * $Log: realloc.c,v $
+  * Revision 1.1.1.1  1997/09/22 14:51:11  hjs
+  * dmake 4.1 orginal sourcen
+  *
   * Revision 1.1.1.1  1997/07/15 16:02:26  dvadura
   * dmake gold 4.1.00 initial import
   *
   * Revision 1.1.1.1  1996/10/27 07:30:14  dvadura
   * Dmake 4.1 Initial Import
   *
   * Revision 1.1.1.1  1996/10/24 05:33:14  dvadura
   * Initial import for final release of dmake 4.1
   *
   * Revision 1.1  1994/10/06  17:43:17  dvadura
   * dmake Release Version 4.0, Initial revision
   *
   * Revision 1.1  1994/10/06  03:45:26  dvadura
   * dmake Release Version 4.0, Initial revision
   *
   * Revision 1.1  1992/01/24  03:29:11  dvadura
   * dmake Version 3.8, Initial revision
   *
   * Revision 1.8  90/08/29  21:22:52  cpcahil
   * miscellaneous lint fixes
   * 
   * Revision 1.7  90/05/11  00:13:10  cpcahil
   * added copyright statment
   * 
   * Revision 1.6  90/02/25  11:01:20  cpcahil
