*** orig/win32_60/inc/pgpEncode.h	Wed Aug 30 12:08:12 2000
--- modified/win32_60/inc/pgpEncode.h	Wed Aug 30 12:08:12 2000
***************
*** 1,35 ****
  /*____________________________________________________________________________
  	pgpEncode.h
  	
  	Copyright (C) 1997 Network Associates, Inc. and its affiliates.
  	All rights reserved.
  	
  	This file contains the prototypes for functions which encode/decode files
  	and buffers.
  
! 	$Id: pgpEncode.h,v 1.101.10.1 1998/11/12 03:23:32 heller Exp $
  ____________________________________________________________________________*/
  
  #ifndef Included_pgpEncode_h	/* [ */
  #define Included_pgpEncode_h
  
  #include "pgpPubTypes.h"
  #include "pgpTLS.h"
  
  #if PRAGMA_ALIGN_SUPPORTED
  #pragma options align=mac68k
  #endif
  
  /*
   * The PGPEvent structure is used to notify clients of the encode API of
   * various events.
   */
  
  /* PGP Event types */
  
  enum PGPEventType_
  {
  	kPGPEvent_NullEvent			=  0,		/* Nothing happened */
  	kPGPEvent_InitialEvent		=  1,		/* Final event */
  	kPGPEvent_FinalEvent		=  2,		/* Final event */
  	kPGPEvent_ErrorEvent		=  3,		/* An error occurred */
--- 1,35 ----
  /*____________________________________________________________________________
  	pgpEncode.h
  	
  	Copyright (C) 1997 Network Associates, Inc. and its affiliates.
  	All rights reserved.
  	
  	This file contains the prototypes for functions which encode/decode files
  	and buffers.
  
! 	$Id: pgpEncode.h,v 1.1 2000/07/28 15:52:08 mhu Exp $
  ____________________________________________________________________________*/
  
  #ifndef Included_pgpEncode_h	/* [ */
  #define Included_pgpEncode_h
  
  #include "pgpPubTypes.h"
  #include "pgpTLS.h"
  
  #if PRAGMA_ALIGN_SUPPORTED
  #pragma options align=mac68k
  #endif
  
  /*
   * The PGPEvent structure is used to notify clients of the encode API of
   * various events.
   */
  
  /* PGP Event types */
  
  enum PGPEventType_
  {
  	kPGPEvent_NullEvent			=  0,		/* Nothing happened */
  	kPGPEvent_InitialEvent		=  1,		/* Final event */
  	kPGPEvent_FinalEvent		=  2,		/* Final event */
  	kPGPEvent_ErrorEvent		=  3,		/* An error occurred */
***************
*** 241,289 ****
  {
  	PGPVersion				 version;		/* Version of event structure */
  	struct PGPEvent_		*nextEvent;		/* Allow lists of events */
  	PGPJobRef				 job;			/* Associated with what job */
  	PGPEventType			 type;			/* Type of event */
  	PGPEventData			 data;			/* Event specific data */
  };
  typedef struct PGPEvent PGPEvent;
  
  
  #if PRAGMA_ALIGN_SUPPORTED
  #pragma options align=reset
  #endif
  
  PGP_BEGIN_C_DECLARATIONS
  
  #if PRAGMA_IMPORT_SUPPORTED
  #pragma import on
  #endif
  
  /*
  **	Functions to encode and decode. The variable parameters are one or more
  **	PGPOptionListRef's which describe the inputs, outputs, and options.
  */
  
! PGPError 		PGPEncode(PGPContextRef context,
  							PGPOptionListRef firstOption, ...);
! PGPError 		PGPDecode(PGPContextRef context,
  							PGPOptionListRef firstOption, ...);
  
! PGPError 		PGPAddJobOptions(PGPJobRef job,
  							PGPOptionListRef firstOption, ...);
  
  #if PRAGMA_IMPORT_SUPPORTED
  #pragma import reset
  #endif
  PGP_END_C_DECLARATIONS
  
  #endif /* ] Included_pgpEncode_h */
  
  
  /*__Editor_settings____
  
  	Local Variables:
  	tab-width: 4
  	End:
  	vi: ts=4 sw=4
  	vim: si
  _____________________*/
--- 241,289 ----
  {
  	PGPVersion				 version;		/* Version of event structure */
  	struct PGPEvent_		*nextEvent;		/* Allow lists of events */
  	PGPJobRef				 job;			/* Associated with what job */
  	PGPEventType			 type;			/* Type of event */
  	PGPEventData			 data;			/* Event specific data */
  };
  typedef struct PGPEvent PGPEvent;
  
  
  #if PRAGMA_ALIGN_SUPPORTED
  #pragma options align=reset
  #endif
  
  PGP_BEGIN_C_DECLARATIONS
  
  #if PRAGMA_IMPORT_SUPPORTED
  #pragma import on
  #endif
  
  /*
  **	Functions to encode and decode. The variable parameters are one or more
  **	PGPOptionListRef's which describe the inputs, outputs, and options.
  */
  
! PGPError 		PGPAPI PGPEncode(PGPContextRef context,
  							PGPOptionListRef firstOption, ...);
! PGPError 		PGPAPI PGPDecode(PGPContextRef context,
  							PGPOptionListRef firstOption, ...);
  
! PGPError 		PGPAPI PGPAddJobOptions(PGPJobRef job,
  							PGPOptionListRef firstOption, ...);
  
  #if PRAGMA_IMPORT_SUPPORTED
  #pragma import reset
  #endif
  PGP_END_C_DECLARATIONS
  
  #endif /* ] Included_pgpEncode_h */
  
  
  /*__Editor_settings____
  
  	Local Variables:
  	tab-width: 4
  	End:
  	vi: ts=4 sw=4
  	vim: si
  _____________________*/
