*** orig/zlib-1.1.3/inffast.c	Sat Aug 26 22:17:46 2000
--- modified/zlib-1.1.3/inffast.c	Sat Aug 26 22:17:46 2000
***************
*** 1,46 ****
  /* inffast.c -- process literals and length/distance pairs fast
!  * Copyright (C) 1995-1998 Mark Adler
   * For conditions of distribution and use, see copyright notice in zlib.h 
   */
  
  #include "zutil.h"
  #include "inftrees.h"
  #include "infblock.h"
  #include "infcodes.h"
  #include "infutil.h"
  #include "inffast.h"
  
  struct inflate_codes_state {int dummy;}; /* for buggy compilers */
  
  /* simplify the use of the inflate_huft type with some defines */
  #define exop word.what.Exop
  #define bits word.what.Bits
  
  /* macros for bit input with no checking and for returning unused bytes */
  #define GRABBITS(j) {while(k<(j)){b|=((uLong)NEXTBYTE)<<k;k+=8;}}
! #define UNGRAB {c=z->avail_in-n;c=(k>>3)<c?k>>3:c;n+=c;p-=c;k-=c<<3;}
  
  /* Called with number of bytes left to write in window at least 258
     (the maximum string length) and number of input bytes available
     at least ten.  The ten bytes are six bytes for the longest length/
     distance pair plus four bytes for overloading the bit buffer. */
  
  int inflate_fast(bl, bd, tl, td, s, z)
  uInt bl, bd;
  inflate_huft *tl;
  inflate_huft *td; /* need separate declaration for Borland C++ */
  inflate_blocks_statef *s;
  z_streamp z;
  {
    inflate_huft *t;      /* temporary pointer */
    uInt e;               /* extra bits or operation */
    uLong b;              /* bit buffer */
    uInt k;               /* bits in bit buffer */
    Bytef *p;             /* input data pointer */
    uInt n;               /* bytes available there */
    Bytef *q;             /* output window write pointer */
    uInt m;               /* bytes to end of window or read pointer */
    uInt ml;              /* mask for literal/length tree */
    uInt md;              /* mask for distance tree */
    uInt c;               /* bytes to copy */
    uInt d;               /* distance back to copy from */
--- 1,48 ----
  /* inffast.c -- process literals and length/distance pairs fast
!  * Copyright (C) 1995-1996 Mark Adler
   * For conditions of distribution and use, see copyright notice in zlib.h 
   */
  
  #include "zutil.h"
  #include "inftrees.h"
  #include "infblock.h"
  #include "infcodes.h"
  #include "infutil.h"
  #include "inffast.h"
  
  struct inflate_codes_state {int dummy;}; /* for buggy compilers */
  
  /* simplify the use of the inflate_huft type with some defines */
+ #define base more.Base
+ #define next more.Next
  #define exop word.what.Exop
  #define bits word.what.Bits
  
  /* macros for bit input with no checking and for returning unused bytes */
  #define GRABBITS(j) {while(k<(j)){b|=((uLong)NEXTBYTE)<<k;k+=8;}}
! #define UNGRAB {n+=(c=k>>3);p-=c;k&=7;}
  
  /* Called with number of bytes left to write in window at least 258
     (the maximum string length) and number of input bytes available
     at least ten.  The ten bytes are six bytes for the longest length/
     distance pair plus four bytes for overloading the bit buffer. */
  
  int inflate_fast(bl, bd, tl, td, s, z)
  uInt bl, bd;
  inflate_huft *tl;
  inflate_huft *td; /* need separate declaration for Borland C++ */
  inflate_blocks_statef *s;
  z_streamp z;
  {
    inflate_huft *t;      /* temporary pointer */
    uInt e;               /* extra bits or operation */
    uLong b;              /* bit buffer */
    uInt k;               /* bits in bit buffer */
    Bytef *p;             /* input data pointer */
    uInt n;               /* bytes available there */
    Bytef *q;             /* output window write pointer */
    uInt m;               /* bytes to end of window or read pointer */
    uInt ml;              /* mask for literal/length tree */
    uInt md;              /* mask for distance tree */
    uInt c;               /* bytes to copy */
    uInt d;               /* distance back to copy from */
***************
*** 96,163 ****
              if ((uInt)(q - s->window) >= d)     /* offset before dest */
              {                                   /*  just copy */
                r = q - d;
                *q++ = *r++;  c--;        /* minimum count is three, */
                *q++ = *r++;  c--;        /*  so unroll loop a little */
              }
              else                        /* else offset after destination */
              {
                e = d - (uInt)(q - s->window); /* bytes from offset to end */
                r = s->end - e;           /* pointer to offset */
                if (c > e)                /* if source crosses, */
                {
                  c -= e;                 /* copy to end of window */
                  do {
                    *q++ = *r++;
                  } while (--e);
                  r = s->window;          /* copy rest from start of window */
                }
              }
              do {                        /* copy all or what's left */
                *q++ = *r++;
              } while (--c);
              break;
            }
            else if ((e & 64) == 0)
!           {
!             t += t->base;
!             e = (t += ((uInt)b & inflate_mask[e]))->exop;
!           }
            else
            {
              z->msg = (char*)"invalid distance code";
              UNGRAB
              UPDATE
              return Z_DATA_ERROR;
            }
          } while (1);
          break;
        }
        if ((e & 64) == 0)
        {
!         t += t->base;
!         if ((e = (t += ((uInt)b & inflate_mask[e]))->exop) == 0)
          {
            DUMPBITS(t->bits)
            Tracevv((stderr, t->base >= 0x20 && t->base < 0x7f ?
                      "inflate:         * literal '%c'\n" :
                      "inflate:         * literal 0x%02x\n", t->base));
            *q++ = (Byte)t->base;
            m--;
            break;
          }
        }
        else if (e & 32)
        {
          Tracevv((stderr, "inflate:         * end of block\n"));
          UNGRAB
          UPDATE
          return Z_STREAM_END;
        }
        else
        {
          z->msg = (char*)"invalid literal/length code";
          UNGRAB
          UPDATE
          return Z_DATA_ERROR;
        }
      } while (1);
--- 98,161 ----
              if ((uInt)(q - s->window) >= d)     /* offset before dest */
              {                                   /*  just copy */
                r = q - d;
                *q++ = *r++;  c--;        /* minimum count is three, */
                *q++ = *r++;  c--;        /*  so unroll loop a little */
              }
              else                        /* else offset after destination */
              {
                e = d - (uInt)(q - s->window); /* bytes from offset to end */
                r = s->end - e;           /* pointer to offset */
                if (c > e)                /* if source crosses, */
                {
                  c -= e;                 /* copy to end of window */
                  do {
                    *q++ = *r++;
                  } while (--e);
                  r = s->window;          /* copy rest from start of window */
                }
              }
              do {                        /* copy all or what's left */
                *q++ = *r++;
              } while (--c);
              break;
            }
            else if ((e & 64) == 0)
!             e = (t = t->next + ((uInt)b & inflate_mask[e]))->exop;
            else
            {
              z->msg = (char*)"invalid distance code";
              UNGRAB
              UPDATE
              return Z_DATA_ERROR;
            }
          } while (1);
          break;
        }
        if ((e & 64) == 0)
        {
!         if ((e = (t = t->next + ((uInt)b & inflate_mask[e]))->exop) == 0)
          {
            DUMPBITS(t->bits)
            Tracevv((stderr, t->base >= 0x20 && t->base < 0x7f ?
                      "inflate:         * literal '%c'\n" :
                      "inflate:         * literal 0x%02x\n", t->base));
            *q++ = (Byte)t->base;
            m--;
            break;
          }
        }
        else if (e & 32)
        {
          Tracevv((stderr, "inflate:         * end of block\n"));
          UNGRAB
          UPDATE
          return Z_STREAM_END;
        }
        else
        {
          z->msg = (char*)"invalid literal/length code";
          UNGRAB
          UPDATE
          return Z_DATA_ERROR;
        }
      } while (1);
